﻿package {
	import flash.net.*;
	import flash.events.*;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.utils;
	public class Aicc_Class extends Sprite {
		
		var AICC_Connected = false;
		var startTime:Object ;
		var lmsAiccVersion:String = "3.0";
		var delimiter :String= "%0D%0A";
		var equalsCode :String= "=";
		var aiccCommand :String= "";
		var lmsCommandInProgress :Boolean= false;
		var exitAfterPutparam :Boolean= false;
		var AICC_Core :Array= new Array();

		var AICC_Core_Lesson:Array = new Array();
		var aicc_core_putvalues:Array = ["lesson_status", "score", "lesson_location", "time"];
		var aicc_corelesson_putvalues = [];
		var lmsSend:URLRequest = new URLRequest();//= new LoadVars();
		var lmsReceive:URLRequest = new URLRequest();//= new LoadVars();
							
				public function Aicc_Class(){
					
					
							//AICC_Connected = false;
							startTime = getTimer() 
							/*
							lmsAiccVersion = "3.0";
							delimiter = "%0D%0A";
							equalsCode = "=";
							aiccCommand = "";
							lmsCommandInProgress = false;
							exitAfterPutparam = false;
							AICC_Core = new Array();
							*/
							lmsReceive.addEventListener(Event.COMPLETE, lmsReceiveEvent)
							AICC_Core.student_id = "";
							AICC_Core.student_name = "";
							AICC_Core.course_id = "";
							AICC_Core.lesson_location = "";
							AICC_Core.lesson_status = "";
							AICC_Core.score = "";
							AICC_Core.time = "";
							AICC_Core.credit = "";

							//AICC_Core_Lesson = new Array();
							aicc_core_putvalues = ["lesson_status", "score", "lesson_location", "time"];
							aicc_corelesson_putvalues = [];
							
							
							if (fAiccUrl && fAiccUrl.length > 2)
							{
								initAiccConnection();
							}
							else
							{
								//gotoAndPlay("loadInfo");///pinding
							} // end else if
					
					
					
					}
				function initAiccConnection()
				{
					if (!fAiccUrl || fAiccUrl.length < 1)
					{
						CGlobal.islDebug("AICC URL not found by WBT");
					}
					else if (!fAiccSid|| fAiccSid.length < 1)
					{
						CGlobal.islDebug("AICC SID not found by WBT");
					}
					else
					{
						getParam();
					} // end else if
				} // End of the function
				
				
				function getParam()
				{
					if (lmsCommandInProgress == false)
					{
						lmsCommandInProgress = true;
						sendCommandToLMS("getparam", "");
					}
					else
					{
						CGlobal.islDebug("Warning. Attempting to execute a getparam command while a command is currently executing, " + aiccCommand);
					} // end else if
				} // End of the function
				
				
				function putParam()
				{
					if (AICC_Connected)
					{
						var _loc1 = buildAiccData();
						sendCommandToLMS("putparam", _loc1);
					} // end if
				} // End of the function
				
				function sendCommandToLMS(islSendCommand, islSendData)
				{
					if (islSendCommand != undefined)
					{
						aiccCommand = islSendCommand;
						var _loc2 = fAiccUrl + "?command=" + islSendCommand + "&version=" + lmsAiccVersion + "&session_id=" + fAiccSid + "&aicc_data=" + islSendData;
						lmsSend.sendAndLoad(_loc2, lmsReceive, "GET");
					} // end if
				} // End of the function
				
				
				public function setAiccCoreValue(element, value)
				{
					CGlobal.islDebug("[[SET Core Value]] " + element + ": " + value);
					element = element.toLowerCase();
					AICC_Core[element] = value;
				} // End of the function
				
				
				
				public function getAiccCoreValue(element)
				{
					CGlobal.islDebug("[[GET Core Value]] " + element + ": " + AICC_Core[element]);
					return (AICC_Core[element]);
				} // End of the function
				
				
				
				public function setAiccCoreLessonValue(element, value)
				{
					CGlobal.islDebug("[[SET Core Lesson]] " + element + ": " + value);
					element = element.toLowerCase();
					AICC_Core_Lesson[element] = value;
					if (searchArray(aicc_corelesson_putvalues, element) == -1)
					{
						aicc_corelesson_putvalues.push(element);
					} // end if
				} // End of the function
				
				
				
				
				public function getAiccCoreLessonValue(element)
				{
					CGlobal.islDebug("[[GET Core Lesson]] " + element + ": " + AICC_Core_Lesson[element]);
					return (AICC_Core_Lesson[element]);
				} // End of the function
				
				
				
				public function passAiccStage()
				{
					//gotoAndPlay("loadInfo");/// pinding
				} // End of the function
				
				
				
				function parseLMSResponse(rString)
				{
					lmsCommandInProgress = false;
					if (aiccCommand == "putparam")
					{
						lmsCommandInProgress = false;
						if (exitAfterPutparam == true)
						{
							exitAfterPutparam = false;
							exitAU();
						} // end if
					}
					else if (aiccCommand == "exitau")
					{
						AICC_Connected = false;
						controlled_AICC_exit();
					}
					else if (aiccCommand == "getparam")
					{
						debugger_mc.aicc_text.htmlText = rString;
						var _loc6 = rString.split("\n");
						for (var _loc3 = 0; _loc3 < _loc6.length; ++_loc3)
						{
							var _loc1 = _loc6[_loc3].split("=");
							_loc1[0] = _loc1[0].toLowerCase();
							switch (_loc1[0])
							{
								case "student_id":
								{
									setAiccCoreValue(_loc1[0], _loc1[1].split("\r")[0]);
									break;
								} 
								case "student_name":
								{
									setAiccCoreValue(_loc1[0], _loc1[1].split("\r")[0]);
									break;
								} 
								case "lesson_location":
								{
									setAiccCoreValue(_loc1[0], _loc1[1].split("\r")[0]);
									break;
								} 
								case "lesson_status":
								{
									setAiccCoreValue(_loc1[0], _loc1[1].split("\r")[0]);
									CompletedStatus = _loc1[1].split("\r")[0];
									break;
								} 
								case "score":
								{
									setAiccCoreValue(_loc1[0], _loc1[1].split("\r")[0]);
									CompletedScore = _loc1[1].split("\r")[0];
									break;
								} 
								case "time":
								{
									setAiccCoreValue(_loc1[0], _loc1[1].split("\r")[0]);
									break;
								} 
								case "credit":
								{
									setAiccCoreValue(_loc1[0], _loc1[1].split("\r")[0]);
									break;
								} 
							} // End of switch
						} // end of for
						if (rString.toLowerCase().indexOf("[core_lesson]") > -1)
						{
							if (rString.toLowerCase().indexOf("[core_vendor]") > -1)
							{
								endPoint = rString.toLowerCase().indexOf("[core_vendor]");
							}
							else if (rString.toLowerCase().indexOf("[student_data]") > -1)
							{
								endPoint = rString.toLowerCase().indexOf("[student_data]");
							}
							else
							{
								endPoint = rString.length;
							} // end else if
							var _loc9 = rString.substring(rString.toLowerCase().indexOf("[core_lesson]"), endPoint);
							var _loc5 = _loc9.split("\n");
							CGlobal.islAppRoot.courseTrackingString = "";
							for (var _loc2 = 0; _loc2 < _loc5.length; ++_loc2)
							{
								if (_loc5[_loc2].indexOf("=") > -1)
								{
									var _loc4 = _loc5[_loc2].split("=");
									setAiccCoreLessonValue(_loc4[0], _loc4[1].split("\r")[0]);
								} // end if
							} // end of for
						}
						else
						{
							CGlobal.islDebug("No [core_lesson] found");
						} // end else if
						if (getAiccCoreValue("lesson_status").toLowerCase().charAt(0) == "n")
						{
							setAiccCoreValue("lesson_status", "i");
						} // end if
						CGlobal.islAppRoot.bookmarkString = getAiccCoreValue("lesson_location");
						for (var _loc8 in AICC_Core_Lesson)
						{
							if (AICC_Core_Lesson[_loc8].length > 0)
							{
								CGlobal.islAppRoot[_loc8] = AICC_Core_Lesson[_loc8];
							} // end if
						} // end of for...in
						CGlobal.islAppRoot.trackingStringsList = aicc_corelesson_putvalues;
						if (AICC_Connected == false)
						{
							AICC_Connected = true;
							passAiccStage();
						} // end if
						lmsCommandInProgress = false;
					}
					else
					{
						CGlobal.islDebug("Warning. After getting LMS response, the aicc command is unidentified");
					} // end else if
					lmsCommandInProgress = false;
				} // End of the function
				
				
				
				function buildAiccData()
				{
					AICC_Core.time = getCourseTime();
					var _loc2 = "[core]" + delimiter;
					for (var _loc1:int = 0; _loc1 < aicc_core_putvalues.length; ++_loc1)
					{
						_loc2 = _loc2 + (aicc_core_putvalues[_loc1] + equalsCode + AICC_Core[aicc_core_putvalues[_loc1]] + delimiter);
					} // end of for
					_loc2 = _loc2 + ("[core_vendor]" + delimiter);
					_loc2 = _loc2 + ("[core_lesson]" + delimiter);
					for (var _loc11:int = 0; _loc11 < aicc_corelesson_putvalues.length; ++_loc11)
					{
						_loc2 = _loc2 + (aicc_corelesson_putvalues[_loc11] + equalsCode + AICC_Core_Lesson[aicc_corelesson_putvalues[_loc11]] + delimiter);
					} // end of for
					debugger_mc.suspend_text.htmlText = _loc2;
					return (_loc2);
				} // End of the function
				
				
				
				public function exitAU()
				{
					if (AICC_Connected)
					{
						lmsCommandInProgress = true;
						sendCommandToLMS("exitau", "");
					} // end if
				} // End of the function
				
				
				
				
				public function getCourseTime()
				{
					var _loc4 = (getTimer() - startTime) / 1000;
					var _loc1 = int(_loc4 / 3600);
					var _loc5 = int(_loc4 - _loc1 * 3600);
					var _loc2 = int(_loc5 / 60);
					var _loc3 = _loc5 - _loc2 * 60;
					_loc1 = _loc1 < 10 ? ("0" + _loc1) : (_loc1);
					_loc2 = _loc2 < 10 ? ("0" + _loc2) : (_loc2);
					_loc3 = _loc3 < 10 ? ("0" + _loc3) : (_loc3);
					return (_loc1 + ":" + _loc2 + ":" + _loc3);
				} // End of the function
				
				
				
				public function exitButtonPressed()
				{
					islAppRoot.functionTrace("framework (AICC Frame) :: exitButtonPressed()");
				
					exitAfterPutparam = true;
					putParam();
				} // End of the function
				
				
				
				function searchArray(arr, searchValue)
				{
					for (var _loc1 = 0; _loc1 < arr.length; ++_loc1)
					{
						if (arr[_loc1] == searchValue)
						{
							return (_loc1);
						} // end if
					} // end of for
					return (-1);
				} // End of the function
				
				
				
				function controlled_AICC_exit()
				{
					islAppRoot.functionTrace("framework (AICC Frame) :: controlled_AICC_exit()");
					  var request:URLRequest = new URLRequest("javascript:top.window.close()");
						navigateToURL(request, '_self');
					//getURL("javascript:top.window.close()");
				} // End of the function
				
				
				
/*
				percentage = 20;
				preload_holder.bar_mc._width = percentage * preload_holder.percentWid;
				preload_holder.percent_txt.text = "Loading " + percentage + "%";
*/

				
				
				//lmsReceive.onLoad = function (success)
				function lmsReceiveEvent(e:Event)
				{
					/*
					//if (success)
					{
						if (this.error != undefined && this.error.length > 0)
						{
							responseStringSplit = this.error.split("\n");
							if (responseStringSplit[0].charAt(0) == "0" || responseStringSplit[1].toLowerCase().indexOf("error_text=successful") > -1)
							{
								if (this.error.toLowerCase().indexOf("aicc_data") > -1)
								{
									parseLMSResponse(this.error.substr(this.error.toLowerCase().indexOf("aicc_data")));
								}
								else
								{
									CGlobal.islDebug("Error. Could not find the \"aicc_data\" string in the response");
								} // end else if
							}
							else
							{
								CGlobal.islDebug("Error. The LMS response indicated a problem with processing the command\n" + responseStringSplit[0] + "\n" + responseStringSplit[1]);
							} // end else if
						}
						else
						{
							CGlobal.islDebug("Error. Received a response from the LMS but it doesn\'t appear valid.");
							passAiccStage();
						} // end else if
					}
					else
					{
						CGlobal.islDebug("Error. Did not get a response from the LMS.");
						passAiccStage();
					} // end else if*/
				}
				
				

	}
	
}