﻿/**
*  @public
*  the class controls all the buttons and all what deals with it in the course
*/
package {
	import flash.display.*;
	import flash.text.*;
	import flash.events.*;
	import flash.net.*;
	import flash.net.URLRequest;

	public class Button_Code extends MovieClip {
		var screen:Object;
		var btnRef:MovieClip;

		/*
		*  @public
		*  class constructor
		*/
		public function Button_Code(screenStage:Object) {
			screen = screenStage;
			screenButtonsControl.objects = new Array();
			
			if (!CGlobal.islAppRoot.islMainPlayerRunning)
			{
				contentLevel = CGlobal.islAppRoot;
			}
			else 
			{
				contentLevel = CGlobal.content_mc;
			} // end else if
		}
		var testingVars = "testing vars";
		var contentLevel;
		var buttonLevel;
		var screenButtonsControl:Object = new Object();
		var sequentialClicksArray = new Array();
		var sequentialClickNum = 0;
		var sequentialRollsArray = new Array();
		var sequentialRollNum = 0;
		
		/*
		*  @public
		*  reset all controls in the screen to it's default state
		*/
		public function resetScreenControls()
		{
			
			{
				contentLevel = CGlobal.content_mc;
			} // end else if
			screenButtonsControl.screenBtnCount = 0;
			screenButtonsControl.viewedBtnCount = 0;
			screenButtonsControl.objects = new Array();	
			screenButtonsControl.currentActiveButton = new MovieClip();
			sequentialClicksArray = new Array();
			sequentialClickNum = 0;
			sequentialRollsArray = new Array();
			sequentialRollNum = 0;
		} // End of the function
		
		/*
		*  @public
		*  initialozes the buttons, adds the listeners and sets the tracking indicator
		*/
		public function initButton(obj:MovieClip){

			obj.initialised = true;
                       
			if (String(obj.name).indexOf("roll") > -1 || String(obj.name).indexOf("click") > -1 || String(obj.name).indexOf("load") > -1)
			{
				++screenButtonsControl.screenBtnCount;
				screenButtonsControl.objects.push(obj);
				if (obj.name.indexOf("click") > -1)
				{
					sequentialClicksArray.unshift(obj);
				} // end if
				if (obj.name.indexOf("roll") > -1)
				{
					sequentialRollsArray.unshift(obj);
				} // end if
			} // end if
			
		
			if (contentLevel.controlled_navigation == "on")
			{
				if (screenButtonsControl.screenBtnCount > screenButtonsControl.viewedBtnCount)
				{
					
				} // end if
			} // end if
			if (obj.hitArea_mc != undefined)
			{
				if(obj.name.indexOf("evaluator")== -1 && obj.name.indexOf("retry") == -1)
				{
				  obj.hitArea_mc.buttonMode = true;
				}
				obj.hitArea_mc.mouseChildren = false;
				obj.hitArea_mc.addEventListener(MouseEvent.MOUSE_OVER,btn_over);
				obj.hitArea_mc.addEventListener(MouseEvent.MOUSE_OUT,btn_out);
				obj.hitArea_mc.addEventListener(MouseEvent.MOUSE_UP,btn_release);
				obj.hitArea_mc.tabEnabled = false;
				
			}
			else
			{
				if(obj.name.indexOf("evaluator") == -1 && obj.name.indexOf("retry") == -1)
				{
				obj.buttonMode = true;}
				
				obj.mouseChildren = false;
				obj.addEventListener(MouseEvent.MOUSE_OVER,btn_over);
				obj.addEventListener(MouseEvent.MOUSE_OUT,btn_out);
				obj.addEventListener(MouseEvent.MOUSE_UP,btn_release);
				obj.tabEnabled = false;
				
			} // end else if
			if (contentLevel.sequential_clicks == "on" && obj.name.indexOf("click") > -1)
			{
				sequentialClickButtons();
			} // end if
			if (contentLevel.sequential_rolls == "on" && obj.name.indexOf("roll") > -1)
			{
				sequentialRollButtons();
			} // end if
			if (contentLevel[obj.name + "_btn_tracking"] != undefined)
			{
				if (contentLevel[obj.name + "_btn_tracking"].indexOf("page") > -1)
				{
					btn_trackingStr = contentLevel[obj.name + "_btn_tracking"];
					pageSrc = btn_trackingStr.substring(btn_trackingStr.lastIndexOf("|") + 1, btn_trackingStr.length);
					pageObject =CGlobal.islAppRoot.findPageBySrc(CGlobal.Course, pageSrc);
					if (pageObject.progress == 2)
					{
						obj.viewed = true;
						MovieClip(obj.tracking_indicator).gotoAndPlay("complete");
					} // end if
				}
				else if (contentLevel[obj.name + "_btn_tracking"].indexOf("module") > -1 || contentLevel[obj.name + "_btn_tracking"].indexOf("topic") > -1)
				{
					btn_trackingStr = contentLevel[obj.name + "_btn_tracking"];
					modID = btn_trackingStr.substring(btn_trackingStr.lastIndexOf("|") + 1, btn_trackingStr.length);
					
					modProgress =CGlobal.islAppRoot.checkNodeProgress(modObj);
					if (modProgress == 2)
					{
						obj.viewed = true;
						MovieClip(obj.tracking_indicator).gotoAndPlay("complete");
					} // end if
				} // end if
			} // end else if
			
			
			obj.initialised = true;
		} // End of the function
		
		
		/*
		*  @public
		*  deactivates and disables the button
		*/
		public function deactivateButton(the_button:MovieClip) {
			if (!the_button)
			return;
			
			if (the_button.name.indexOf("hitArea") > -1)
			{
				
				the_button.hitArea_mc.buttonMode = false;
			}
			else
			{
				
				the_button.buttonMode = false;
			} // end else if
			the_button.alpha = .5;

		}
		
		/*
		*  @public
		*  activates and enables the button
		*/
		public function activateButton(the_button:Object) {
						
			if (the_button.name.indexOf("hitArea") > -1)
			{
				
				the_button.hitArea_mc.buttonMode = true;
			}
			else
			{
				
				the_button.buttonMode = true;
			} // end else if
			the_button.alpha = 1;
					
		}
				
		
		/*
		*  @public
		*  disables all the screen buttons
		*/
		function disableScreenButtons()
		{
			for (var _loc1:int = 0; _loc1 < screenButtonsControl.objects.length; ++_loc1)
			{
				if (contentLevel.controlled_events == "on")
				{
					if (contentLevel.sequential_clicks == "off")
					{
						if (screenButtonsControl.objects[_loc1].hitArea_mc != undefined)
						{
							if (screenButtonsControl.objects[_loc1].name.indexOf("click") > -1 || screenButtonsControl.objects[_loc1].name.indexOf("load") > -1)
							{
								screenButtonsControl.objects[_loc1].hitArea_mc.buttonMode = false;
								
							} // end if
						}
						else if (screenButtonsControl.objects[_loc1].name.indexOf("click") > -1 || screenButtonsControl.objects[_loc1].name.indexOf("load") > -1)
						{
							screenButtonsControl.objects[_loc1].buttonMode= false;
							
						} // end else if
					}
					else if (screenButtonsControl.objects[_loc1].hitArea_mc != undefined)
					{
						if (screenButtonsControl.objects[_loc1].name.indexOf("click") > -1 || screenButtonsControl.objects[_loc1].name.indexOf("load") > -1)
						{
							screenButtonsControl.objects[_loc1].hitArea_mc.buttonMode = false;
							
							} // end if
					}
					else if (screenButtonsControl.objects[_loc1].name.indexOf("click") > -1 || screenButtonsControl.objects[_loc1].name.indexOf("load") > -1)
					{
						screenButtonsControl.objects[_loc1].buttonMode = false;
												
					} // end else if
					continue;
				} // end if
				if (screenButtonsControl.objects[_loc1].hitArea_mc != undefined)
				{
					screenButtonsControl.objects[_loc1].hitArea_mc.buttonMode = false;
					
					continue;
				} // end if
				screenButtonsControl.objects[_loc1].buttonMode = false;
			} // end of for
			
			
		} // End of the function
		
		
		/*
		*  @public
		*  enables all the screen buttons
		*/
		function enableScreenButtons()
		{
			for (var _loc1:int = 0; _loc1 < screenButtonsControl.objects.length; ++_loc1)
			{
				if (contentLevel.controlled_events == "on")
				{
					if (contentLevel.sequential_clicks == "off")
					{
						if (screenButtonsControl.objects[_loc1].hitArea_mc != undefined)
						{
							if (screenButtonsControl.objects[_loc1].name.indexOf("click") > -1 || screenButtonsControl.objects[_loc1].name.indexOf("load") > -1)
							{
								screenButtonsControl.objects[_loc1].hitArea_mc.buttonMode = true;

							} // end if
						}
						else if (screenButtonsControl.objects[_loc1].name.indexOf("click") > -1 || screenButtonsControl.objects[_loc1].name.indexOf("load") > -1)
						{
							screenButtonsControl.objects[_loc1].buttonMode = true;

						} // end else if
					}
					else if (_loc1 <= sequentialClickNum)
					{
						sequentialClicksArray[_loc1].hitArea_mc.buttonMode = true;

					} // end else if
					continue;
				} // end if
				if (screenButtonsControl.objects[_loc1].hitArea_mc != undefined)
				{
					screenButtonsControl.objects[_loc1].hitArea_mc.buttonMode = true;

					continue;
				} // end if
				screenButtonsControl.objects[_loc1].buttonMode = true;
			} // end of for
		} // End of the function
		
		
		/*
		*  @public
		*  arranges the click buttons array and counts them in every screen
		*/
		function sequentialClickButtons()
		{
			sequentialClicksArray.sort();
			for (var _loc1:int = 0; _loc1 < sequentialClicksArray.length; ++_loc1)
			{
				if (sequentialClicksArray[_loc1].hitArea_mc != undefined)
				{
					sequentialClicksArray[_loc1].hitArea_mc.buttonMode = false;
					
					continue;
				} // end if
				sequentialClicksArray[_loc1].buttonMode = false;
			} // end of for
			for (s = 0; s <= sequentialClickNum; s++)
			{
				if (sequentialClicksArray[s].hitArea_mc != undefined)
				{
					sequentialClicksArray[s].hitArea_mc.buttonMode = true;
 					sequentialClicksArray[s].hitArea_mc.mouseChildren = false;
					continue;
				} // end if
				
				sequentialClicksArray[s].buttonMode = true; 
				
			} // end of for
		} // End of the function
		
		
		/*
		*  @public
		*  arranges the roll buttons array and counts them in every screen
		*/
		function sequentialRollButtons()
		{
			sequentialRollsArray.sort();
			for (var _loc1:int = 0; _loc1 < sequentialRollsArray.length; ++_loc1)
			{
				if (sequentialRollsArray[_loc1].hitArea_mc != undefined)
				{
					sequentialRollsArray[_loc1].hitArea_mc.buttonMode = false;
					
					continue;
				} // end if
				sequentialRollsArray[_loc1].buttonMode = false;
			} // end of for
			for (s = 0; s <= sequentialRollNum; s++)
			{
				if (sequentialRollsArray[s].hitArea_mc != undefined)
				{
					sequentialRollsArray[s].hitArea_mc.buttonMode = true;
    				sequentialRollsArray[s].hitArea_mc.mouseChildren = false;
					continue;
				} // end if
				sequentialRollsArray[s].buttonMode = true;
			} // end of for
		} // End of the function
		
		
		/*
		*  @public
		*  plays the effects on mouse over and plays the actions if the button is a roll button 
		*/
		public function btn_over(e:MouseEvent):void {
			
			
			if(e.target.buttonMode == false) return;
			
			if(CurentOverBtn)
			{
				 rollOutAction(CurentOverBtn);
				
				CurentOverBtn.removeEventListener(Event.ENTER_FRAME , rollOutTracker);
			}
			e.target.addEventListener(Event.ENTER_FRAME , rollOutTracker);
			
			CurentOverBtn=e.target;
			if (e.target.name.indexOf("hitArea") > -1)
			{

				MovieClip(e.target.parent).gotoAndPlay("over");
				if (e.target.parent.name.indexOf("roll") > -1)
				{
					
					
					sharedFunctionality(e.target.parent);
					e.target.buttonMode = false;
				} // end if
			}
			else
			{
				MovieClip(e.target).gotoAndPlay("over");
				if (e.target.name.indexOf("roll") > -1)
				{
					
					sharedFunctionality(e.target);
					e.target.buttonMode = false;
				} // end if
			} // end else if
			
			
		}
		var CurentOverBtn:MovieClip;
		
		/*
		*  @public
		*  plays the effects on mouse out and stops the actions if the button is a roll button 
		*/
		public function btn_out(e:MouseEvent):void {
			
		 
			
			if(e.target.hitTestPoint(mouseX,mouseY,true)) 
			{
				e.target.addEventListener(Event.ENTER_FRAME , rollOutTracker);
				
				
			}else{
				
			
			}
				   
			}
	
		
		/*
		*  @public
		*  removes the listener from roll buttons on mouse out
		*/
		 function rollOutTracker(e:Event){
				
				if(!e.target.hitTestPoint(mouseX,mouseY,true)) 
				{
					
							   rollOutAction(e.target);
								e.target.removeEventListener(Event.ENTER_FRAME , rollOutTracker);
				}
				
			}
			
		
		/*
		*  @public
		*  plays the actions required with mouse out on roll buttons or movieclips
		*/
		function rollOutAction(movie:MovieClip)
			{
				
				 if (movie.name.indexOf("hitArea") > -1)
								{
									if (movie.parent != screenButtonsControl.currentActiveButton)
									{
										MovieClip(movie.parent).gotoAndPlay("out");
									} // end if
									if (movie.parent.name.indexOf("roll") > -1)
									{ 
										close_btn_release(MovieClip(movie.parent));
									} // end if
								}
								else
								{
									if (movie != screenButtonsControl.currentActiveButton)
									{
										MovieClip(movie).gotoAndPlay("out");
									} // end if
									if (movie.name.indexOf("roll") > -1)
									{ 
										close_btn_release(movie);
									} // end if
								} // end else if
								
								if(movie.name.indexOf("evaluator") == -1 && movie.name.indexOf("retry") == -1)
								movie.buttonMode = true;
					
				
				}
				
	
	/*
	*  @public
	*  checks for the button type and launches the proper functions
	*/
	public function btn_release(e:MouseEvent):void {
	if(e.target.buttonMode == false) return;
	
	if (e.target.name.indexOf("hitArea") > -1) {
		e.target.parent.gotoAndPlay("down");
		if (e.target.parent != screenButtonsControl.currentActiveButton) {
			screenButtonsControl.currentActiveButton.parent.gotoAndPlay("revert");
		}// end if
		if (e.target.parent.name.indexOf("click") > -1) {
			sharedFunctionality(e.target.parent);
		} else if (e.target.parent.name.indexOf("comp") > -1) {
			CGlobal.closeComponent(e.target.parent);
		} else if (e.target.parent.name.indexOf("close") > -1) {
			close_btn_release(e.target.parent);
		} else if (e.target.parent.name.indexOf("next") > -1) {
			CGlobal.goNext();
		} else if (e.target.parent.name.indexOf("lms_finish") > -1) {
			CGlobal.islAppRoot.manual_finish();
		} else if (e.target.parent.name.indexOf("launch") > -1) {
			CGlobal.goLaunch(e.target.parent.name);
		} else if (e.target.parent.name.indexOf("captivate") > -1) {
			CGlobal.interaction_code_lib.loadCaptivate(e.target.parent.name);
		} else if (e.target.parent.name.indexOf("trigger") > -1 && contentLevel.screen_type.indexOf("video") > -1) {
			e.target.parent.viewed = true;
			CGlobal.video_code_lib.triggerPoint();
		} else if (e.target.parent.name.indexOf("video") > -1 && contentLevel.screen_type.indexOf("video") > -1) {
			sharedFunctionality(e.target.parent);
			CGlobal.video_code_lib.findVidObject(e.target.parent.name);
		} else if (contentLevel.question_type != "") {
			
			
						CGlobal.question_generic_lib.questionBtnReleased(e.target.parent);
		} else {
					
			funcName = getChildByName("contentLevel." + e.target.name + "_btn_release");
			funcName(e.target.name);
			
		}// end else if
	} else {
		
		
		if(e.target.name.indexOf("evaluator") > -1)
					{

						++CGlobal.question_generic_lib.contentLevel.total_attempts;
						CGlobal.aql.evaluateAnswer();    

						CGlobal.question_generic_lib.displayFeedback();
						deactivateButton(e.target);
					}
		else if (e.target.name.indexOf("retry") > -1)
				{
					CGlobal.aql.resetOptions(); 
					CGlobal.question_generic_lib.contentLevel.feedbackmc.gotoAndStop("1");
					CGlobal.question_generic_lib.contentLevel.feedbackmc.evaluator_icon.gotoAndStop(1);
					CGlobal.button_code_lib.deactivateButton(e.target);
				}
				else if (e.target.name.indexOf("toggle") > -1)
				{
					CGlobal.aql.toggleButtonRelease();
				} // end else if

		
		
		e.target.gotoAndPlay("down");
		if (e.target != screenButtonsControl.currentActiveButton) {
			screenButtonsControl.currentActiveButton.gotoAndPlay("revert");
		}// end if
		if (e.target.name.indexOf("click") > -1) {
			sharedFunctionality(e.target);
			
		} else if (e.target.name.indexOf("comp") > -1) {
			CGlobal.closeComponent(e.target.parent);
		} else if (e.target.name.indexOf("close") > -1) {
			close_btn_release(e.target);
		} else if (e.target.name.indexOf("next") > -1) {
			CGlobal.goNext();
		} else if (e.target.name.indexOf("launch") > -1) {
			CGlobal.goLaunch(e.target.name);
		} else if (e.target.name.indexOf("captivate") > -1) {
			CGlobal.interaction_code_lib.loadCaptivate(e.target.name);
		} else if (e.target.name.indexOf("open") > -1) {
			CGlobal.interaction_code_lib.loadExternal(e.target.parent[e.target.name + "_doc"]);
		} else if (e.target.name.indexOf("trigger") > -1 && contentLevel.screen_type.indexOf("video") > -1) {
			e.target.viewed = true;
			CGlobal.video_code_lib.triggerPoint();
		} else if (e.target.parent&& e.target.parent.name.indexOf("video") > -1 && contentLevel.screen_type.indexOf("video") > -1) {
			CGlobal.video_code_lib.findVidObject(e.target.name);
			sharedFunctionality(e.target);
		} else if (contentLevel.question_type != "" && contentLevel.question_type != undefined) {
			
			CGlobal.question_generic_lib.questionBtnReleased(e.target);
		} else {
			funcName = getChildByName("contentLevel." + e.target.name + "_btn_release");
			
		}// end else if
	}// end else if


}// End of the function
		
		
		/*
		*  @public
		*  opens an external document
		*/
		function openDoc(req:URLRequest):void {
			flash.net.navigateToURL(req);
		}
		
		
		/*
		*  @public
		*  plays the extra content in the screen
		*  counts the buttons, click buttons, and roll buttons in the screen
		*/
		function sharedFunctionality(currentButton:MovieClip)
		{
			
			
			if (contentLevel.handler_mc != undefined)
			{
				contentLevel.handler_mc.x = currentButton.x;
			} // end if
			
			buttonLevel = (currentButton.parent);
			if(contentLevel.extra_content)
			{
				
				MovieClip(contentLevel.extra_content).gotoAndPlay(currentButton.name);
			}
			if(contentLevel.currentActiveButton)
			MovieClip(screenButtonsControl.currentActiveButton).gotoAndPlay("out");
			screenButtonsControl.currentActiveButton = currentButton;
			if (!currentButton.viewed)
			{
				currentButton.viewed = true;
				++screenButtonsControl.viewedBtnCount;
			} // end if
			if (contentLevel.controlled_navigation == "on")
			{
				controlledNavigation(currentButton);
			} // end if
			if (contentLevel.sequential_clicks == "on")
			{
				if (currentButton.name.indexOf("click") > -1)
				{
					if (currentButton.clickViewed != true)
					{
						++sequentialClickNum;
						sequentialClickButtons();
						currentButton.clickViewed = true;
					} // end if
				} // end if
			} // end if
			if (contentLevel.sequential_rolls == "on")
			{
				if (currentButton.name.indexOf("roll") > -1)
				{
					if (currentButton.rollViewed != true)
					{
						++sequentialRollNum;
						sequentialRollButtons();
						currentButton.rollViewed = true;
					} // end if
				} // end if
			} // end if
			if (contentLevel.controlled_events == "on")
			{
				disableScreenButtons();
			} // end if
			if (contentLevel.popupAudio == "on")
			{
				CGlobal.audio_code_lib.extraAudioPlay(currentButton.name);
			} // end if
		} // End of the function
		
		/*
		*  @public
		*  stops and closes the extra content when when the close button is clicked
		*/
		function close_btn_release(currentButton:MovieClip)
		{
			if (currentButton.name.indexOf("roll") > -1)
			{
				try{
				if(buttonLevel && buttonLevel.extra_content)
				buttonLevel.extra_content.gotoAndStop(1);
				}catch(e:Error){
					}
			}
			else
			{
				trace ("close_btn_release",currentButton.parent.name);
				if(currentButton && currentButton.parent.name=="extra_content" && currentButton.parent.moviecon_mc && currentButton.parent.moviecon_mc.getChildByName("myCaptivate")){		
					currentButton.parent.moviecon_mc.getChildByName("myCaptivate").unloadAndStop();
				}
				parentLevel = currentButton.parent;
				parentLevel.gotoAndStop(1);
			} // end else if
			if (contentLevel.popupAudio == "on")
			{
				CGlobal.audio_code_lib.extraAudioStop(screenButtonsControl.currentActiveButton.name);
			} // end if


			if(CGlobal.checkLabel(screenButtonsControl.currentActiveButton,"revert"))
			{
			MovieClip(screenButtonsControl.currentActiveButton).gotoAndPlay("revert");
			}
			screenButtonsControl.currentActiveButton = new MovieClip();
			if (contentLevel.controlled_events == "on")
			{
				enableScreenButtons();
			} // end if
			if (contentLevel.screen_type == "video")
			{
				if (contentLevel.video_mc.video_flv.contentPath != "")
				{
					contentLevel.video_mc.video_flv.unloadMovie(contentLevel.video_mc.video_flv.contentPath);
				} // end if
			} // end if
		} // End of the function
		
		
		/*
		*  @public
		*  controls the navigation by preventing the user from advancing from the screen until
		*  it's finished
		*/
		function controlledNavigation(currentButton:MovieClip)
		{
			if (screenButtonsControl.screenBtnCount == screenButtonsControl.viewedBtnCount)
			{
				if (CGlobal.islAppRoot.islSettings.forcedNavigation == "on")
				{
					CGlobal.islAppRoot.contentMovieFinished();
				}
				else
				{
					
				} // end if
			} // end else if
		} // End of the function

	
}

}