﻿/*
*  @public
*  class is responsible for loading and using the main course structure XML
*/
package {

	import flash.events.Event;
	import flash.events.*;
	import flash.events.EventDispatcher;
	import flash.net.*;
	import flash.net.URLRequest;
	import flash.display.Loader;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	public class CStructure extends MovieClip {
		var loader:URLLoader = new URLLoader();
		public var XMLData:XML;
		/*
		*  @public
		*  class constructor
		*/
		function CStructure() {
			
		}
		/*
		*  @public
		*  loading the data from the XML file and removing the listener
		*/
		function onxmlComplete(evt:Event):void {
			try {
				XMLData  = new XML(evt.target.data);

				loader.removeEventListener(Event.COMPLETE, onxmlComplete);
				//loader.removeEventListener(IOErrorEvent.IO_ERROR,onIOError);
				dispatchEvent(new Event("onCStructureLoad"));
			} catch (err:Error) {
				trace("Could not loaded CourseStructure:\n" + err.message);
			}
		}
		/*
		*  @public
		*  loads the main structure XML for the course
		*/
		public function LoadStructure(){
			
			loader.addEventListener(Event.COMPLETE, onxmlComplete, false, 0, true);
			//loader.addEventListener(IOErrorEvent.IO_ERROR, onIOError, false, 0,true);
			loader.load(new URLRequest("structure.xml"));
			}
		
		/*
		*  @public
		*  gets the first activity of the activity
		*/
		public function getFirstOfActivity(ActName:String):int
		{
			 
			for (var b:int=0 ;b<  XMLData.groupnode.groupnode.groupnode.page.length(); b++) {
						if( ActName ==  XMLData.groupnode.groupnode.groupnode.page[b].parent().title )
						{
							return b;
						}
				}  // end for
			 
						return -1;
		}
		
		/*
		*  @public
		*  gets the source (src) of the given screen
 		*/
		public function getScreenBySrc(ActName:String):int
		{
			/// trace(ActName + "ActName");
			for (var b:int=0 ;b<  XMLData.groupnode.groupnode.groupnode.page.length(); b++) {
						
						//trace(XMLData.groupnode.groupnode.groupnode.page[b].@src.toString()  + " to oooo ActName");
						
						if( ActName ==  XMLData.groupnode.groupnode.groupnode.page[b].@src.toString() )
						{
							
							return b;
						}
				}  // end for
			 
						return -1;
		}
		
		
		
		
	}
}