﻿/*
*  @public
*  
*/
package {
	import flash.events.*;
	import flash.net.URLRequest;
	import flash.net.URLLoader;
	import flash.display.Loader;
	import flash.media.*;

	import flash.display.MovieClip;
	import flash.display.Sprite;

	public class FileLoader extends MovieClip {

		private var _mc:Sprite;
		var MoviesPath:String;
		var myFileName:String;
		var myXmlFile:String;
		var myAudioFile:String;
		var loadingtxt:String;
		var myrequest:URLRequest;
		private var url:String;
		public var loader:Loader;
		public var xmlloader:URLLoader;
		public var audioloader:Loader;
		
		/*
		*  @public
		*  class constructor, adds the listeners
		*/
		public function FileLoader(url:String="") {

			if (url!="") {

				CGlobal.islAppRoot.preloader_mc.bar_mc.width = 0;
				CGlobal.islAppRoot.preloader_mc.percent_txt.text =  "" ;

				this.url=url;
				if (url.indexOf("movies") > -1 ) {
					this.myFileName = url.substring(url.indexOf('/')+1,url.lastIndexOf('.'));
					this.MoviesPath ="movies/";
					this.myXmlFile = MoviesPath+"content/" + myFileName + ".xml";
					this.myAudioFile = MoviesPath+"audio/"+myFileName+ "_audio.swf";
					audioLoader(myAudioFile);

				}
				else {
					swfLoader(url);
				}

			}
		}
		public function xmlLoader(url:String="") {


			xmlloader=new URLLoader();
			
			xmlloader.addEventListener(Event.COMPLETE, xmldone);
			xmlloader.addEventListener(IOErrorEvent.IO_ERROR,xmlonIOError);
			myrequest = new URLRequest(url);
			xmlloader.load(myrequest);

		}
		public function audioLoader(url:String="") {

            loadingtxt="Sound Loading " ;
			audioloader=new Loader();
			audioloader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS, loop);
			audioloader.contentLoaderInfo.addEventListener(Event.COMPLETE, audiodone);
			audioloader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR,audioonIOError);
			myrequest = new URLRequest(url);
			audioloader.load(myrequest);

		}

		public function swfLoader(url:String="") {
			
			CGlobal.islAppRoot.preloader_mc.bar_mc.width = 0;
			CGlobal.islAppRoot.preloader_mc.percent_txt.text =  "" ;
			loadingtxt="Data loading " ;
			loader=new Loader();
			loader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS, loop);
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, swfdone);
			loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR,onIOError);

			
			myrequest=new URLRequest(url);
			loader.load(myrequest);

		}
		private function loop(e:ProgressEvent):void {
			
			CGlobal.islAppRoot.preloader_mc.visible= true;
			var perc:Number = (e.bytesLoaded / e.bytesTotal)*100;
			CGlobal.islAppRoot.preloader_mc.bar_mc.width=perc;
			CGlobal.islAppRoot.preloader_mc.percent_txt.text = loadingtxt + Math.ceil(perc).toString() + "%" ;
		}
		private function swfdone(event:Event):void {
			
			dispatchEvent(new Event("onFileLoad"));
			CGlobal.islAppRoot.preloader_mc.visible=false;
			
		}
		private function xmldone(event:Event):void {
			swfLoader(url);
		}
		private function audiodone(event:Event):void {
			xmlLoader(myXmlFile);
		}
		/*
		*  @private
		*  firing event on errors
		*/
		private function onIOError(event:IOErrorEvent):void {

			dispatchEvent(new Event("onFileNotFound"));
			CGlobal.islDebug("File Not Found "+url);
		}
		private function audioonIOError(event:IOErrorEvent):void {
			xmlLoader(myXmlFile);

		}
		private function xmlonIOError(event:IOErrorEvent):void {
			swfLoader(url);

		}

	}
}