﻿/*
*  @public
*  a class responsible for the generic type questions
*/
package 
{
	import flash.display.MovieClip;

	public class QuestionGeneric extends MovieClip
	{
	    public var contentLevel:MovieClip;	
		//var rootLevel = _level0;
		public  var randomOrder:Array;
		public  var feedback_string:String;
		
		/*
		*  @public
		*  class constructor
		*/
		public function QuestionGeneric()
			{
				randomOrder  = new Array();
				contentLevel = new MovieClip()
				
			}

		/*
		*  @public
		*  initiating the question movie, reseting all settings to default
		*/
		public function initQuestionScreen() // ff:MovieClip  add 
		{
			
			CGlobal.recordCurrentQuestionResult(0);
			
			if (!CGlobal.islAppRoot && !CGlobal.islAppRoot.islMainPlayerRunning) //  pending--->  added for test (!islAppRoot &&)
			{
				contentLevel = CGlobal.islAppRoot;  //CGlobal.content_mc   //_level0;
			}
			else
			{
				contentLevel = CGlobal.content_mc;
			} // end else if
			contentLevel.question_is_correct = 0;
			contentLevel.total_attempts = 0;
			randomOrder = new Array();
			feedback_string = "";
		} // End of the function

		/*
		*  @public
		*  determines which buttons is released and triggers it's actions
		*/
		public function questionBtnReleased(btn)
			{
				
				//CGlobal.islAppRoot.navigation.loader.content.enableNextButton();
				//trace("btn.buttonMode   "+ btn.buttonMode);
				if(btn.buttonMode == false){return;}
				
				
				//trace(CGlobal.aql + "ccc");
				if (btn.name.indexOf("evaluator") > -1)
				{
					
					++contentLevel.total_attempts;
					CGlobal.aql.evaluateAnswer();    
					displayFeedback();
					CGlobal.button_code_lib.deactivateButton(btn);
				}
				else if (btn.name.indexOf("retry") > -1)
				{
					CGlobal.aql.resetOptions();   ///     ???? aql ??? 
					contentLevel.feedbackmc.gotoAndStop("1");
					contentLevel.feedbackmc.evaluator_icon.gotoAndStop(1);
					CGlobal.button_code_lib.deactivateButton(btn);
				}
				else if (btn.name.indexOf("toggle") > -1)
				{
					CGlobal.aql.toggleButtonRelease();
				} // end else if
			} // End of the function

		/*
		*  @public
		*  displays the proper feedback for the question depending on the evaluation of the answer
		*/
		public function displayFeedback()
		{
			trace ("contentLevel.question_is_correct before: "+contentLevel.question_is_correct);
if (		contentLevel.question_is_correct== 0 )
contentLevel.question_is_correct=false;

trace ("contentLevel.question_is_correct after : "+contentLevel.question_is_correct);

			if (contentLevel.question_type == "SAMC_IF")
			{
				if (contentLevel.question_is_correct){
					
					feedback_string = "feedback_" + 1;
					
				}				
				if (!contentLevel.question_is_correct && contentLevel.total_attempts < contentLevel.max_attempts)
				{
					trace("X1");
					feedback_string = "feedback_" + 2;
					CGlobal.button_code_lib.activateButton(contentLevel.retry_button);
				} // end if
				
				if (!contentLevel.question_is_correct && contentLevel.total_attempts == contentLevel.max_attempts)
				{
										trace("X2");
					feedback_string = "feedback_" + 3;
				} // end if
				
			}
			else if (contentLevel.question_type == "GRIDALT")
			{
				if (CGlobal.aql.column_1feedback)
				{
					feedback_string = "feedback_column1";
				}
				else
				{
					feedback_string = "feedback_column2";
				} // end else if
			}
			else if (contentLevel.total_attempts < contentLevel.max_attempts && !contentLevel.question_is_correct)
			{


				if (contentLevel.question_type != "SAMC" && contentLevel.total_correct > 0)
				{
														trace("X31: "+ contentLevel.total_attempts);
														
														
					feedback_string = "feedback_partlycorrect_tryagain_" + contentLevel.total_attempts;
					
				}
				else
				{									trace("X32");
					feedback_string = "feedback_incorrect_tryagain_" + contentLevel.total_attempts;
//									feedback_string = "feedback_incorrect";
				} // end else if
				
				CGlobal.button_code_lib.activateButton(contentLevel.retry_button);
			}
			else if (contentLevel.total_correct > 0 && !contentLevel.question_is_correct)
			{
									trace("X4");
				feedback_string = "feedback_partlycorrect";
			}
			else if (contentLevel.question_is_correct)
			{
				feedback_string = "feedback_correct";
				trace("feedback_string_uncorrect " + feedback_string);
			}
			else if (!contentLevel.question_is_correct)
			{
									trace("X5");
				feedback_string = "feedback_incorrect";
				
				
			} // end else if
			trace ("contentLevel.question_is_correct afterxx : "+contentLevel.question_is_correct);
			CGlobal.audio_feedback = feedback_string;  ///  ??? audio_feedback ???
			feedback_string = contentLevel[feedback_string];
			contentLevel.setChildIndex(contentLevel.feedbackmc,contentLevel.numChildren-1);
			contentLevel.feedbackmc.gotoAndPlay("start");
			CGlobal.aql.disableOptions();
			if (contentLevel.question_is_correct)
			{
				if (contentLevel.show_answer != "off" && contentLevel.show_answer != "toggle")
				{
					CGlobal.aql.showCorrectAnswer();
				} // end if
				contentLevel.feedbackmc.evaluator_icon.gotoAndStop("correct");
			}
			else if (contentLevel.total_attempts >= contentLevel.max_attempts)
			{
				contentLevel.feedbackmc.evaluator_icon.gotoAndStop("incorrect");
				if (contentLevel.show_answer != "off")
				{
					
					CGlobal.aql.showCorrectAnswer();
				} // end if
			}
			else
			{
				if(contentLevel.feedbackmc.evaluator_icon)
				contentLevel.feedbackmc.evaluator_icon.gotoAndStop("incorrect");
			} // end else if
			if (contentLevel.scoring == "on")
			{
				if (contentLevel.question_is_correct || contentLevel.total_attempts >= contentLevel.max_attempts)
				{
					if (!contentLevel.question_is_correct)
					{
						CGlobal.recordCurrentQuestionResult(0);
					}
					else if (!isNaN(contentLevel.score_value))
					{
						//trace(contentLevel.score_value + "contentLevel.score_value");
						CGlobal.recordCurrentQuestionResult(contentLevel.score_value);
					}
					else
					{
						CGlobal.recordCurrentQuestionResult(1);
					} // end if
				} // end else if
			} // end else if
			if (contentLevel.screenAudio == "on")
			{
				CGlobal.audio_code_lib.extraAudioPlay(CGlobal.audio_feedback);
			} // end if
			//trace(CGlobal.islAppRoot.currentPage.parent.type.indexOf("exam")   + " YYY ");
			//trace(CGlobal.islAppRoot.islSettings.forcedNavigation + " ooooooo " + CGlobal.currentPage.@type.toString());
			//trace(CGlobal.currentPage.parent());
			if (CGlobal.islAppRoot.islSettings && CGlobal.islAppRoot.islSettings.forcedNavigation == "on"  || CGlobal.currentPage.@type.toString().indexOf("question") != -1) 
			{//CGlobal.currentPage.parent().@type.toString().indexOf("exam")!= -1
				if (contentLevel.total_attempts == contentLevel.max_attempts || contentLevel.question_is_correct)
				{
					CGlobal.islAppRoot.contentMovieFinished();
				} // end if
			} // end if
		} // End of the function
	
	  	/*
		*  @public
		*  position the options in randomly generated positions
		*/
		public function randomiseOptionPositioning()
		{
			//trace ("randomiseOptionPositioning ");
			//trace ("contentLevel : " + contentLevel);
			//trace ("contentLevel.total_options : " + contentLevel.total_options);
			for (var i = 1; i <= contentLevel.total_options; ++i)
			{
				randomOrder.push(i);
			} // end of for
			for (num = randomOrder.length - 1; num > 0; num--)
			{
				var rNum = Math.round(Math.random() * num);
				var nNum = randomOrder[num];
				randomOrder[num] = randomOrder[rNum];
				randomOrder[rNum] = nNum;
			} // end of for
		} // End of the function

	
	}
}