﻿/*
*  @public
*  class controls the resouces component
*/
package 
{
    import flash.display.*;
	import caurina.transitions.*;
    import flash.events.*;
    import flash.net.*;
    import flash.text.*;

    public class Resources extends MovieClip
    {
        public var nextcar:int;
        public var linkNode:XMLList;
        public var loader:URLLoader;
        public var opend:Boolean;
        public var navData:XML;
        public var sublessons:Array;
        public var container:MovieClip;
       // public var PaneMask:Sprite;
		var scrollC:scrollClass ;
        /*
		*  @public
		*  class constructor, defines the main buttons, main container, and main mask
		*/
		public function Resources()
        {
			
			button_close.buttonMode = true;
			button_close.mouseChildren = false;

			button_close.addEventListener(MouseEvent.MOUSE_DOWN,CloseComm)
            loadXML();
            container = new MovieClip();
            addChild(container);
            container.x = 370;
            container.y = 163;
            PaneMask = createMask(container, 368, 373);
            PaneMask.x = container.x - 69;
            PaneMask.y = container.y;
            addChild(PaneMask);
            container.mask = PaneMask;
            sublessons = new Array();
			
			scrollC= new scrollClass(this,container,PaneMask,scrollTrack_mc,scrollCentral,scrollUp_mc,scrollDown_mc);
			scrollC.scrollComponent();

			}// end function

		/*
		*  @public
		*  closes the components
		*/
		private function CloseComm(e:MouseEvent) {
			
				 if(CGlobal.islAppRoot){
					   
					   if(CGlobal.islAppRoot.checkFinished){
				  		 CGlobal.islAppRoot.pauseContent(); 
				  		}else{
				  		 CGlobal.islAppRoot.playContent(); 
						}
				  
				  CGlobal.islAppRoot.CloseComponant();
				  }
			}
	 	/*
		*  @public
		*  creates the main mask
		*/
		private function createMask(Pane,panelW, panelH):MovieClip
			{
				var cont:MovieClip = new MovieClip();
				var color = Math.round(Math.random()*0xFFFFFF);
				cont.graphics.beginFill(color,0.5);
				cont.graphics.drawRect(0,0,panelW,panelH);
				cont.graphics.endFill();
				return cont;
			}// end function
			
        /*
		*  @public
		*  gets the requested definition when a word is clicked
		*/
		private function onSubDown(e:MouseEvent)
        {
           	var url = e.target.ss;
			var request:URLRequest = new URLRequest(url);
           	navigateToURL(request);
	       scrollC.Refresh();
	   }// end function
		
        /*
		*  @public
		*  expands and collapses the tree nodes depending on it's state
		*/
		private function onDown(e:MouseEvent) {
       
	   
          var _myclip:MovieClip = MovieClip(e.target.parent);
		           
		  if(_myclip.opend == false){
               for(var i:int = 1 ; i< _myclip.numChildren; i++){
					var _mc:MovieClip = _myclip.getChildAt(i);
					_myclip.node.expandable_mc.gotoAndStop("minus");
					 Tweener.addTween(_mc, {y: -26 + 26 * i, alpha: 1});
					_myclip.opend = true;
					}// end for
				} // end if

			else if(_myclip.opend == true){
					
					for(i = 1 ; i< _myclip.numChildren; i++){
					 _mc = _myclip.getChildAt(i);
					_myclip.node.expandable_mc.gotoAndStop("plus");
					Tweener.addTween(_mc, {y:0, alpha:0});
					_myclip.opend = false;
					}// end for
		    } // end if 
			       scrollC.Refresh();
		}  // end function

		
		
        /*
		*  @public
		*  rearranges the tree elements when necessary
		*/
		private function rearange(e:Event):void {
            for(var n:int = 1 ; n < container.numChildren; n++)
          		  { 
					  var _mcM:MovieClip = container.getChildAt(n);
					  var _mcS:MovieClip = container.getChildAt(n-1);
					  _mcM.y = _mcS.y + _mcS.height - 30.4 ;  
			} // end for		
			this.removeEventListener(Event.ENTER_FRAME , rearange);
        }// end function
	 
	 
	 

        /*
		*  @public
		*  loads the components main XML file
		*/
		private function loadXML(){
        
            var request:URLRequest;
            loader = new URLLoader();
            loader.addEventListener(Event.COMPLETE, completeHandler);
           request = new URLRequest("component/content_en/resources.xml");
		   //request = new URLRequest(CGlobal.content_en+"resources.xml");
            try
            {
                loader.load(request);
            }
            catch (error:Error)
            {
                trace("An error occurred when attempting to load the XML.");
            }
        }// end function

        /*
		*  @public
		*  fires the action and changes the text color on mouse over
		*/
		private function onSubOver(e:MouseEvent)
        {
            e.target.over_in.visible = true;
            e.target.title.textColor = 16777215;
        }// end function

        /*
		*  @public
		*  fires the action and changes the text color on mouse out
		*/
		private function onSubOut(param1:MouseEvent)
        {
            param1.target.over_in.visible = false;
            param1.target.title.textColor = 3355443;
        }// end function

        /*
		*  @public
		*  sets the title and buttons text
		*  builds the course tree via a loop
		*/
		private function completeHandler(event:Event):void {   
			navData = new XML(event.target.data);
            title_txt.text = navData.title[0];
            button_close.button_text.text = navData.btn[0];
			var modulesNode:XMLList= navData.groupnode;

			for (var m in modulesNode) {
					
					var resNode:XMLList= modulesNode[m].link; 
					var menu_mc:Menu_mc = new Menu_mc();
					container.addChild(menu_mc);
					menu_mc.node.title.htmlText = modulesNode.title[m];
					menu_mc.node.title.textColor = 0xAC004C;
					menu_mc.node.expandable_mc.gotoAndStop("plus");
					menu_mc.y= 60 + (m * 30) 
					menu_mc.x= 10;
				for (var r in resNode) {
					var subNode:XMLList= resNode[r].title; 
					var res:Res = new Res();
					menu_mc.addChild(res);
					res.title.htmlText = resNode[r].title;
				
					linkNode = navData.groupnode[m].link
					
					res.over_in.visible =false;
						res.y= 0;
						res.alpha= 0;// 30* l;
						res.x=120;
						
						res.buttonMode = true;
						res.mouseChildren = false;
					
						res.addEventListener(MouseEvent.MOUSE_OVER,onSubOver);
						res.addEventListener(MouseEvent.MOUSE_OUT,onSubOut);
						res.addEventListener(MouseEvent.MOUSE_DOWN,onSubDown);
						res.ss =  linkNode[r].attribute("src");
						
						//trace(res.ss);
				}
				
					var nclip:Dumy_mc = new Dumy_mc();
					nclip.alpha = 0;
					menu_mc.addChild(nclip);
					
					menu_mc.node.buttonMode = true;
					menu_mc.node.mouseChildren = false;
					menu_mc.opend = false;
					menu_mc.node.addEventListener(MouseEvent.MOUSE_DOWN,onDown);
					menu_mc.node.addEventListener(Event.ENTER_FRAME , rearange);
				
				
			}  // end for 1
       
			loader.removeEventListener(Event.COMPLETE, completeHandler);

		   }// end function

		}
    }
