﻿/*
*  @public class
*  the class checks the screen and loads the proper library to deal with it
*/
package {
	
	import flash.display.*;
	import flash.events.*;
	
	public class Setup{
		
		/*
		*  @public
		*  class constructor
		*/
		public function Setup(){
			
			
		}
		/*
		*  @public
		*  checks the screen and loads the proper library to deal with it
		*/
		public function initPage(lvl:MovieClip)
		{

			if (lvl.screen_type )
			{
			if (lvl.screen_type == "question")
			{
				var questionStr:String = "";
				if (lvl.question_type == "SAMC" || lvl.question_type == "MAMC" || lvl.question_type == "SAMC_IF")
				{
					questionStr = "MC";
				}
				else
				{
					questionStr = lvl.question_type;
				} // end else if
				if (lvl.auto_create != "delayed")
				{
					
					/*
					libFile = eval("question_" + questionStr.toLowerCase() + "_lib");
					libFile["init" + questionStr + "Question"]();
					*/
					switch(questionStr.toLowerCase())
					{
					case "dd":
					CGlobal.question_dd_lib.initDDQuestion()
					break;
					case "mc":
					CGlobal.question_mc_lib.initMCQuestion()
					break;
					case "grid":
					CGlobal.question_grid_lib.initGRIDQuestion()
					break;
					case "gridalt":
					CGlobal.question_gridalt_lib.initGRIDALTQuestion()
					break;
					case "ca":
					CGlobal.question_ca_lib.initCAQuestion()
					break;
					//default:
					
					}
				} // end if
			}
			else if (lvl.screen_type.indexOf("interaction") > -1)
			{
				var lastIndex = lvl.screen_type.lastIndexOf("_");
				var interactionType = lvl.screen_type.substring(lastIndex + 1, lvl.screen_type.length);
				CGlobal.interaction_code_lib.initInteractionsScreen(interactionType);
			}
			else if (lvl.screen_type.indexOf("video") > -1)
			{
				CGlobal.video_code_lib.initVideoScreen();
				if (lvl.video_cuePoints == "on")
				{
					lvl.stop();
				}
				else
				{
					lvl.play();
				} // end else if
			} // end else if
						
			}
			if (CGlobal.islAppRoot.currentPage != undefined)
			{
				//CGlobal.updateCurrentPageProgress(2);//pinding
			} // end if
			CGlobal.button_code_lib.resetScreenControls();
			/*
			if (transcript != undefined)
			{
				if (lvl.audio_transcript != undefined)
				{
					transcript.transcript_txt.htmlText = lvl.audio_transcript;
					transcript.transcript_txt.scroll = 1;
					transcript.trackPosition();
				}
				else
				{
					transcript.transcript_txt.htmlText = "No audio for this screen.";
					transcript.transcript_txt.scroll = 1;
				}// end if
			} // end else if
			*/
		} // End of the function
	}
}