﻿/*
*  @public
*  class responsible for the action plan component
*/
package 
{
    import flash.display.*;
    import flash.events.*;
    import flash.net.*;
    import flash.text.*;

    public class actionPlan extends MovieClip
    {

		private var navData:XML;
        private var courseData:XML;
		private var ldr1:URLLoader;
		private var ldr2:URLLoader = new URLLoader();
		private var container:MovieClip;
		private var cont:MovieClip;
		private var sublessons:Array;
		private var activityArray:Array;
		private var allCtivity:XMLList;
		private var Num:int = 0;
		private var opend:Boolean;
		private var checked:Boolean;
		private var mySO:SharedObject;
		
		private var modulesNode:XMLList;
		private var lessonsNode:XMLList;
		private var activityNodes:XMLList;
		
      	private var hasActivty:String;
		private var hasSubActivty:String;
		private var isActivty:String;
		private var counter:int;
		
		private var menu_mc:Menu_mc;
		private var submenu_mc:Menu_mc;
		private var sublesson_mc:Menu_mc;
		/*
		*  @private
		*  closes the component
		*/
		private function CloseComm(e:MouseEvent) {
			
				  if(CGlobal.islAppRoot){
					   
					   if(CGlobal.islAppRoot.checkFinished){
				  		 CGlobal.islAppRoot.pauseContent(); 
						 }else{
						 
				  		 CGlobal.islAppRoot.playContent(); 
						}
				  
				  CGlobal.islAppRoot.CloseComponant();
				  }
			}
        /*
		*  @public
		*  the main action plan function
		*  builds the action plan main container, masks, and loads the action plan xml
		*/
		public function actionPlan()
        {
			
			stop();
			button_close.buttonMode = true;
			button_close.mouseChildren = false;
			
			button_close.addEventListener(MouseEvent.MOUSE_DOWN,CloseComm)
            container = new MovieClip();
			     cont = new MovieClip();
			addChild(container);
            container.x = 350;
            container.y = 230;
			
            PaneMask = createMask(container, 814, 300);
			PaneMask.y = container.y ;
            addChild(PaneMask);
            container.mask = PaneMask;
			
			mySO = CGlobal.data_store.getCourseArraySO();

			
			
            sublessons = new Array();
			
			activityArray = new Array(); 
			checked = false;
			progress_mc.gotoAndPlay("not_started");
			
			ldr1 = new URLLoader();
			ldr2 = new URLLoader(); 
			
			ldr1.load(new URLRequest("component/content_en/action_plan.xml"));
			ldr1.addEventListener(Event.COMPLETE, onCMxmlComplete);
	
			 
			reset_btn.buttonMode = true;
			reset_btn.mouseChildren = false;
			reset_btn.addEventListener(MouseEvent.MOUSE_DOWN,reset_checkList);
			 
			click_3.buttonMode = true;
			click_3.mouseChildren = false;
			click_3.addEventListener(MouseEvent.MOUSE_DOWN,aboutCheklist);
			 
			 
			reset_btn.addEventListener(MouseEvent.MOUSE_OVER ,buttonsOver);
			reset_btn.addEventListener(MouseEvent.MOUSE_OUT  ,buttonsOut);
			 
			click_3.addEventListener(MouseEvent.MOUSE_OVER ,buttonsOver);
			click_3.addEventListener(MouseEvent.MOUSE_OUT  ,buttonsOut);

			 
			 
			var scrollC:scrollClass = new scrollClass(this,container,PaneMask,scrollTrack_mc,scrollCentral,scrollUp_mc,scrollDown_mc);
			scrollC.scrollComponent();
            }// end function

		
        /*
		*  @private
		*  setting the component main titles and buttons text
		*/
		
		function aboutCheklist(e:MouseEvent):void {
		  setChildIndex(extra_content , numChildren-1);
		  extra_content.gotoAndPlay("about");
		}
		
		private function onCMxmlComplete(event:Event):void {   
			
			courseData = new XML(event.target.data);		
	
			button_close.button_text.text = courseData.btn[0];
			component_title_01.htmlText = courseData.dynamic[0];
			component_title_02.htmlText = courseData.dynamic[1];
			component_title_03.htmlText = courseData.dynamic[2];
			component_title_04.htmlText = courseData.dynamic[3];
			component_title_05.htmlText = courseData.dynamic[4];
			button_expand.expand_txt.htmlText = courseData.p[0];
			button_colaps.collapse_txt.htmlText = courseData.p[1];
			completed.htmlText = courseData.dynamic[7];
			not_started.htmlText = courseData.dynamic[6];
			actionplan2.htmlText = courseData.p[2];
			header.htmlText = courseData.dynamic[8];

			click_3.StretchText_txt.htmlText = courseData.p[3];
			reset_btn.StretchText_txt.htmlText = courseData.p[4];
			
			extra_content.close.button_text.text = courseData.btn[0];
			extra_content.about_txt.htmlText = courseData.p[5];
			
			notice.note.StretchText_txt.htmlText = "";

			ldr1.removeEventListener(Event.COMPLETE, onCMxmlComplete);
		    
			ldr2.load(new URLRequest("structure.xml"));
			ldr2.addEventListener(Event.COMPLETE, onStructurexmlComplete);
			
		}

		
		function reset_checkList(e:Event){
			CGlobal.data_store.clearAction();
			//notice.gotoAndPlay("go");
			CollapsAll();
			buildTree();
		}
		
		private function buttonsOver(e:MouseEvent) {
			e.target.gotoAndPlay("over");
			e.target.StretchText_txt.textColor = 0xAB004C;
		}
		
		private function buttonsOut(e:MouseEvent) {
			e.target.gotoAndPlay("out");
			e.target.StretchText_txt.textColor = 0x0B76B4;
		}

		
		
		
	 	/*
		*  @private
		*  creating the main mask
		*/
		private function createMask(Pane,panelW, panelH):MovieClip
        {
            
            var color = Math.round(Math.random()*0xFFFFFF);
            cont.graphics.beginFill(color,0.5);
            cont.graphics.drawRect(0,0,panelW,panelH);
            cont.graphics.endFill();
            return cont;
        }// end function
		
        /*
		*  @private
		*  loops through the course structure and builds the course tree in the action plan
		*/
		
		
		public function onStructurexmlComplete(evt:Event):void {

			navData = new XML(evt.target.data);
			buildTree();
			ldr2.removeEventListener(Event.COMPLETE, onStructurexmlComplete);
		}
		
		
		
		public function buildTree() {
			
			
			counter = 0;
			
			while (container.numChildren) {
				container.removeChildAt(0);
			}
			
			
			allCtivity =   navData.groupnode.groupnode.groupnode.title
			
			if(mySO.data.Num == undefined){
				mySO.data.Num = Num;
			}else{
			Num = mySO.data.Num;
			}
			
			if(mySO.data.myResult == undefined){
				for(var aa:int = 0 ; aa<allCtivity.length(); aa++){
					activityArray.push(false);
					mySO.data.myResult = activityArray;
				}
			} 
			else{
			activityArray = mySO.data.myResult;
			}
			
		    modulesNode = navData.groupnode  
			for (var r in modulesNode) {
				hasActivty =   navData.groupnode[r].attribute("activity");
				if(hasActivty == "true"){
				lessonsNode = navData.groupnode[r].groupnode;
				menu_mc = new Menu_mc();
				container.addChild(menu_mc);
				menu_mc.node.thetxt.title.htmlText =modulesNode.title[r];
				menu_mc.node.thetxt.title.textColor = 0xAC004C;
				menu_mc.node.thetxt.expandable_mc.gotoAndStop("plus");
				menu_mc.y= 30 + (r * 30) 
				menu_mc.x= 10;
				
				menu_mc.node.progress_mc.visible = false;
				menu_mc.activtyCount = 0;
				menu_mc.finishedLessons = 0;
				for (var l in lessonsNode) {
					hasSubActivty = lessonsNode[l].attribute("activity");
					if(hasSubActivty == "true"){
					 activityNodes = lessonsNode[l].groupnode;				
					 submenu_mc = new Menu_mc();
				
					submenu_mc.node.thetxt.title.htmlText = lessonsNode.title[l];
					submenu_mc.node.thetxt.title.textColor = 0xAC004C;
					submenu_mc.node.thetxt.expandable_mc.gotoAndStop("plus");
					submenu_mc.node.progress_mc.gotoAndStop(1);
					
					submenu_mc.y= 30;    
					submenu_mc.visible = false; 
					submenu_mc.x = 12;
				
				for (var k in activityNodes) {
					isActivty = activityNodes[k].attribute("activity");
					if(isActivty == "true"){
					counter++
					sublesson_mc = new Menu_mc();
					submenu_mc.addChild(sublesson_mc);
					sublesson_mc.node.thetxt.buttonMode = true;
					sublesson_mc.node.thetxt.mouseChildren = false;
					sublesson_mc.node.progress_mc.buttonMode = true;
					sublesson_mc.node.progress_mc.mouseChildren = false;
					
					sublesson_mc.node.progress_mc.count = counter;
					sublesson_mc.node.thetxt.Aname = activityNodes.title[k];
					
					sublesson_mc.node.firstPageSrc = activityNodes[k].page[0].@src;
					
					sublesson_mc.node.thetxt.title.htmlText = activityNodes.title[k];
					menu_mc.activtyCount++;
					
					
					sublesson_mc.y = 0;     
					sublesson_mc.visible = false;
					sublesson_mc.visible = false;
					sublesson_mc.node.counter.visible = false;
					sublesson_mc.x = 0;
					sublesson_mc.opend = false;
					sublesson_mc.node.thetxt.addEventListener(MouseEvent.MOUSE_DOWN,endRun);
					sublesson_mc.node.progress_mc.addEventListener(MouseEvent.MOUSE_DOWN,trackMe);
					sublesson_mc.node.progress_mc.checked = mySO.data.myResult[counter];
					sublesson_mc.node.progress_mc.activtyChecked = Num;
					
					
					if(sublesson_mc.node.progress_mc.checked == true){
							sublesson_mc.node.progress_mc.gotoAndPlay("in_progress");
							menu_mc.finishedLessons++;
							
						
							}else{
						sublesson_mc.node.progress_mc.gotoAndStop(2);	
						
	
						}
					menu_mc.node.counter.htmlText = menu_mc.finishedLessons + "/" + menu_mc.activtyCount;// end if					
						}
	
					} // end for 3 
						
					
				menu_mc.addChild(submenu_mc);
				submenu_mc.node.thetxt.mouseChildren = false;
				submenu_mc.node.thetxt.buttonMode = true;
				submenu_mc.opend = false;
				submenu_mc.node.thetxt.addEventListener(MouseEvent.MOUSE_DOWN,onSubDown);
					} // end if 
	
				}  // end for 2 
				
	
				var nclip:Dumy_mc = new Dumy_mc();
				nclip.y = 0;
				nclip.visible = false;
				menu_mc.addChild(nclip); 
						
				menu_mc.node.thetxt.mouseChildren = false;
				menu_mc.node.thetxt.buttonMode = true;
				menu_mc.opend = false;
				menu_mc.node.thetxt.addEventListener(MouseEvent.MOUSE_DOWN,onDown);
				
					
				button_expand.buttonMode = true;
				button_expand.mouseChildren = false;
				button_expand.addEventListener(MouseEvent.MOUSE_DOWN,ExpandAll);
				
				button_colaps.buttonMode = true;
				button_colaps.mouseChildren = false;
				button_colaps.addEventListener(MouseEvent.MOUSE_DOWN,call_CollapsAll);
	
		   } // end if 
		} // end for 
	
	
	stage.addEventListener(Event.ENTER_FRAME , checkNumOfActivity);
	stage.addEventListener(Event.ENTER_FRAME , subrearange);
	ldr2.removeEventListener(Event.COMPLETE, onStructurexmlComplete);
	
			
	} // end function
		   
		   		
	    /*
		*  @private
		*  sets text color when the mouse moves out
		*/
		private function onSubOut(e:MouseEvent)
			{
				e.target.title.textColor = 0x333333;
			}// end function

			
		/*
		*  @public
		*  triggers the action on mouse down
		*/
		function onDown(e:MouseEvent) {
			onDownexc(e.target);
			}; // end function
   

		/*
		*  @public
		*  triggers the movieclip actions 
		*/
		private function onDownexc(target:MovieClip) {
		
				var _myclip:MovieClip = MovieClip(target.parent.parent);					
				
				if(_myclip.opend == false ){
					
					expandModules(target);
				} // end if
				else if(_myclip.opend == true){
		
					collapseModules(target);
		    } // end if
		
		}; // end function



		/*
		*  @private
		*  expands the modules nodes in the course tree
		*/
		private function expandModules(target:MovieClip) {
		var _myclip:MovieClip = MovieClip(target.parent.parent);					
				
					for(var i:int = 1 ; i< _myclip.numChildren; i++){
					var _mc:MovieClip = _myclip.getChildAt(i);
					_myclip.node.thetxt.expandable_mc.gotoAndStop("minus");
					_mc.visible = true;
				  _mc.y= -26 + 26 + 26 * i ;
					_mc.visible=true ;
					_myclip.opend = true;
					}// end for
	
		}


		/*
		*  @private
		*  collapses the modules nodes in the course tree
		*/
		private function collapseModules(target:MovieClip) {
		var _myclip:MovieClip = MovieClip(target.parent.parent);					
				
					for(i = 1; i< _myclip.numChildren; i++){
					 _mc = _myclip.getChildAt(i);
					_myclip.node.thetxt.expandable_mc.gotoAndStop("plus");
					_mc.y= 0;
					_mc.visible = false;
					_myclip.opend = false;
					}// end for
	
	}


		/*
		*  @private
		*  triggers the action on mouse down
		*/
		private function onSubDown(e:MouseEvent) {
				onDownexc(e.target);
		}; // end function
		
		/*
		*  @private
		*  opens the first screen in the lesson when clicked in the tree
		*/
		private function endRun(e:MouseEvent) {

			
			
			CGlobal.islAppRoot.OpenScreenBySrc(e.target.parent.firstPageSrc);
			
			}
		/*
		*  @private
		*  controls the tracking options and states
		*/
		private function trackMe(e:MouseEvent) {
			var ID = e.target.count;
			if(e.target.checked == undefined ||e.target.checked == false){
			e.target.gotoAndPlay("in_progress");
			e.target.checked = true;
			activityArray[ID] = true;
			
			CGlobal.data_store.setPageAction(CGlobal.islAppRoot.Structure_code.getScreenBySrc(e.target.parent.firstPageSrc),1)
			
			
			e.target.parent.parent.parent.parent.finishedLessons++;


			}else{
				if (e.target.parent.parent.parent.parent.finishedLessons > 0){
				e.target.parent.parent.parent.parent.finishedLessons--;}
				e.target.gotoAndStop(2);
				CGlobal.data_store.setPageAction(CGlobal.islAppRoot.Structure_code.getScreenBySrc(e.target.parent.firstPageSrc),0)
				e.target.checked = false;
				activityArray[ID] = false;
			}
			
			e.target.parent.parent.parent.parent.node.counter.htmlText = e.target.parent.parent.parent.parent.finishedLessons + "/" + e.target.parent.parent.parent.parent.activtyCount;

		}
	    /*
		*  @private
		*  rearranges the elements in the tree when necessary
		*/
		private function subrearange(event:Event):void {
			 for(var n:int = 1 ; n <  container.numChildren; n++)
          		  {
					   var _mcM:MovieClip =  container.getChildAt(n);
					   var _mcS:MovieClip =  container.getChildAt(n-1);
					   					  
				  if (_mcS.opend ){
					  _mcM.y = _mcS.y + _mcS.height - 60;
					for(var subn:int = 2 ; subn < _mcS.numChildren; subn++)
					  {
						   var sub_mcM:MovieClip = _mcS.getChildAt(subn);
						   var sub_mcS:MovieClip = _mcS.getChildAt(subn-1);
						   sub_mcM.y = sub_mcS.y + sub_mcS.height + 6 ;
					  }

				  }
				  else{
					  _mcM.y = _mcS.y + 60 - 26;
					  
				  }
				
				} // end for				
		} //end function

		/*
		*  @private
		*  expands all the nodes in the tree at the same time
		*/
		private function ExpandAll(e:MouseEvent) {
				var _myclip:MovieClip = MovieClip( container);	
					for(var i:int = 0 ; i< _myclip.numChildren; i++){
						var _mc = _myclip.getChildAt(i).node.thetxt;
						var ModMc = _myclip.getChildAt(i);
						
						for(var j:int = 1 ; j<ModMc.numChildren ;j++){
							var _smc = ModMc.getChildAt(j).node.thetxt;
							
							expandModules(_smc)
							}
						    expandModules(_mc)
					}
			}

		/*
		*  @private
		*  counting the number of activities
		*/
		private function checkNumOfActivity(e:Event) {
				var _myclip:MovieClip = MovieClip( container);	
					for(var i:int = 0 ; i< _myclip.numChildren; i++){
						var ModMc = _myclip.getChildAt(i);
						for(var j:int = 1 ; j<ModMc.numChildren ;j++){
							var _smc = ModMc.getChildAt(j);
							
							if(_smc.checked == true){
								
								}
							
							}
					}
			}
			
		/*
		*  @private
		*  collapses all the nodes in the tree at the same time
		*/
		
		
	
		
		function emptyChecked(){
			
			
			for (var r in modulesNode) {
				if(hasActivty == "true"){
					for (var l in lessonsNode) {
					if(hasSubActivty == "true"){
				      for(var k in activityNodes) {
					   if(isActivty == "true"){
						   trace("activityNodes "  + sublesson_mc.numChildren);
							sublesson_mc.node.progress_mc.gotoAndStop(2);	
						}//end if 
					   } // end for 3 
					
				     }// end if
				
				
					} // end for 
				} // end if

			} // end for
		
	} // end func
		
		
		

		function call_CollapsAll(e:MouseEvent){
			
			CollapsAll();
			
		}
		
		private function CollapsAll() {
				var _myclip:MovieClip = MovieClip( container);	
					for(var i:int = 0 ; i< _myclip.numChildren; i++){
						var _mc = _myclip.getChildAt(i).node.thetxt;
						var ModMc = _myclip.getChildAt(i);
						
						for(var j:int = 1 ; j<ModMc.numChildren ;j++){
							var _smc = ModMc.getChildAt(j).node.thetxt;
							
							collapseModules(_smc)
							}
						    collapseModules(_mc)
					}
			}		

		
		/*
		*  @public
		*  gets the name of the first screen in the activity
		*/
		function getFirstScreenOfActivity(ActName:String):int{
			for (var b:int=0 ;b<  navData.groupnode.groupnode.groupnode.page.length(); b++) {
						if( ActName ==  navData.groupnode.groupnode.groupnode.page[b].parent().title ){
							return b;
							}
						}  // end for
						return -1;
			}
		}
    }
