﻿/*
 *************************************
 * help component                   
 * version 1.0                       
 *************************************
 */
package 
{
	import flash.display.*;
	import flash.text.*;
	import flash.events.*;
	import flash.net.*;
	import flash.xml.*;

	public class courseHelp extends MovieClip
	{
		
		public var navData:XML;
		public var loader:URLLoader;
		/*
		*  @public
		*  class constructor, activates the close button
		*/
		public function courseHelp()
		{
			button_close.buttonMode = true;
			button_close.mouseChildren = false;

			button_close.addEventListener(MouseEvent.MOUSE_DOWN,CloseComm)
			loadXML();
		}
		/*
		*  @private
		*  closes the component
		*/
		private function CloseComm(e:MouseEvent) {
	       
		   if(CGlobal.islAppRoot){
					   
					   if(CGlobal.islAppRoot.checkFinished){
				  		 CGlobal.islAppRoot.pauseContent(); 
				  		}else{
				  		 CGlobal.islAppRoot.playContent(); 
						}
				  
				  CGlobal.islAppRoot.CloseComponant();
				  }
				  
			}
		/*
		*  @private
		*  loads the components XML file
		*/
		private function loadXML():void
		{
			loader = new URLLoader();
			loader.addEventListener(Event.COMPLETE,completeHandler);
			var request:URLRequest=new URLRequest("component/content_en/help.xml");
			//var request:URLRequest=new URLRequest(CGlobal.content_en+"help.xml");
			try 
			{
				loader.load(request);
			} 
			catch(error:Error) 
			{
				trace('An error occurred when attempting to load the XML.');
			}
		}
		/*
		*  @private
		*  parses the XML data and assigns it to the text labels
		*/
		private function completeHandler(event:Event):void
		{
			navData = new XML(event.target.data);
			// setting the data from xml file 
			button_close.button_text.text = navData.btn[0]
			progress_bar.htmlText = navData.p[0];
			menu_txt.htmlText = navData.p[1];
			help_txt.htmlText = navData.p[2];
			glossary_txt.htmlText = navData.p[3];
			resources.htmlText = navData.p[4];
			action.htmlText = navData.p[5];
			exit.htmlText = navData.p[6];
			body_text.htmlText = navData.p[7];
			title_text.htmlText = navData.p[8];
			audio.htmlText = navData.p[12];
			pause.htmlText = navData.p[13];
			replay.htmlText = navData.p[14];
			next_back.htmlText = navData.p[15];
		}
	}
}