﻿/**
 *  @public
 *  tha main couse class
 *creates the main tree and publish it
 */
package {
	import flash.display.*;
	import flash.events.*;
	import flash.text.*;
	import caurina.transitions.*;
	import flash.net.*;
	import fl.controls.*;
	import flash.text.TextField;
	public class course_menu extends MovieClip {
		/**
		 *@public
		 *defining the main variables that we will need in the menu
		 */
		var navData:XML;
		var opend:Boolean;

		var sublessons:Array = new Array();
		
		var name_con:MovieClip = new MovieClip();
		var container:MovieClip =new MovieClip();
		
		var name_mask:Sprite = new Sprite();
		var nextcar:int;
		var xmlData:XML;
		

		var loader:URLLoader = new URLLoader();
		var ldr:URLLoader = new URLLoader();

		var CTemp:MovieClip;
		var LTemp:MovieClip;
		var LTemp2:MovieClip;
		var ATemp:MovieClip;


		/**
		 *@public
		 *main course menu function
		 *creates and places the main modules and activities tree
		 */
		private function CloseComm(e:MouseEvent) {

			if (CGlobal.islAppRoot) {

				if (CGlobal.islAppRoot.checkFinished) {
						
					CGlobal.islAppRoot.pauseContent();
					
				} else {
				
					CGlobal.islAppRoot.playContent();
				}
				CGlobal.islAppRoot.CloseComponant();
			}
		}
		public function course_menu() {

			
			stop();
			this.focusRect=false;
			
			button_close.buttonMode = true;
			button_close.tabEnabled = false;
			button_close.mouseChildren = false;
			button_close.addEventListener(MouseEvent.MOUSE_DOWN,CloseComm);

			
			loader.addEventListener(Event.COMPLETE, onCMxmlComplete, false, 0, true);
			loader.addEventListener(IOErrorEvent.IO_ERROR, onxmlIOError, false, 0,true);

			click_2.buttonMode = true;
			click_2.tabEnabled = false;
			click_2.mouseChildren = false;
			click_2.addEventListener(MouseEvent.MOUSE_DOWN,aboutProgress);

			click_3.buttonMode = true;
			click_3.tabEnabled = false;
			click_3.mouseChildren = false;
			click_3.addEventListener(MouseEvent.MOUSE_DOWN,reset_menu);

			click_2.addEventListener(MouseEvent.MOUSE_OVER ,buttonsOver);
			click_2.addEventListener(MouseEvent.MOUSE_OUT  ,buttonsOut);

			click_3.addEventListener(MouseEvent.MOUSE_OVER ,buttonsOver);
			click_3.addEventListener(MouseEvent.MOUSE_OUT  ,buttonsOut);


			header.autoSize = "left";
			//header.embedFonts=true;
			header.multiline=true;
			header.wordWrap=true;

			loader.load(new URLRequest("component/content_en/course_menu.xml")); 

			 
			
			/**
			 *@public
			 *on xml loading complete, initializing the menu tree
			 */
		}
		function aboutProgress(et:MouseEvent):void {
			setChildIndex(extra_content , numChildren-1);
			extra_content.gotoAndPlay("about");
		}
		function reset_menu(e:Event) {
			CGlobal.data_store.clearCMenu();
			//notice.gotoAndPlay("go");
			
			buildTree();
			
			
		}
		function reset_activities(){
			while (container.numChildren) {
				container.removeChildAt(0);
			}
			header.htmlText="";
			activities.htmlText="";
			}
		private function buttonsOver(e:MouseEvent) {
			e.target.gotoAndPlay("over");
			e.target.StretchText_txt.textColor = 0xAB004C;
		}
		private function buttonsOut(e:MouseEvent) {
			e.target.gotoAndPlay("out");
			e.target.StretchText_txt.textColor = 0x0B76B4;
		}
		public function onCMxmlComplete(evt:Event):void {

			loader.removeEventListener(Event.COMPLETE, onCMxmlComplete);
			loader.removeEventListener(IOErrorEvent.IO_ERROR,onxmlIOError);
			navData = new XML(evt.target.data);
			
			// setting the labels and titles text
			// **********************************
			heading_text_1.text = navData.p[2];
			notstarted.htmlText = navData.p[4];
			inprogress.htmlText = navData.p[5];
			completed.htmlText = navData.p[6];
			click_2.StretchText_txt.htmlText = navData.p[8];
			click_3.StretchText_txt.htmlText = navData.p[9];

			button_close.button_text.text = navData.btn[0];
			extra_content.close.button_text.text = navData.btn[0];
			extra_content.about_txt.htmlText = navData.p[10];
			notice.note.StretchText_txt.htmlText = "";


			// adding the main container and mask to the stage
			// ***********************************************
			addChild(container);
			container.x =490;
			container.y = 240;
			addChild(name_con);
			name_con.x =65;
			name_con.y = 225;
			with (name_mask.graphics) {
				beginFill(0x000000);
				drawRect(0, 0,814,270);
				endFill();
			}
			addChild(name_mask);
			name_mask.x=name_con.x - 10  ;
			name_mask.y=name_con.y + 20;
			name_con.mask =name_mask;

			// retrieving the shared object
			// initializing the general counter that counts the screens
			// adding listerners to load the tree xml
			ldr.addEventListener(Event.COMPLETE, onStructurexmlComplete, false, 0, true);
			ldr.addEventListener(IOErrorEvent.IO_ERROR, onxmlIOError, false, 0,true);
			ldr.load(new URLRequest("structure.xml"));
			
			// intiating the scroll class
			var scrollC:scrollClass = new scrollClass(this,name_con,name_mask,scrollTrack_mc,scrollCentral,scrollUp_mc,scrollDown_mc);
			scrollC.scrollComponent();
		}
		/**
		 *@public
		 *error function
		 */

		public function onxmlIOError(evt:IOErrorEvent):void {
			
		}
		public function onStructurexmlComplete(evt:Event):void {

			xmlData = new XML(evt.target.data);
			buildTree();
			ldr.removeEventListener(Event.COMPLETE, onStructurexmlComplete);
			ldr.removeEventListener(IOErrorEvent.IO_ERROR,onxmlIOError);
		}
		public function buildTree() {
			

			while (name_con.numChildren) {
				name_con.removeChildAt(0);
			}
			for (var z in name_con) {
				name_con.removeChild(z);
			}
			 reset_activities();

			var generalIndex:int = 0;
			var courseTreeArray:Array = new Array();
			courseTreeArray = CGlobal.data_store.getCourseTree();//courseArray
			


			var modulesNode:XMLList= xmlData.groupnode;
			var subheights  = 0;
			// initiating the modules loop

			for (var r in modulesNode) {
				var menu_mc:Menu_mc = new Menu_mc();
				var lessonsNode:XMLList= xmlData.groupnode[r].groupnode;
				name_con.addChild(menu_mc);
				
								
				menu_mc.node.title.htmlText =modulesNode.title[r];

				menu_mc.node.expandable_mc.gotoAndStop("plus");
				menu_mc.y=60 + (r * 30) + subheights;
				menu_mc.x=15;
				
				// initiating the lessons loop
				var lesTrueNo:int = 0;
				var lesFalseNo:int = 0;

				for (var l in lessonsNode) {
					var activityNodes:XMLList= lessonsNode[l].groupnode;
					var subcontainer:MovieClip =new MovieClip();
					subcontainer.x =0;
					subcontainer.y = 0;
					var submenu_mc:Submenu_mc = new Submenu_mc();
					menu_mc.addChild(submenu_mc);
					submenu_mc.buttonMode = true;
					submenu_mc.tabEnabled = false;
					submenu_mc.mouseChildren = false;
					submenu_mc.title.autoSize = TextFieldAutoSize.LEFT;

					//submenu_mc.title.multiline=true;
					//submenu_mc.title.wordWrap =true;

					submenu_mc.title.htmlText = lessonsNode.title[l];
					submenu_mc.res = modulesNode.title[r] + ", " + lessonsNode.title[l];
					submenu_mc.y= 0;
					submenu_mc.visible = false;
					submenu_mc.x=30;
					submenu_mc.addEventListener(MouseEvent.MOUSE_OVER,onSubOver);
					submenu_mc.addEventListener(MouseEvent.MOUSE_OUT,onSubOut);
					submenu_mc.addEventListener(MouseEvent.MOUSE_DOWN,onSubDown);
					
					// initiating the activities loop
					var actTrueNo:int = 0;
					var actFalseNo:int = 0;
					for (var k in activityNodes) {
						var sublesson_mc:Submenu_mc = new Submenu_mc();
						subcontainer.addChild(sublesson_mc);
						sublesson_mc.buttonMode = true;
						sublesson_mc.tabEnabled = false;
						sublesson_mc.mouseChildren = false;
						sublesson_mc.addEventListener(MouseEvent.MOUSE_OVER,onSubOver);
						sublesson_mc.addEventListener(MouseEvent.MOUSE_OUT,onSubOut);
						sublesson_mc.addEventListener(MouseEvent.MOUSE_DOWN,ActivityDown);
						sublesson_mc.Aname = activityNodes[k].title;
						
										sublesson_mc.title.multiline=true;
					                    sublesson_mc.title.wordWrap =true;


						sublesson_mc.firstScreenIndex = generalIndex ;

						sublesson_mc.title.autoSize==TextFieldAutoSize.LEFT;
						sublesson_mc.title.htmlText = activityNodes[k].title;

						sublesson_mc.y =  30* k;
						sublesson_mc.x = 10;
						
						// initiating the general counter loop
						var trueNo:int = 0;
						var falseNo:int = 0;
						

						for (var scrC:int=0; scrC < activityNodes[k].page.length(); scrC++) {
							var scrState:Object= (courseTreeArray[(generalIndex)]);

							{
								if (scrState.opened == "T") {
									trueNo++;
								}
								if (scrState.opened == "F") {
									falseNo++;
								}
							};
							
							// setting the tracking flags for the activities
							if (trueNo == activityNodes[k].page.length()) {
								sublesson_mc.progress_mc.gotoAndPlay("complete");
								actTrueNo++;

							} else if (falseNo == activityNodes[k].page.length()) {
								sublesson_mc.progress_mc.gotoAndPlay("not_started");
								actFalseNo++;
							} else {
								sublesson_mc.progress_mc.gotoAndPlay("in_progress");
							}
							generalIndex++;
						}
					}
					
					// setting the tracking flags for the lessons

					for (var actC:int=0; actC < lessonsNode[l].groupnode.length(); actC++) {
						if (actTrueNo == lessonsNode[l].groupnode.length()) {
							submenu_mc.progress_mc.gotoAndPlay("complete");
							lesTrueNo++;
						} else if (actFalseNo == lessonsNode[l].groupnode.length()) {
							submenu_mc.progress_mc.gotoAndPlay("not_started");
							lesFalseNo++;
						} else {
							submenu_mc.progress_mc.gotoAndPlay("in_progress");
						}
					}
					submenu_mc.ss = subcontainer;
				}
				
				// setting the tracking flags for the modules
				for (var lesC:int=0; lesC < modulesNode[r].groupnode.groupnode.length(); lesC++) {
					if (lesTrueNo == modulesNode[r].groupnode.groupnode.length()) {
						menu_mc.node.progress_mc.gotoAndPlay("complete");
					} else if (lesFalseNo == modulesNode[r].groupnode.groupnode.length()) {
						menu_mc.node.progress_mc.gotoAndPlay("not_started");
					} else {
						menu_mc.node.progress_mc.gotoAndPlay("in_progress");
					}
				}
				var nclip:Dumy_mc = new Dumy_mc();
				nclip.alpha = 0;
				menu_mc.addChild(nclip);
				menu_mc.node.mouseChildren = false;
				menu_mc.node.buttonMode = true;
				menu_mc.node.tabEnabled = false;
				menu_mc.opend = false;
				menu_mc.node.addEventListener(MouseEvent.MOUSE_OVER,onOver);
				menu_mc.node.addEventListener(MouseEvent.MOUSE_OUT,onOut);
				menu_mc.node.addEventListener(MouseEvent.MOUSE_DOWN,onDown);

			}
		}
		public function UpdateTree() {
			

			var generalIndex:int = 0;
			var courseTreeArray:Array = new Array();
			courseTreeArray = CGlobal.data_store.getCourseTree();//courseArray
			


			var modulesNode:XMLList= xmlData.groupnode;
			var subheights  = 0;
			// initiating the modules loop

			for (var r in modulesNode) {
				var menu_mc:Menu_mc = new Menu_mc();
				var lessonsNode:XMLList= xmlData.groupnode[r].groupnode;
				

				
				menu_mc.node.title.htmlText =modulesNode.title[r];

				menu_mc.node.expandable_mc.gotoAndStop("plus");
				menu_mc.y=60 + (r * 30) + subheights;
				menu_mc.x=15;
				
				// initiating the lessons loop
				var lesTrueNo:int = 0;
				var lesFalseNo:int = 0;

				for (var l in lessonsNode) {
					var activityNodes:XMLList= lessonsNode[l].groupnode;
					var subcontainer:MovieClip =new MovieClip();
					subcontainer.x =0;
					subcontainer.y = 0;
					var submenu_mc:Submenu_mc = new Submenu_mc();
					
					submenu_mc.buttonMode = true;
					submenu_mc.tabEnabled = false;
					submenu_mc.mouseChildren = false;
					submenu_mc.title.autoSize = TextFieldAutoSize.LEFT;

					submenu_mc.title.multiline=true;
					submenu_mc.title.wordWrap =true;

					submenu_mc.title.htmlText = lessonsNode.title[l];
					submenu_mc.res = modulesNode.title[r] + ", " + lessonsNode.title[l];
					submenu_mc.y= 0;
					submenu_mc.visible = false
					submenu_mc.x=30;
					submenu_mc.addEventListener(MouseEvent.MOUSE_OVER,onSubOver);
					submenu_mc.addEventListener(MouseEvent.MOUSE_OUT,onSubOut);
					submenu_mc.addEventListener(MouseEvent.MOUSE_DOWN,onSubDown);
					
					// initiating the activities loop
					var actTrueNo:int = 0;
					var actFalseNo:int = 0;
					for (var k in activityNodes) {
						var sublesson_mc:Submenu_mc = new Submenu_mc();
						
						sublesson_mc.buttonMode = true;
						sublesson_mc.tabEnabled = false;
						sublesson_mc.mouseChildren = false;
						sublesson_mc.addEventListener(MouseEvent.MOUSE_OVER,onSubOver);
						sublesson_mc.addEventListener(MouseEvent.MOUSE_OUT,onSubOut);
						sublesson_mc.addEventListener(MouseEvent.MOUSE_DOWN,ActivityDown);
						sublesson_mc.Aname = activityNodes[k].title;

						sublesson_mc.firstScreenIndex = generalIndex ;

						sublesson_mc.title.autoSize==TextFieldAutoSize.LEFT;
						sublesson_mc.title.htmlText = activityNodes[k].title;

						sublesson_mc.y =  30* k;
						sublesson_mc.x = 0;
						// initiating the general counter loop
						var trueNo:int = 0;
						var falseNo:int = 0;
						

						for (var scrC:int=0; scrC < activityNodes[k].page.length(); scrC++) {
							var scrState:Object= (courseTreeArray[(generalIndex)]);

							{
								if (scrState.opened == "T") {
									trueNo++;
								}
								if (scrState.opened == "F") {
									falseNo++;
								}
							};
							// setting the tracking flags for the activities
							if (trueNo == activityNodes[k].page.length()) {
								sublesson_mc.progress_mc.gotoAndPlay("complete");
								actTrueNo++;

							} else if (falseNo == activityNodes[k].page.length()) {
								sublesson_mc.progress_mc.gotoAndPlay("not_started");
								actFalseNo++;
							} else {
								sublesson_mc.progress_mc.gotoAndPlay("in_progress");
							}
							generalIndex++;
						}
					}
					// setting the tracking flags for the lessons

					for (var actC:int=0; actC < lessonsNode[l].groupnode.length(); actC++) {
						if (actTrueNo == lessonsNode[l].groupnode.length()) {
							submenu_mc.progress_mc.gotoAndPlay("complete");
							lesTrueNo++;
						} else if (actFalseNo == lessonsNode[l].groupnode.length()) {
							submenu_mc.progress_mc.gotoAndPlay("not_started");
							lesFalseNo++;
						} else {
							submenu_mc.progress_mc.gotoAndPlay("in_progress");
						}
					}
					submenu_mc.ss = subcontainer;
				}
				// setting the tracking flags for the modules
				for (var lesC:int=0; lesC < modulesNode[r].groupnode.groupnode.length(); lesC++) {
					if (lesTrueNo == modulesNode[r].groupnode.groupnode.length()) {
						menu_mc.node.progress_mc.gotoAndPlay("complete");
					} else if (lesFalseNo == modulesNode[r].groupnode.groupnode.length()) {
						menu_mc.node.progress_mc.gotoAndPlay("not_started");
					} else {
						menu_mc.node.progress_mc.gotoAndPlay("in_progress");
					}
				}
				var nclip:Dumy_mc = new Dumy_mc();
				nclip.alpha = 0;
				
				menu_mc.node.mouseChildren = false;
				menu_mc.node.buttonMode = true;
				menu_mc.node.tabEnabled = false;
				menu_mc.opend = false;
				menu_mc.node.addEventListener(MouseEvent.MOUSE_OVER,onOver);
				menu_mc.node.addEventListener(MouseEvent.MOUSE_OUT,onOut);
				menu_mc.node.addEventListener(MouseEvent.MOUSE_DOWN,onDown);

			}
		}
		/*
		 *@public
		 *getting the first screen in the activity
		 */
		public function GetFirstScreenOfActivity(ActName:String):int {
			
			for (var b:int=2; b< xmlData.groupnode.groupnode.groupnode.page.length(); b++) {
				if ( ActName == xmlData.groupnode.groupnode.groupnode.page[b].parent().title ) {
					return b;
				}
			}
			return -1;
		}
		/**
		 *@public
		 *a group of function to set the text colors of the over and out effects
		 */
		public function onOver(e:MouseEvent) {
			e.target.title.textColor = 0x0066FF;
		}
		public function onSubOver(e:MouseEvent) {
			e.target.title.textColor = 0x0066FF;
		}
		public function onOut(e:MouseEvent) {
			e.target.title.textColor = 0x333333;
		}
		public function onSubOut(e:MouseEvent) {
			e.target.title.textColor = 0x333333;
		}
		/**
		 *@public
		 *setting the plus and minus mark on tree collapse and expand
		 */
		public function onDown(e:MouseEvent) {

			var _myclip:MovieClip = MovieClip(e.target.parent);
			var wrapH:int = 0;
			CTemp = e.target;
			var countH =0;
			if (_myclip.opend == false) {//menu_mc
				for (var i:int = 1; i< _myclip.numChildren; i++) {
					var _mc:MovieClip = _myclip.getChildAt(i);
					var hh = _mc.height;

					_myclip.node.expandable_mc.gotoAndStop("minus");

					if (_mc.height == 17) {
						_mc.height = 30;
						
					}
					_mc.visible = true;
					_mc.y = countH;
					countH+= _mc.height + 4;

					_myclip.opend = true;

					
					
					if (_mc.title) {
						
						
					}
				}
			} else if (_myclip.opend == true) {// menu_mc

				for (i = 1; i< _myclip.numChildren; i++) {
					_mc = _myclip.getChildAt(i);
					
					
					_myclip.node.expandable_mc.gotoAndStop("plus");
					_mc.visible = false;
					_mc.y = 0;
					if (_mc.height > 20) {
						
						
						_mc.height = 17;
						
					}

					_myclip.opend = false;

					

					if (_mc.title) {
						
						
					}
				}
			}
			this.addEventListener(Event.ENTER_FRAME , rearange);
		}
		/**
		 *@public
		 *setting the activity text
		 */
		public function onSubDown(e:MouseEvent) {
			if (LTemp) {
				LTemp.title.textColor = 0x333333;
			}
			LTemp = e.target;
			e.target.title.textColor = 0x99CC00;

			activities.htmlText = navData.p[3];
			header.htmlText =  e.target.res;
			var gg:MovieClip = e.target.ss as MovieClip;
			while (container.numChildren) {
				container.removeChildAt(0);
			}
			container.addChild(gg);
			e.target.removeEventListener(MouseEvent.MOUSE_OVER,onSubOver);
			e.target.removeEventListener(MouseEvent.MOUSE_OUT,onSubOut);
		}
		/**
		 *@public
		 *loading the first screen of the activity when clicked
		 */
		public function ActivityDown(e:MouseEvent) {





			if (ATemp) {
				ATemp.title.textColor = 0x333333;
			}
			if (LTemp2) {

				LTemp2.title.textColor = 0x333333;
			}
			if (LTemp) {

				LTemp.title.textColor = 0x333333;
				LTemp2 = LTemp;
			}
			if (CTemp) {
				CTemp.title.textColor = 0x333333;
			}

			ATemp = e.target;
			
			
			ATemp.title.textColor = 0xAB004C;
			LTemp.title.textColor = 0xAB004C;
			CTemp.title.textColor = 0xAB004C;

			if (CGlobal.islAppRoot) {
				CGlobal.islAppRoot.ClearComponant();
			}
			var FScreen:String = CGlobal.islAppRoot.Structure_code.XMLData.groupnode.groupnode.groupnode.page[0].@src.toString();
			if (CGlobal.islAppRoot.Structure_code.XMLData.groupnode.groupnode.groupnode.page[e.target.firstScreenIndex].@src.toString() == FScreen) {
				CGlobal.islAppRoot.OpenScreen(2);
			} else {

				CGlobal.islAppRoot.OpenScreen(e.target.firstScreenIndex);
			}
			CTemp.removeEventListener(MouseEvent.MOUSE_OVER,onOver);
			CTemp.removeEventListener(MouseEvent.MOUSE_OUT,onOut);

			e.target.removeEventListener(MouseEvent.MOUSE_OVER,onSubOver);
			e.target.removeEventListener(MouseEvent.MOUSE_OUT,onSubOut);

		}
		/**
		 *@public
		 *rearranging the tree items inside the main container
		 */
		public function rearange(event:Event):void {

			for (var n:int = 1; n < name_con.numChildren; n++) {
				var _mcM:MovieClip = name_con.getChildAt(n);
				var _mcS:MovieClip = name_con.getChildAt(n-1);
				_mcM.y = _mcS.y + _mcS.height - 22;




			}
		}
	}
}