﻿/*
 *************************************
 * end session component                     
 * version 1.0                       
 *************************************
 */
package 
{
	import flash.display.*;
	import flash.text.*;
	import flash.events.*;
	import flash.net.*;
	import flash.xml.*;
	import flash.system.*;
	
	public class exitCourse extends MovieClip
	{
		public var navData:XML;
		public var loader:URLLoader;
		public var exitAfterPutparam:Boolean = false;
		/*
		*  @public
		*  activating the component buttons and adding the listeners
		*/
		public function exitCourse()
		{  
		    // call xml data
			
			
			button_exitCourse.buttonMode = true;
			button_exitCourse.mouseChildren = false;
			
			button_close.buttonMode = true;
			button_close.mouseChildren = false;
			
			button_exitCourse.addEventListener(MouseEvent.MOUSE_OVER,onOver);
			button_exitCourse.addEventListener(MouseEvent.MOUSE_OUT,onOut);
			button_exitCourse.addEventListener(MouseEvent.MOUSE_DOWN,exitCourseware);

			button_close.addEventListener(MouseEvent.MOUSE_DOWN,CloseComm);
			button_close.addEventListener(MouseEvent.MOUSE_OVER,onOver);
			button_close.addEventListener(MouseEvent.MOUSE_OUT,onOut);
			loadXML();
		}
		/*
		*  @private
		*  closes the component
		*/
		private function CloseComm(e:MouseEvent) {
				
				if(CGlobal.islAppRoot){
				  CGlobal.islAppRoot.playContent();
				  CGlobal.islAppRoot.CloseComponant(); 
				  }
			}
		/*
		*  @private
		*  loads the component XML file
		*/
		private function loadXML():void
		{			
			loader = new URLLoader();
			loader.addEventListener(Event.COMPLETE,completeHandler);
			 
			var request:URLRequest= new URLRequest("component/content_en/exit_dlg.xml");
			//var request:URLRequest= new URLRequest(CGlobal.content_en+"exit_dlg.xml");
			try 
			{
				loader.load(request);
			} 
			catch(error:Error) 
			{
				trace('An error occurred when attempting to load the XML.');
			}
		}
		/*
		*  @private
		*  loading the data from the XML and setting the exit message text
		*/
		private function completeHandler(event:Event):void
		{
			navData = new XML(event.target.data);
			// setting the data from xml file
			msg.StretchText_txt.htmlText = navData.p[1];
			button_exitCourse.prompt_text_1_COMP.StretchText_txt.htmlText = navData.btn[0];
			button_close.prompt_text_1_COMP.StretchText_txt.htmlText = navData.btn[1];
		
			loader.removeEventListener(Event.COMPLETE, completeHandler);
		}
		
		/*
		*  @private
		*  changes state with mouse over
		*/
		private function onOver(e:MouseEvent) {
				e.target.gotoAndPlay("over");
			}
		/*
		*  @private
		*  changes state with mouse out
		*/
		private function onOut(e:MouseEvent) {
				e.target.gotoAndPlay("out");
			}

		/*
		*  @private
		*  ending session through a framework function
		*/
		private function exitCourseware(e:MouseEvent)
		{
			trace(CGlobal.islAppRoot.islSettings.delivery);
			if (CGlobal.islAppRoot.islSettings.delivery == "cd" || CGlobal.islAppRoot.islSettings.delivery == "exe")
			{
				fscommand("quit");
			}
			else if (CGlobal.islAppRoot.islSettings.delivery == "scorm")
			{
				//navigateToURL(new URLRequest("javascript:exitSCO()"));
				navigateToURL(new URLRequest("javascript:top.window.close()"));
			}
			else if (CGlobal.islAppRoot.islSettings.delivery == "aicc" || CGlobal.islAppRoot.islSettings.delivery == "aicc_hacp")
			{
				//exitButtonPressed();
			}
			else
			{
				navigateToURL(new URLRequest("javascript:top.window.close()"));
			} // end else if
		} // End of the function
				
		
		/*
		*  @private
		*  saving parameters and exiting
		*/
		private function exitButtonPressed()
		{
			CGlobal.islAppRoot.functionTrace("framework (AICC Frame) :: exitButtonPressed()");
			exitAfterPutparam = true;
			putParam();
		} // End of the function
				



	}
}