﻿/*
 *************************************
 * glossary component                     
 * version 1.0                       
 *************************************
 */
package 
{
	import flash.display.*;
	import flash.text.*;
	import flash.events.*;
	import flash.net.*;
	import flash.xml.*;

	public class glossary extends MovieClip
	{
		public var name_con:MovieClip;
		public var name_mask:Sprite;
		public var navData:XML;
		public var nextcar:int;
		public var loader:URLLoader;
		public var ttt:Boolean = false;

		public function glossary()
		{
			// call xml data
			loadXML();
			// container that carry all the glossary definition
			name_con  = new MovieClip();
			name_mask = new Sprite();

			addChild(name_con);
			name_con.x =155;
			name_con.y = 205;

			
			 
			with (name_mask.graphics)
			{
				beginFill(0x000000);
				drawRect(0, 0,329,300);
				endFill();
			}
			addChild(name_mask);
			name_mask.x=name_con.x+22 ;
			name_mask.y=name_con.y+15;
			name_con.mask =name_mask;
			
		    //calling the scroll bar class
			var scrollC:scrollClass = new scrollClass(this,name_con,name_mask,scrollTrack_mc,scrollCentral,scrollUp_mc,scrollDown_mc);
			scrollC.scrollComponent();
			

		}
		
		private function loadXML():void
		{
			loader = new URLLoader();
			loader.addEventListener(Event.COMPLETE,completeHandler);
			var request:URLRequest=new URLRequest("component/content_en/glossary.xml");
			
			try
			{
				loader.load(request);
			}
			catch (error:Error)
			{
			}
		}
		private function completeHandler(event:Event):void
		{
			
			button_close.buttonMode = true;
			button_close.mouseChildren = false;

			button_close.addEventListener(MouseEvent.MOUSE_DOWN,CloseComm)
			navData = new XML(event.target.data);
			
			title.text = navData.p[0];
			find.text = navData.p[1];
			button_close.close_btn.text = navData.btn;
			
			stage.addEventListener(Event.ENTER_FRAME , enterFrameSearch_xml);
			search.addEventListener(Event.CHANGE,textInputHandler);
			loader.removeEventListener(Event.COMPLETE, completeHandler);

		}
	   /*
		**@public function for showin result of the definistion founded in screens 
		*/
		
		
		
		
		
		
		
		function glossaryReset(){
			
			
		while (name_con.numChildren)
			{
				name_con.removeChildAt(0);
				result.htmlText ="";
				search.text ="";
			}
			
				
			var tx:String =search.getLineText(0).toString();
			nextcar = tx.length;
			
		}
		
		
		
		private function CloseComm(e:MouseEvent) {
			
				if(CGlobal.islAppRoot){
					   
					   if(CGlobal.islAppRoot.checkFinished){
				  		 CGlobal.islAppRoot.pauseContent(); 
				  		}else{
				  		 CGlobal.islAppRoot.playContent(); 
						}
					 if(ttt){
					glossaryReset();
					ttt = false;
					 }
						
				  CGlobal.islAppRoot.CloseComponant();
				  }
				  
		}
	   public function launch_glossary_def(def:String):void {
			
			
			ttt = true;
			
					search.text = def;
					def = "";

					while (name_con.numChildren)
					{
						name_con.removeChildAt(0);
						result.htmlText ="";
					}
					
					var tx:String =search.getLineText(0).toString();
					nextcar = tx.length;
					
		
		}
		/*
		**@private function to seach foe the difinition that user input
		*/
		
		private function enterFrameSearch_xml(event:Event):void
		{
			
			
			
			
			
			if(CGlobal.glossary_def && CGlobal.glossary_def!="")
			{
				launch_glossary_def(CGlobal.glossary_def)
				tempStr=CGlobal.glossary_def;
				CGlobal.glossary_def="";
				
				search_xml();
			}
			else if (tempStr!=search.text){
				tempStr=search.text;
				search_xml();				
			}
		}
		var tempStr:String="??";
		
		private function search_xml():void
		{
			try{
			
			{
			
			//list of the difintion calling it by character one by one 
			var resultNode:XMLList= navData.glossary_list.word.((name.substr(0,nextcar).toLowerCase()).match((search.text).toLowerCase()));
				var tempItem:int=20;
				for (var r in resultNode)
				{
					var over:Over = new Over();
					over.over_in.visible =false;
					over.Arrow.visible =false;
					over._txt.multiline=true;
					over._txt.autoSize=TextFieldAutoSize.CENTER;
					over._txt.htmlText =resultNode.name[r];

					over.res = resultNode.definition[r];
					
					over.mouseChildren = false;
					//over.buttonMode = true;

					over.addEventListener(MouseEvent.MOUSE_DOWN,onDown);

					over.y=(tempItem);
					
					over.x=20;
					over.over_in.height=over.height;
					tempItem=over.y+over.height;
					name_con.addChild(over);

				}
			}
			
			result.htmlText = ""
			//if(resultNode.name[r].toLowerCase()==search.text.toLowerCase())
			{
				if(name_con.getChildAt(0))
				{
					
				name_con.getChildAt(0).Arrow.visible =true;
				name_con.getChildAt(0).over_in.visible =true;
				name_con.getChildAt(0)._txt.textColor = 0xffffff;
				result.htmlText =name_con.getChildAt(0).res;
				}
			}
			
			}
			catch(e:Error){
				
			}
			 
		}
		
		var tempLastMovie:MovieClip;
		private function onDown(e:MouseEvent)
		{
			
			
			for( var i = 0; i< name_con.numChildren ; i++)
			{
				name_con.getChildAt(i)._txt.textColor = 0x000000;
				name_con.getChildAt(i).over_in.visible =  false;
				name_con.getChildAt(i).Arrow.visible =false;
			}
			
			
			
			if(tempLastMovie)
			{
				
				tempLastMovie._txt.textColor = 0x000000;
				tempLastMovie.over_in.visible =  false;
				tempLastMovie.Arrow.visible =false;
			}
			
			if(!e.target.Arrow.visible)
			{
			//search.text=e.target._txt.text.toUpperCase().substring(0,1)+e.target._txt.text.toLowerCase().substring(1) ;
			
			tempLastMovie=e.target;
			e.target.Arrow.visible =true;
			e.target.over_in.visible =  true;
			e.target._txt.textColor = 0xffffff;
			result.htmlText =e.target.res;
			}
		}
		/*
		** @private function to clear all the difintion and set the only word that match the user 
		** typed 
		*/
		private function textInputHandler(event:Event)
		{
			while (name_con.numChildren)
			{
				name_con.removeChildAt(0);
			}
			var tx:String =search.getLineText(0).toString();
			nextcar = tx.length;
			
			stage.addEventListener(Event.ENTER_FRAME , enterFrameSearch_xml);
		}
	}
}