﻿/**
*  this class handles the shared objects
*  the class gets the shared object, creating it if it doesn't exist
*/
package {
	import flash.net.*;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	public class intSharedObject extends Sprite {
		/**
		 *  @public
		 *  hold the main framework referance
		 */
		var userData_so:SharedObject;
		/**
		 *  @public
		 *  hold the main framework referance
		 */

		/**
		 *  @public function
		 *  class constructor
		 */
		public function intSharedObject() {
			
			getSO();
		}
		
		 /**
		 *  @public function
		 *  gets the shared object and returns it to the framework
		 */
		public function getSO():SharedObject {
				/**
				 *  fetching the shared object and assigning it to the variable
				 */
				
				var cLoc:String = "courseArray_" + CGlobal.islAppRoot.islSettings.XMLData.@courseLoc.toString();				
			    userData_so = SharedObject.getLocal(cLoc,"/");
								
				
				getCourseArraySO();
				return (userData_so);
		}		
		public function setSO(soName:String, arrayToSet:Array):SharedObject {
			/**
		 	 *  setting the shared object and assigning it to the variable
		 	 */
			 
			userData_so = SharedObject.getLocal(soName,"/");
			userData_so.data.arrayToSet
			userData_so.close();
			return (userData_so);
		}
		public function getActivitiesCount(Module:int):int
		{
			
			Module=CGlobal.islAppRoot.Structure_code.XMLData.groupnode.groupnode.groupnode.page[CGlobal.islAppRoot.CurrentScreenID].parent().parent().parent().childIndex()-1;
			

			var Li:XMLList=CGlobal.islAppRoot.Structure_code.XMLData.groupnode[Module].groupnode.groupnode;
			
			var count:int=0;
			for(var ii:int=0;ii<Li.length();ii++)
			{
				
				if(Li[ii].@activity && Li[ii].@activity.toString()== "true")
				{
					
					count+=getPageAction(CGlobal.islAppRoot.Structure_code.getScreenBySrc(Li[ii].page[0].@src)) 
				}
				
			}
			return count;
			
			
		}
		public function getActivitiesTotal(Module:int):int
		{
			
			Module=CGlobal.islAppRoot.Structure_code.XMLData.groupnode.groupnode.groupnode.page[CGlobal.islAppRoot.CurrentScreenID].parent().parent().parent().childIndex()-1;
			var Li:XMLList=CGlobal.islAppRoot.Structure_code.XMLData.groupnode[Module].groupnode.groupnode;
			
			var count:int=0;
			for(var ii:int=0;ii<Li.length();ii++)
			{

				
				if(Li[ii].@activity && Li[ii].@activity.toString()== "true")
					count++; 
			}
			return count;
		}
		public function saveUserData()
		{
			
			CGlobal.islAppRoot.functionTrace("framework_tracking.as :: saveUserData");
			if (CGlobal.TrackedCourse == true)
			{
				CGlobal.islDebug("SaveUserData(). SuspendData= " + islSuspendData);
				islProgressString = "";
				for (var _loc1 = 0; _loc1 < courseTrackingStringsArray.length; ++_loc1)
				{
					islProgressString = islProgressString + (CGlobal.islAppRoot[courseTrackingStringsArray[_loc1]] + "@");
					islTrackingStringArray = courseTrackingStringsArray.toString();
				} // end of for
				islActivityArray = action_plan.activities_arr.toString();
				islScore = scoreArray.toString();
				CGlobal.islAppRoot.islSuspendData = escape(islProgressString + "***" + islTrackingStringArray);
				CGlobal.islAppRoot.islSuspendData = islProgressString + "***" + islTrackingStringArray + "***" + islActivityArray + "***" + islScore;
				CGlobal.islAppRoot.debugger_mc.suspend_text.htmlText = CGlobal.islSuspendData;
				
				if (CGlobal.islAppRoot.islSettings.delivery == "aicc_hacp" || CGlobal.islAppRoot.islSettings.delivery == "scorm" || CGlobal.islAppRoot.islSettings.delivery == "custom")
				{
					checkCourseProgress();
				}
				else if (CGlobal.islAppRoot.islSettings.delivery == "local" || CGlobal.islAppRoot.islSettings.delivery == "cd" || CGlobal.islAppRoot.islSettings.delivery == "asp")
				{
					saveLocalCookie();
				} // end if
			} // end else if
		} // End of the function

		


		public function saveLocalCookie()
		{
			
			CGlobal.islAppRoot.functionTrace("framework_tracking.as :: saveLocalCookie");
			userData_so.data.islSuspendData = CGlobal.islAppRoot.islSuspendData;
			userData_so.data.islLessonLocation = CGlobal.islAppRoot.islBookmarkTracker;

			var _loc1 = userData_so.flush();
			
			if (_loc1 == true)
			{
			}
			else if (_loc1 == "pending")
			{
			}
			else if (_loc1 == false)
			{
				System.showSettings(1);
			} // end else if
			
			
		} // End of the function
		public function readUserData() {
			
			
		}
		
		public function getCourseTree():Array {
			
			/**
		 	 *  fetching the course tree shared object and assigning it to the variable
		 	 */
			
			var returnArray:Array = new Array();
			
			returnArray = userData_so.data.courseTreeArray;
			
			return (userData_so.data.courseTreeArray);
		}
				
		public function setCourseTree(soName:String, incomingArray:Array):void {
			
			/**
		 	 *  setting the shared object and assigning the variables
		 	 */
			userData_so = SharedObject.getLocal(soName,"/");
			userData_so.data.courseTreeArray = incomingArray;
			userData_so.close();
		}
		

		/**
		 *  @public function
		 *  creates  and returns the shared object "courseArray"
		 */
		public function getCourseArraySO():SharedObject {
			
			/**
			 *  @private
			 *  a temporary holder for the newly created course array
			 */
			var courseTrack:Array = new Array();
			/**
			 *  creating the course array
			 */
			if (userData_so.data.courseTreeArray==undefined) {
				
 				for (var cA:int=0; cA <= CGlobal.islAppRoot.Structure_code.XMLData.children().children().children().page.length()-1; cA++) {
					courseTrack.push(new Object());
					courseTrack[cA].opened = "F";
				}

				userData_so.data.courseTreeArray = courseTrack;
			}
			else
			{
								
				}
			return (userData_so);
		}
		

		

		public function setScreenAsTrue(screenID:int):void{
			
			if (userData_so.data.courseTreeArray){
				
				userData_so.data.courseTreeArray[(screenID)].opened = "T";
				userData_so.flush();
			}
		}
		public function setPageAction(screenID:int,result:int):void{
			
			if (userData_so.data.courseTreeArray){
				userData_so.data.courseTreeArray[screenID].Action= result;
				userData_so.flush();
			}
			
		}
		public function getPageAction(screenID:int):int{
			
			if (userData_so.data.courseTreeArray){
				if(userData_so.data.courseTreeArray[(screenID)].Action)
				{
					return userData_so.data.courseTreeArray[(screenID)].Action;
				}
			}
			return 0;
		}
		
		public function setPageResult(screenID:int,result:int):void{
			
			if (userData_so.data.courseTreeArray){
				
				userData_so.data.courseTreeArray[(screenID)].result = result;
				
			}
			
		}
		
		public function clearAction(){
			if (userData_so.data != null)
				{
				for(var i=0;i<userData_so.data.courseTreeArray.length;i++ ){
							setPageAction(i,0);
							if(userData_so.data.myResult){
							userData_so.data.myResult[i]=false;
							}
							
						}
				}
				
		}
		
		public function clearCMenu(){
				
				for (var cA:int=0; cA <= CGlobal.islAppRoot.Structure_code.XMLData.children().children().children().page.length()-1; cA++) {
					userData_so.data.courseTreeArray[(cA)].opened = "F";
					userData_so.flush();
				}

				 userData_so =getCourseArraySO();
		}


		public function getPageResult(screenID:int):int{
			
			if (userData_so.data.courseTreeArray){
				
				if(userData_so.data.courseTreeArray[(screenID)].result != null || userData_so.data.courseTreeArray[(screenID)].result != undefined)
				{
					
					return userData_so.data.courseTreeArray[(screenID)].result;
				}
				
				
			}
			return -1;
		}
	}
}