﻿// use  pbl_m1_l1_a3_05.fla 
/*
*  @public
*  a class responsible for multi-choice questions
*/

package {
	import flash.display.MovieClip;
	import flash.display.*;
	import flash.text.*;
	import flash.media.*
	import flash.net.*;
	import flash.events.*;
	import flash.xml.*;
	//import OptionControl;	
	public class question_mc extends MovieClip {

		public var localContentLevel:MovieClip;
		public var total_options:Number;
		public var correct_options:Array;
		public var total_correct_options:Number;
		public var total_options_clicked:Number;
		public var total_points_possible:Number;
       // public var question_generic_lib:QuestionGeneric;
//		public var button_code_lib:Button_Code;
		//private var islAppRoot:Object;
		//public  var global:Object;

		/*
		*  @public
		*  class constructor
		*/
		public function question_mc()
		{
				
		}
		/*
		*  @public
		*  initiating the question
		*/
		public function initMCQuestion()
				{
					//global = new Object();
				//islAppRoot = new Object();
				//localContentLevel = CGlobal.content_mc;
				//localContentLevel = question_generic_lib.contentLevel;
				
				CGlobal.question_generic_lib.initQuestionScreen(); //Pinding
				localContentLevel = CGlobal.question_generic_lib.contentLevel;
				initAQL();
				initsettingsQMC();
				if (localContentLevel.auto_create == "on" || localContentLevel.auto_create == "delayed")
				{
					autoGenerateOptions();
				}  //end if
				if (localContentLevel.randomise_option_positioning == "on")
				{
					CGlobal.question_generic_lib.randomiseOptionPositioning();
				} // end if
				if (localContentLevel.auto_create == "on" || localContentLevel.auto_create == "delayed" || localContentLevel.randomise_option_positioning == "on")
				{
					autoPositionOptions();
				} // end if
				initScreenItems();
				initOptionFunctionality();
				} // End of the function
			
			/*
			*  @public
			*  initiating the general default settings for the questions
			*/
			function initsettingsQMC()
			{
				// trace(localContentLevel.retry_button + " retry_button");
				localContentLevel.total_options = localContentLevel.aOptions.length;
				localContentLevel.correct_options = new Array();
				//trace(localContentLevel)
				//trace(localContentLevel.correct_answer+"DDDDDDDDDDDDDDD")
				localContentLevel.correct_options = localContentLevel.correct_answer.split(",");
				localContentLevel.total_correct_options = localContentLevel.correct_options.length;
				localContentLevel.total_options_clicked = 0;
				localContentLevel.total_points_possible = localContentLevel.total_points_possible + localContentLevel.total_correct_options;
				if (localContentLevel.max_attempts == 1)
				{
					if(localContentLevel.retry_button)
					localContentLevel.retry_button.visible = false;
				} // end if
			} // End of the function
			/*
			*  @public
			*  loading answer options
			*/
			function autoGenerateOptions()
			{
				//trace(localContentLevel.total_options);
				for (var loc1 = 1; loc1 <= localContentLevel.total_options; ++loc1)
				{
					//localContentLevel["option" + loc1]=new OptionControl();
					//trace("totalFrames  "+localContentLevel["option" + loc1].totalFrames);
					
					localContentLevel["option" + loc1].addEventListener(Event.COMPLETE,OptionLoaded)
					function OptionLoaded(e:Event){
						trace("OptionLoaded"+e.target.totalFrames)
					
					}
					
					
					//duplicateMovieClip(localContentLevel.option, "option" + loc1, 1050 + loc1);
					localContentLevel.addChild(localContentLevel["option" + loc1]);
					//trace("aaaaaaaa"+ localContentLevel["option" + loc1]);
					if (localContentLevel.randomise_option_positioning == "on")
					{
						localContentLevel["option" + loc1].visible = false;
					} // end if
				} // end of for
				//trace(localContentLevel.option);
				localContentLevel.option.visible = false;
			} // End of the function
			
			/*
			*  @public
			*  positioning the options
			*/
			function autoPositionOptions()
			{
				autoPostioning();
			} // End of the function
			/*
			*  @public
			*  positioning the options in random order, automatically generated each time
			*/
			function autoPostioning()
			{
				var loc3;
				var loc2;
				for (var loc1 = 0; loc1 < localContentLevel.total_options; ++loc1)
				{
					
					if (CGlobal.question_generic_lib.randomOrder.length > 1)
					{
						loc3 = CGlobal.question_generic_lib.randomOrder[loc1];
						if (loc1 != 0)
						{
							loc2 = CGlobal.question_generic_lib.randomOrder[loc1 - 1];
						}
						else
						{
							loc2 = 0;
						} // end else if
					}
					else
					{
						loc3 = loc1 + 1;
						loc2 = loc1;
					} // end else if
					if (loc2 != 0)
					{
						if (loc1 != 0)
						{
							trace("totalFrames  "+localContentLevel["option" + loc1].totalFrames);
							localContentLevel["option" + loc3].y = localContentLevel["option" + loc2].y + localContentLevel["option" + loc2].option_hitArea.height + localContentLevel.option_v_spacer;
						} // end if
					}
					else
					{
						//trace(localContentLevel.optionnn.y);
						localContentLevel["option" + loc3].y = localContentLevel.option.y;
						
					} // end else if
					localContentLevel["option" + loc3].x = localContentLevel.option.x; 
					localContentLevel["option" + loc3].visible = true;
				} // end of for
			} // End of the function
			/*
			*  @public
			*  initiating the buttons and options on the screens
			*/
			function initScreenItems()
			{
				CGlobal.button_code_lib.deactivateButton(localContentLevel.evaluator_button);
				CGlobal.button_code_lib.deactivateButton(localContentLevel.retry_button);
				localContentLevel.depthCounter = 1100;
				for (var loc2 = 1; loc2 <= localContentLevel.total_options; ++loc2)
				{
					 //trace("aaaaaaaaa " + localContentLevel["option" + loc2]);
					localContentLevel["option" + loc2].selected = false;
					localContentLevel["option" + loc2].option_icon.gotoAndStop("up");
				} // end of for
				//islDebug("islAppRoot.islSettings[\"debug\"]: " + islAppRoot.islSettings.debug);
				if (true || CGlobal.islAppRoot.islSettings.debug == 1) //pinding
				{
					for (var loc22 = 1; loc22 <= localContentLevel.total_options; ++loc22)
					{
						//localContentLevel["option" + loc22].debug_indicator.gotoAndStop("incorrect");
					} // end of for
					for (var loc111 = 0; loc111 < localContentLevel.correct_options.length; ++loc111)
					{
						//localContentLevel["option" + localContentLevel.correct_options[loc111]].debug_indicator.gotoAndStop("correct");
					} // end of for
				} // end if
			} // End of the function
/*
*  @public
*  initiating the basic options settings
*/
function initOptionFunctionality() {
	for (var loc2 = 1; loc2 <= localContentLevel.total_options; ++loc2) {
		localContentLevel["option" + loc2].tabEnabled = false;
		localContentLevel["option" + loc2].buttonMode = true;
		localContentLevel["option" + loc2].mouseChildren = false;
		localContentLevel["option" + loc2].addEventListener(MouseEvent.MOUSE_DOWN,buttonDown);


		/*
		*  @public
		*  setting the attributes and counters when a button is clicked
		*/
		function buttonDown(e:MouseEvent) {
			if(e.target.buttonMode == false) return;
			if (localContentLevel.question_type == "SAMC" || localContentLevel.question_type == "SAMC_IF") {
				if (e.target != localContentLevel.current_option) {
					resetOptions();
					localContentLevel.current_option = e.target;
					localContentLevel.option_chosen = e.target.name.substr(6);
				}// end if
			}// end if
			if (!e.target.selected) {
				if (localContentLevel.question_type == "MAMC") {
					++localContentLevel.total_options_clicked;
				} else {
					localContentLevel.total_options_clicked = 1;
				}// end else if
				e.target.selected = true;
				e.target.option_icon.gotoAndPlay("down");
			} else if (localContentLevel.question_type == "MAMC") {
				--localContentLevel.total_options_clicked;
				e.target.selected = false;
				e.target.option_icon.gotoAndStop("up");
			}// end else if
			//trace("localContentLevel.total_options_clicked : " + localContentLevel.total_options_clicked);
			if (localContentLevel.total_options_clicked > 0) {
				//trace("activate ok btn");
				CGlobal.button_code_lib.activateButton(localContentLevel.evaluator_button);
			} else {
				CGlobal.button_code_lib.deactivateButton(localContentLevel.evaluator_button);
			}// end else if
		}// end reset

		if (localContentLevel.option_popup == "on") {
			//trace(localContentLevel["option" + loc2] +  " localContentLevel")
			localContentLevel["option" + loc2].buttonMode = true;
			localContentLevel["option" + loc2].mouseChildren = false;
			localContentLevel["option" + loc2].addEventListener(MouseEvent.MOUSE_OVER,onOver);
			function onOver(e:MouseEvent) {
				if(e.target.buttonMode == false) return;
				++localContentLevel.depthCounter;
				//this.swapDepths(localContentLevel.depthCounter);
            
				//setChildIndex(e.target,localContentLevel.depthCounter);
				
				//trace(e.target.parent.name)

				e.target.option_popup.gotoAndPlay("on");
				if (localContentLevel.popupAudio == "on") {
					CGlobal.audio_code_lib.extraAudioPlay(e.target.name);
				}// end if
			}//  end onOver 
			localContentLevel["option" + loc2].addEventListener(MouseEvent.ROLL_OUT,onOut);
			function onOut(e:MouseEvent) {
				e.target.option_popup.gotoAndPlay("off");
				if (localContentLevel.popupAudio == "on") {
					CGlobal.audio_code_lib.extraAudioStop(e.target.name);
				}// end if

			}// end onOut 
		}// end if  
	}// end of for
}// End of the function
			
			
			/*
			*  @public
			*  assigning the current stage to the global aql
			*/
			function initAQL(){
				
				CGlobal.aql = this;
				//trace(CGlobal.aql + " ffff");
			}

			/*
			*  @public
			*  reseting all the options to their original slots
			*/
			function resetOptions()
			{
				for (var loc1 = 1; loc1 <= localContentLevel.total_options; ++loc1){
					localContentLevel["option" + loc1].option_icon.gotoAndStop("up");
					if(localContentLevel["option" + loc1].option_bg)
					localContentLevel["option" + loc1].option_bg.gotoAndStop("up");
					localContentLevel["option" + loc1].selected = 0;
					//localContentLevel["option" + loc1].enabled = true;
					localContentLevel["option" + loc1].buttonMode = true;
					
				} // end of for
			} // End of the function
			/*
			*  @public
			*  deactivating all options
			*/
			function disableOptions()
			{
				for (var loc1 = 1; loc1 <= localContentLevel.total_options; ++loc1)
				{
					//localContentLevel["option" + loc1].enabled = false;
					localContentLevel["option" + loc1].buttonMode = false;
				} // end of for
			} // End of the function
/*
*  @public
*  checking the answers against the right answers and evaluating whether it's right or wrong answers
*/
function evaluateAnswer() {
	trace("localContentLevel" + localContentLevel.total_options);
	localContentLevel.total_correct = 0;
	
	localContentLevel.total_selected = 0;
	for (var loc2 = 1; loc2 <= localContentLevel.total_options; ++loc2) {
		trace("localContentLevel['option' + loc2]"+localContentLevel["option" + loc2]);
		if (localContentLevel["option" + loc2].selected) {
			++localContentLevel.total_selected;
			for (var loc1 = 0; loc1 <= localContentLevel.correct_options.length; ++loc1) {
				trace ("localContentLevel.correct_options[loc1]" +localContentLevel.correct_options[loc1]);
				if (loc2 == localContentLevel.correct_options[loc1]) {
					++localContentLevel.total_correct;
				}// end if
			}// end of for
		}// end if
	}// end of for
	if (localContentLevel.total_correct == localContentLevel.correct_options.length && localContentLevel.total_selected == localContentLevel.total_correct && localContentLevel.total_correct != 0) {
		localContentLevel.question_is_correct = true;
	}// end if
	
		trace("localContentLevel..question_is_correct" + localContentLevel.question_is_correct);
}// End of the function
/*
*  @public
*  showing the correct answer when the wrong answer is givin	
*/
function showCorrectAnswer() {
	for (var loc1 = 1; loc1 <= localContentLevel.total_options; ++loc1) {
		if (localContentLevel.show_answer == "ticks") {
			localContentLevel["option" + loc1].evaluator_graphic.gotoAndStop("incorrect");
			continue;
		}// end if
		localContentLevel["option" + loc1].option_icon.gotoAndStop("up");
		localContentLevel["option" + loc1].option_bg.gotoAndStop("up");
	}// end of for
	for (var loc11 = 1; loc11 <= localContentLevel.total_options; ++loc11) {
		for (var loc2 = 0; loc2 <= localContentLevel.correct_options.length; ++loc2) {
			if (loc11 == localContentLevel.correct_options[loc2]) {
				if (localContentLevel.show_answer == "ticks") {
					localContentLevel["option" + loc11].evaluator_graphic.gotoAndStop("correct");
					continue;
				}// end if
				localContentLevel["option" + loc11].option_icon.gotoAndStop("down");
				localContentLevel["option" + loc11].option_bg.gotoAndStop("down");
			}// end if
		}// end of for
	}// end of for
}// End of the function
			
			
	} // end class
}//end packsge
