﻿/*
*  @public class
*  xml_code is responsible for loading, parsing, and filling all the data from the course
*  xml files for the main framework functions and the coutse screens
*/
package 
{
	import flash.display.MovieClip;
	import flash.display.Loader;
	import flash.events.Event;
	import flash.net.URLLoader;
	import flash.net.*;
	import flash.xml.*;
	import flash.geom.ColorTransform;
	import flash.utils.getTimer;
	import flash.events.EventDispatcher;
	public class xml_code extends MovieClip
	{
		public  var menuXML:XML;
		public  var control:XML;
		public  var xmlcontent:XML;
		public  var loader1:URLLoader;
		public  var loader2:URLLoader;
		public  var req:URLRequest;
		public  var forced_path:String;
		public  var xmlObj:Object;
		public  var pagecount:int;
		public  var url:String;
		public  var newExamNode:Object;
		
		// will dealling with it and frame woek 
		// global by  == calling an objects globaly
		// islAppRoot == mean framework
		/*
		*  @public
		*  class constructor, defines the main attributes and variables for the class
		*/
		public function xml_code()
		{
			menuXML=new XML;
			control=new XML;
			xmlObj = new Object;
			global = new Object();
			islAppRoot = new Object();
			xmlcontent = new XML();
			loader1 = new URLLoader();
			loader2 = new URLLoader();
			pagecount = 0;
		}

		/*
		*  @public
		*  loads the framework settings
		*/
		public function parseFrameworkSettings(_filename)
		{

			req = new URLRequest(_filename);
			loader1.addEventListener(Event.COMPLETE,onSettingsLoaded);
			try
			{
				loader1.load(req);
			}
			catch (error:Error)
			{
				
				CGlobal.islDebug('An error occurred when attempting to load the XML.');
			}
		}//End of the function

		/*
		*  @private
		*  parsing the settings and setting the requires attributes
		*/
		private function onSettingsLoaded(event:Event)
		{

			control = new XML(event.target.data);
			var firstNode:XMLList = control.attributes();
			islAppRoot.islSettings=firstNode;
			//trace( islAppRoot.islSettings);
 				if (islAppRoot.islSettings.length == 1 && isFinite(parseInt(islAppRoot.islSettings)))
				{
					islAppRoot.islSettings = parseInt(islAppRoot.islSettings);
				}// end if
			var subNodes:XMLList  = control.children();
			var n:int = 0;
			for each  (var  nodeInfo:XML  in subNodes)  {
				var tagSetting = nodeInfo.name();
				
				  if (tagSetting == "completion"){
					islAppRoot.islCompletion = subNodes.attributes();
					//trace(islAppRoot.islCompletion);
					}// end if
				   else if (tagSetting == "lib"){	
					islAppRoot["lib_" + n++ + "_atts"] = subNodes.attributes();
					//trace(islAppRoot.lib_0_atts);
					islAppRoot.required_libs = islAppRoot.required_libs + subNodes.attribute("uri")+ ",";
					}
					else if (tagSetting == "component"){	
					islAppRoot["comp_" + n++ + "_atts"]= subNodes.attributes();
					islAppRoot.required_comps=islAppRoot.required_comps + subNodes.attribute("uri")+ ",";
					//trace(islAppRoot.required_comps);
					}
					n = 0;
				}
			loadContent(forced_path);
		}// End of the function
		/*
		*  @private
		*  loading the main strucure XML file
		*/
		private function loadContent(forced_path)
		{
			
		    if (forced_path != undefined)
		    {
		       req = new URLRequest(forced_path);
		    }
		    else
		    {
		       req = new URLRequest("structure.xml");
		    } // end else if

			loader2.addEventListener(Event.COMPLETE,loadMenuXML);
			try
			{
				loader2.load(req);
			}
			catch (error:Error)
			{
				CGlobal.islDebug("Failed to load structure " + menu.status);
			}
		   // islDebug("Sending commmand to load menu file : " + xml_code);
		 // End of the function
		
		}
		
		/*
		*  @private
		*  loading the menu XML and setting the course and activity titles 
		*  depending on the tagname
		*/
		private function loadMenuXML(event:Event)
		{
			
			menuXML = new XML(event.target.data);
			
			if (global.Course == undefined)
			{
				global.Course = new Object();
			} // end if
			if (global.Activity == undefined)
			{
				global.Activity = new Object();
			} // end if
			for   (var  r:int=0 ;r< menuXML.attributes().length();r++){
				//trace(menuXML.attributes()[r].name())
		     global.Course[menuXML.attributes()[r].name().toString()]   = menuXML.attributes()[r];
			 global.Activity[menuXML.attributes()[r].name().toString()] = menuXML.attributes()[r];	
			//trace(global.Course["id"])
			}
			
			var TempsubNodes:XMLList = menuXML.children();
			
			for (var snC:int; snC< TempsubNodes.length(); snC++)  {
				
			  var tagname:String  = TempsubNodes[snC].name();
			 // trace("ooooo"+ tagname  +  TempsubNodes.length());
			 switch (tagname){
				 /////////////////////stoping///////////////////
				 case "title":
				    global.Course.title   =  TempsubNodes[snC].text().toString();
                    global.Activity.title =  TempsubNodes[snC].text().toString();
                    //trace( global.Course.title );
					break;
					
				 case "page":
                
                    if (global.Course.pageNodes == undefined)
                    {
                        global.Course.pageNodes = new Array();
                        global.Activity.pageNodes = new Array();
                    } // end if
                    var page = new Object();
                    page.parent = global.Course;
                    page.progress = 0;
					for (var pC:int; pC< TempsubNodes[snC].attributes().length(); pC++){
					page[TempsubNodes[snC].attributes()[pC].name().toString()] =  TempsubNodes[snC].attributes()[pC];
			 		}
					global.Course.pageNodes = page ;
					global.Activity.pageNodes = page ;
                    page.index = global.Course.pageNodes.length();
                    page.number = pagecount;
                    ++pagecount;
                    break;   
                
				 case "groupnode":
              
                    var chekExam = false;
                    if (global.Course.subNodes == undefined)
                    {
                        global.Course.subNodes = new Array();
                    } // end if
                    if (global.Activity.subNodes == undefined)
                    {
                        global.Activity.subNodes = new Array();
                    } // end if
					
			 for (var n:int=0; n< TempsubNodes[snC].attributes().length(); n++){
				 
				 
				 var cName = TempsubNodes[snC].attributes()[n].name().toString()
				 //trace("222" + cName);
                        if (cName == "type" && TempsubNodes[snC].attributes()[n].indexOf("exam") != -1)
                        {
                            chekExam = true;
                        } // end if
                    } // end of for...in
                    if (chekExam == true)
                    {

                       parseGroupNode(TempsubNodes[snC],  global.Course, 0, true);
                       parseActivityNode(TempsubNodes[snC], global.Activity, 0, true);
                    }
                    else
                    {
					//trace(TempsubNodes[snC])
                      parseGroupNode(TempsubNodes[snC], global.Course, 0, false);
                      parseActivityNode(TempsubNodes[snC], global.Activity, 0, false);
                    } // end else if
                    break;
                  
			} // End of switch  
		} // end of for 
		
//		delete control;
//		delete menuXML;			
			loader1.removeEventListener(Event.COMPLETE,onSettingsLoaded);
			loader2.removeEventListener(Event.COMPLETE,loadMenuXML);

			global.Course.totalPages = pagecount;
			global.Activity.totalPages = pagecount;
//////////islAppRoot.gotoAndPlay("loadLibs");
		
	}// End of the function
	
		/*
		*  @private
		*  parsing the group nodes and setting the module title
		*  depending on the tagname
		*/
		
		private function parseGroupNode(xmlNode:XMLNode, parentObject:Object , depth:int, isExamNode:Boolean )
	{
		return;
		if (parentObject.subNodes == undefined)
			{
				parentObject.subNodes = new Array();
			} // end if
		
			var module = new Object();
			module.parent = parentObject;
			module.progress = 0;
			module.depth = depth;
	
		if (module.parent.totalPages == undefined)
		{
			module.parent.totalPages = 0;
		} // end if
	
	

	for (var n:int=0; n< xmlNode.attributes().length(); n++){
		
		module[xmlNode.attributes()[n].name().toString()] = xmlNode.attributes()[n];
	}
	
	
	
	   for (var snnC:int=0; snnC< xmlNode.childNodes.length(); snnC++)  {
				
			  //trace(xmlNode.childNodes[snnC]);
	 	  switch (xmlNode.childNodes[snnC].name().toString())
		
		{
            case "title":
            {
                module.title = xmlNode.childNodes[0].children()[0].text();
                break;
            } 
            case "page":
            {
                if (module.pageNodes == undefined)
                {
                    module.pageNodes = new Array();
                } // end if
                var page = new Object();
                page.parent = module;
                page.progress = 0;
                page.number = pagecount;
                ++pagecount;
				//page = xmlNode.children().attributes();
                module.pageNodes = page ;
                page.index = page.pageNodes.length;
                break;
            } 
            case "groupnode":
            {
               parseGroupNode(xmlNode.childNodes[snnC], module, depth + 1, false);
                break;
           } 
		  } // end of for
        } // End of switch
		
		
		 if (isExamNode == true)
    	{
			var newExamNode = new Object();
			var nModule = module;
			newExamNode.pageNodes = new Array();
			newExamNode.type = nModule.type;
			newExamNode.id = nModule.id;
			newExamNode.title = nModule.title;
			newExamNode.depth = nModule.depth;
			newExamNode.progress = nModule.progress;
			newExamNode.active = nModule.active;
			newExamNode.parent = parentObject;
			if (newExamNode.active != "false")
			{
				if (nModule.subNodes != undefined && nModule.subNodes.length > 0)
				{
					for (var i = 0; i < nModule.subNodes.length; ++i)
					{
						if (nModule.order == "random_sequential" || nModule.order == "random_unsequential")
						{
							nModule.subNodes[i].pageNodes.sort(randomOrder);
						} // end if
					} // end of for
				} // end if
				var cat = new Array();
				cat = nModule.key.split("|");
				for (k = 0; k < cat.length; k++)
				{
					var c = 0;
					for (var nnn = 0; nnn < nModule.subNodes[0].pageNodes.length; n++)
					{
						if (parseInt(nModule.subNodes[0].pageNodes[nnn].category) == k + 1 && c< parseInt(cat[k]))
						{
							newExamNode.pageNodes.push(nModule.subNodes[0].pageNodes[nnn]);
							++c;
						} // end if
					} // end of for
					} // end of for
				if (nModule.order == "random_unsequential")
				{
					newExamNode.pageNodes.sort(randomOrder);
				} // end if
				}
			else
			{
				for (var l = 0; l < nModule.subNodes.length; ++l)
				{
					var k = 0;
					while (k < nModule.subNodes[l].pageNodes.length)
					{
						newExamNode.pageNodes.push(nModule.subNodes[l].pageNodes[k]);
						++k;
					} // end while
				} // end of for
			} // end else if
			newExamNode.pageNodes.unshift(nModule.pageNodes[0]);
			newExamNode.pageNodes.push(nModule.pageNodes[1]);
	
			newExamNode.totalPages = newExamNode.pageNodes.length;
			newExamNode.examscore = 0;
			pagecount = pagecount - newExamNode.totalPages;
			for (var j = 0; j < newExamNode.pageNodes.length; ++j)
			{
				newExamNode.pageNodes[j].index = j + 1;
				newExamNode.pageNodes[j].parent = newExamNode;
			} // end of for
			parentObject.subNodes.push(newExamNode);
			newExamNode.index = parentObject.subNodes.length;
		}
		else
		{
			parentObject.subNodes.push(module);
			module.index = parentObject.subNodes.length;
		} // end else if
	} // End of the function
	

	/*
	*  @private
	*  parsing activity nodes and setting the activity attributes
	*/
	private function parseActivityNode(xmlNode:XML, parentObject:Object , depth:int, isExamNode:Boolean)
	{
		if (parentObject.subNodes == undefined)
			{
				parentObject.subNodes = new Array();
			} // end if
			
			var page = new Object();
			page.parent = parentObject;
			page.progress = 0;
			page.depth = depth;

		if (page.parent.totalPages == undefined)
			{
				page.parent.totalPages = 0;
			} // end if
			
			
			
			
	 for (var n:int=0; n< xmlNode.attributes().length(); n++){
		page[xmlNode.attributes()[n].name().toString()] = xmlNode.attributes()[n];
	}
	
	 
	for (var snnC:int=0; snnC< xmlNode.childNodes.length(); snnC++)  {
		
	switch (xmlNode.childNodes[snnC].name().toString())
        {
            case "title":
            {
				 page.title = xmlNode.childNodes[0].children()[0].text();
                break;
            } 
            case "page":
            {
                if (page.pageNodes == undefined)
                {
                    page.pageNodes = new Array();
                } // end if
                var lesson = new Object();
                lesson.parent = page;
                lesson.progress = 0;
                lesson.number = pagecount;
                ++pagecount;
				
				for (var kk:int=0; kk< xmlNode.childNodes[snnC].attributes().length(); kk++) 
                {
                   lesson[xmlNode.childNodes[snnC].attributes()[kk].name().toString()] = xmlNode.childNodes[snnC].attributes()[kk];
                } // end of for...in
                page.pageNodes.push(lesson);
                lesson.index = page.pageNodes.length;
                break;
            } 
            case "groupnode":
            {
				//trace("jjjjj");
                parseGroupNode(xmlNode.childNodes[snnC], page, depth + 1, false);
                break;
            } 
        } // End of switch
    } // end of for
    if (isExamNode == true)
    {
        newExamNode = new Object();
        var npage = page;
        newExamNode.pageNodes = new Array();
        newExamNode.type = npage.type;
        newExamNode.id = npage.id;
        newExamNode.title = npage.title;
        newExamNode.depth = npage.depth;
        newExamNode.progress = npage.progress;
        newExamNode.active = npage.active;
        newExamNode.parent = parentObject;
        if (newExamNode.active != "false")
        {
            if (npage.subNodes != undefined && npage.subNodes.length > 0)
            {
                for (var i = 0; i < npage.subNodes.length; ++i)
                {
                    if (npage.order == "random_sequential" || npage.order == "random_unsequential")
                    {
                        npage.subNodes[i].pageNodes.sort(randomOrder);
                    } // end if
                } // end of for
            } // end if
            var cat = new Array();
            cat = npage.key.split("|");
            for (k = 0; k < cat.length; k++)
            {
                var c = 0;
                for (var nnn = 0; nnn < npage.subNodes[0].pageNodes.length; n++)
                {
                    if (parseInt(npage.subNodes[0].pageNodes[nnn].category) == k + 1 && c < parseInt(cat[k]))
                    {
                        newExamNode.pageNodes.push(npage.subNodes[0].pageNodes[nnn]);
                        ++c;
                    } // end if
                } // end of for
            } // end of for
            if (npage.order == "random_unsequential")
            {
                newExamNode.pageNodes.sort(randomOrder);
            } // end if
        }
        else
        {
            for (var l = 0; l < npage.subNodes.length; ++l)
            {
                var k = 0;
                while (k < npage.subNodes[l].pageNodes.length)
                {
                    newExamNode.pageNodes.push(npage.subNodes[l].pageNodes[k]);
                    ++k;
                } // end while
            } // end of for
        } // end else if
        newExamNode.pageNodes.unshift(npage.pageNodes[0]);
        newExamNode.pageNodes.push(npage.pageNodes[1]);
        newExamNode.totalPages = newExamNode.pageNodes.length;
        newExamNode.examscore = 0;
        pagecount = pagecount - newExamNode.totalPages;
        for (var j = 0; j < newExamNode.pageNodes.length; ++j)
        {
            newExamNode.pageNodes[j].index = j + 1;
            newExamNode.pageNodes[j].parent = newExamNode;
        } // end of for
        parentObject.subNodes.push(newExamNode);
        newExamNode.index = parentObject.subNodes.length;
    }
		else
		{
			parentObject.subNodes.push(page);
			page.index = parentObject.subNodes.length;
		} // end else if
	} // End of the function

	
	/*
	*  @private
	*  generating a random number
	*/
	private function randomOrder()
	{
		return (Math.round(Math.random()) - 5.000000E-001);
	} // End of the function
		

	/*
	*  @public
	*  parsing the movie text from the XML
	*/
	public function parseMovieText(movLvl, _filename)
		{
			/*var myurl:String  = unescape(movLvl.loaderInfo.url);
			if (myurl.indexOf("http") == 0)
		    {      
			  req = new URLRequest(_filename + "?rand=" + getTimer());
		    }
		    else
		    {
				req = new URLRequest(_filename);
		    } // end else if
			*/
			req = new URLRequest(_filename);
			loader1.addEventListener(Event.COMPLETE,myOnLoad);
			
			try
			{
				loader1.load(req);
			}
			catch (error:Error)
			{
				CGlobal.islDebug("Error loading xml file for level : " );
				//trace('An error occurred when attempting to load the XML.');
			}
			//islDebug("Successfull loaded and parsed file to level : " + xmlObj.l + " " );
		    xmlObj.l = movLvl;
		    xmlObj.filename = _filename;
		} // End of the function

	/*
	*  @private
	*  extracting the text data from the movie XML
	*/
	private function myOnLoad(event:Event)
		{
			
			xmlcontent = new XML(event.target.data);
			//trace(xmlcontent.children()[1].name().toString());
			
			try
			{
			for (var i:int = 0; i < xmlcontent.children().length(); i++){
				
				switch (xmlcontent.children()[i].name().toString())
				
						{
							case "textdata":
							{
								parseTextdata(xmlcontent.children()[i]);
								break;
							} 
							case "id":
							{

								break;
							} 
						} // End of switch
					} // end of for
					// for revision@@
				  //  MovieClip(xmlObj.l).gotoAndPlay("loadLibs");
			
			}
			catch(e:Error)
			{
				CGlobal.islDebug("in XML Code Error loading xml file for myOnLoad : "+e.toString() );
				} 
				this.dispatchEvent(new Event("onParseTextFinish"));// to Call next library after calling ---> parseMovieText
		} // End of the function
	
	/*
	*  @private
	*  parsing the text data and filling the text boxes, buttons, questions, etc..
	*/
	private function parseTextdata(textdata)
		{
			
			var nodes = textdata.children();
			//trace("rrrrr" + nodes);
			
			for (var i = 0; i < nodes.length(); ++i){
				
				var id = nodes[i].@id;
				var document = nodes[i].@document;
				var rslt:String = nodes[i].text();
			    var n = 1;
		
		//trace(id+" id  "  +rslt)
		//trace( nodes[i].name().toString() +"  Node  ")

		switch (nodes[i].name().toString())
		        {
		            case "p":
		            {
						
		                xmlObj.l[id] = rslt;
		                break;
		            } 
		            case "btn":
		            {
		                xmlObj.l[id + "_btn"] = rslt;
						//trace( "kkkk  " + xmlObj.l[id + "_btn"]);
		                if (document != undefined)
		                {
		                    xmlObj.l[id + "_doc"] = document;
		                } // end if
		                if (nodes[i].attributes().tracking != undefined)
		                {
		                    xmlObj.l[id + "_btn_tracking"] = nodes[i].attributes().tracking;
		                } // end if
		                break;
		            } 
		            case "screen":
		            {
		                MovieClip(xmlObj.l).screen_type = nodes[i].@type;
						
						for (var k:int = 0; k < nodes[i].children().length(); ++k){
						
					  	  if (!isNaN(nodes[i].children()[k].text()))
		                    {
		                      xmlObj.l[nodes[i].children()[k].@id] = parseInt(nodes[i].children()[k].text());
		                        continue;
		                    } // end if
		                      xmlObj.l[nodes[i].children()[k].@id] = nodes[i].children()[k].text();
						}
		                break;
		            } 
		            case "video":
		            {

		                xmlObj.l["videoItem_" + nodes[i].attributes().name] = new Object();
		                var viName = xmlObj.l["videoItem_" + nodes[i].attributes().name];
		              
					  
					for (var j:int = 0; j < nodes[i].childNodes.length(); ++j){
					  
					
					    if (!isNaN(nodes[i].childNodes[j].text()))
		                    {
		                        viName[nodes[i].childNodes[j].attributes().id] = parseInt(nodes[i].childNodes[j].text());
		                    }
		                    else
		                    {
		                        viName[nodes[i].childNodes[j].attributes().id] = nodes[i].childNodes[j].text();
		                    } // end else if
							
							 if (nodes[i].childNodes[j].name().toString() == "cuePoint")
		                    {
		                        viName["cue_" + n] = new Object();
		                        viName["cue_" + n].name = "ASCuePt" + n;
		                        viName["cue_" + n].time = parseInt(nodes[i].childNodes[j].text());
		                        viName["cue_" + n].label = nodes[i].childNodes[j].attributes().label;
		                        viName["cue_" + n].pauseVideo = nodes[i].childNodes[j].attributes().pauseVideo;
		                        viName["cue_" + n].triggerMc  = nodes[i].childNodes[j].attributes().triggerMc;
		                        ++n;
		                    } // end if
		                } // end of for
		                break;
		            } 
		            case "question":
		            {
		                xmlObj.l.aOptions = new Array();
		                xmlObj.l.aFeedbacks = new Array();
		                xmlObj.l.question_type = nodes[i].@type;
						//trace("bbb" + nodes[i]);
		              //  var _loc8 = _loc2[_loc1].childNodes.length;
						// trace(" kkkk " + nodes[i].children().length());
						for (var l = 0; l < nodes[i].children().length(); ++l)
						{   
						 //trace(" kkkk " + nodes[i].children()[l].@id);
					   		if (!isNaN(nodes[i].children()[l].text()))
								{
								   xmlObj.l[nodes[i].children()[l].@id] = parseInt(nodes[i].children()[l].text());
									continue;
								} // end if
								   xmlObj.l[nodes[i].children()[l].@id] = nodes[i].children()[l].text();
							} // end for 
						
		                if (xmlObj.l.question_type == "DD")
		                {
		                    xmlObj.l.aSlotLabels = new Array();
		                    xmlObj.l.aCorrectSlots = new Array();
		                    xmlObj.l.slot_counter = 0;
		                } // end if
		                xmlObj.l.aColumnHeadings = new Array();
		                break;
		            } 
		            case "dynamic":
		            {	
					// trace(id.toString()+"  dynamic id"  + "  "  + rslt );
					 
		                switch (id.toString())
		                {
		                    case "slot_label":
		                    {
								
		                        xmlObj.l.aSlotLabels.push(rslt);
								
		                        break;
		                    } 
		                    case "option":
		                    {
								
								
		                        xmlObj.l.aOptions.push(rslt);
								
								//trace( xmlObj.l +   "  rslt** " +  rslt  + "   aOptions ");
		                        break;
		                    } 
		                    case "feedback":
		                    {
		                        xmlObj.l.aFeedbacks.push(rslt);
		                        break;
		                    } 
		                    case "correct_slots":
		                    {
		                        xmlObj.l.aCorrectSlots[xmlObj.l.slot_counter] = rslt.split(",");
		                        ++xmlObj.l.slot_counter;
		                        break;
		                    } 
		                    case "column_heading":
		                    {
		                        xmlObj.l.aColumnHeadings.push(rslt);
		                        break;
		                    } 
		                    default:
		                    {
		                        //++xmlObj.l["num_" + id];
		                        if (xmlObj.l["num_" + id] > 1)
		                        {
		                            if (xmlObj.l["num_" + id] == 2)
		                            {
		                                xmlObj.l[id + "1"] = xmlObj.l[id];
		                            } // end if
		                            xmlObj.l[id + xmlObj.l["num_" + id]] = rslt;
		                        }
		                        else
		                        {
									//trace(id+"\n\n\n\n   ddsdsdsadasdasdasdsa"+rslt);
		                            xmlObj.l[id] = rslt;
		                        } // end else if
		                        break;
		                    } 
		                } // End of switch
		                break;
							
		            } 
		            default:
		            {
		                break;
		            } 
					} // End of switch
		    } // end of for

		} // End of the function
	}
}