﻿/*
*  @public
*  the class loads the basic elements for the screen, the preloader, XML, and audio files
*/
package {
	
	import flash.display.*
	import flash.net.URLRequest;
	import flash.display.Loader;
	import flash.text.*;
	import flash.events.*;
	dynamic public class CContent extends MovieClip {

		/**
		 *  @private
		 *  default root path
		 */
		//var FM:Framework;
		public var AudioFileLoader:FileLoader;
		public  var numAudioElements:int = 0;
		var islMainPlayerRunning:Boolean=false;
		public  var screenAudio="off";
		
		private var url:String;
		public var loader:Loader;
		
		/*
		*  @public
		*  class constructor
		*/
		public function CContent() {
			//trace("I'M THE CONSTRUCTOR");
			this.focusRect=false;
			loader=new Loader();
			
			//CGlobal.GetFileName(ContentMovie);
				CGlobal.content_mc=this;
			if (CGlobal.islAppRoot) {//&& !CGlobal.islAppRoot.islMainPlayerRunning
				CGlobal.islDebug("CGlobal.islAppRoot is:" + CGlobal.islAppRoot + "  means that this content opened in framework");
				CGlobal.PrifixPath="../";
			} else {
				CGlobal.PrifixPath="";
				CGlobal.islDebug("CGlobal.islAppRoot is:" + CGlobal.islAppRoot + "  means that this content not in framework");
				CGlobal.islAppRoot=this;
				//CGlobal.contentLevel=this;// pinding
				CGlobal.myFileName=CGlobal.GetFileName(this.loaderInfo.url);
				//CGlobal.Preloader=new FileLoader("../shared_elements/preloader.swf");
				//CGlobal.Preloader.addEventListener("onFileLoad",onPreloaderLoad);
				CGlobal.content_mc.addEventListener(Event.ENTER_FRAME , checkFinished);
			}// end else if

			//audio_holder.loadMovie("movies/audio/" + myFile + "_audio.swf");

			if(CGlobal.islAppRoot.islMainPlayerRunning)
			{
				CGlobal.PathBack="../"
				CGlobal.MoviesPath="movies/";
			}

			
			CGlobal.myXmlFile= CGlobal.MoviesPath+"content/" + CGlobal.myFileName + ".xml";
			
			//trace(CGlobal.myXmlFile)
			CGlobal.myflvPath=CGlobal.PrifixPath + "flv/";
			
			//CGlobal.islDebug(myFile + "\n" + myXmlFile + "\n" + myflvPath);
			if(this.error_mc)
			this.error_mc.visible=false;
			
			if(CGlobal.PrifixPath!="")
			loadLib();

		}
		
		
		/*
		*  @public
		*  adding the preloader
		*/
		/*function onPreloaderLoad(e:Event) {
			CGlobal.islAppRoot.addChild(CGlobal.Preloader.loader.content);
			CGlobal.Preloader.removeEventListener("onFileLoad",onPreloaderLoad);
			//CGlobal.updatePreloader(true,10,"loading 10%");
			loadLib();
		}*/
		/*
		*  @public
		*  announcing the end of the screen
		*/
		
		function checkFinished(e:Event){
			
			if(e.target.currentFrame==e.target.totalFrames){
				
				CGlobal.islAppRoot.contentMovieFinished();
				
			}
		}
		
		public function contentMovieFinished()
		{
			CGlobal.content_mc.finished = true;
			//trace(" contentMovieFinished called")
			CGlobal.islDebug("Current Screen Finished"+ this);
		}
		/*
		*  @public
		*  adding event listener to the XML loader and parsing the XML file
		*/
		public function loadLib() {
			
			//xmlLib.parseStyles();  this calling canceld and its work will be in text_code library
			CGlobal.xmllib.addEventListener("onParseTextFinish",onParseTextFinishEvent);
			CGlobal.xmllib.parseMovieText(CGlobal.content_mc,CGlobal.myXmlFile);
		}
		/*
		*  @public
		*  loading the Audio file for the screen
		*/
		public function onParseTextFinishEvent(e:Event) {
			CGlobal.xmllib.removeEventListener("onParseTextFinish",onParseTextFinishEvent);
			CGlobal.audio_code_lib = new Audio_Code();
			//trace("this.screenAudio "+this.screenAudio+"   "+CGlobal.myFileName)
			if(this.screenAudio && this.screenAudio=="on")
			{
				
				var request:URLRequest=new URLRequest(CGlobal.MoviesPath+"audio/"+CGlobal.myFileName+ "_audio.swf");
				var loader:Loader=new Loader();
				loader.contentLoaderInfo.addEventListener(Event.COMPLETE,audioComplete);
				loader.load(request);
				
				
				
				
				//AudioFileLoader=new FileLoader(CGlobal.MoviesPath+"audio/"+CGlobal.myFileName+ "_audio.swf");
				//AudioFileLoader.addEventListener("onFileLoad",onAudioLoad)
				//AudioFileLoader.addEventListener("onFileNotFound",onAudioNotFound)
				
			}else{
				//AudioFileLoader=new FileLoader("");
				LoadbtnCode();
			}
		}
		/*
		*  @public
		*  loads the audio content into the screen
		*/
		function audioComplete(e:Event){
			
				this.audio_holder= e.currentTarget.content;
				LoadbtnCode();
				 //this.audio_holder.play();
			}
		/*
		*  @public
		*  plays the content
		*/
		public function  playContent(){
				play();
			}
		/*
		*  @public
		*  loads the buttons
		*/
		function LoadbtnCode(){
			//CGlobal.updatePreloader(true,45,"loading 45%");
			//CGlobal.islDebug(CGlobal.content_mc.screen_type);
			CGlobal.button_code_lib=new Button_Code(CGlobal.content_mc);
			
			//trace(CGlobal.audio_code_lib)
			CGlobal.setup_lib.initPage(CGlobal.content_mc);
			/**/
			//
			//trace(CGlobal.updatePreloader  + "  "+true,8,"loading 8%");
			if(this.screenAudio=="off")
			{
				if(CGlobal.islAppRoot.islMainPlayerRunning)
				{
					trace(" ccontent 111111111111");
					CGlobal.islAppRoot.playContent()
				}
				else
				 trace("  ccontent 2222222222");
				playContent();
			}else{
				 trace(" ccontent 333333333333");
				playContent();
				//trace(numAudioElements + " numAudioElements ");
				 CGlobal.audio_code_lib.initAudio(numAudioElements);
				}
			//CGlobal.updatePreloader(false,45,"loading 45%");
			//addEventListener(Event.ENTER_FRAME ,enterFrameFunctions);
			}
			/*
			function enterFrameFunctions(e:Event.ENTER_FRAME )
			{

			}
			*/
	}
}