﻿
package {
	import flash.display.*;
	import flash.text.*;
	import flash.media.*;
	import flash.net.*;
	import flash.system.fscommand;
	import flash.events.*;
	import flash.xml.*;
	import fl.video.FLVPlayback;
	import fl.video.VideoPlayer;
	import flash.utils.Timer;
    import flash.events.TimerEvent;

	dynamic public class Framework extends MovieClip {
		/**
		 *  @private
		 *  framework screen loader
		 */
		 public var navigation:FileLoader;
		 public var timer:Timer;
		/**
		 *  @private
		 *  framework screen loader
		 */
		 
		public var MyNavigator:NavEvents;
		/**
		 *  @private
		 *  framework screen loader
		 */
		 
		public var MyContent:FileLoader;
		/**
		 *  @private
		 *  framework Components
		 */
		var Components:Array=new Array;
		/**
		 *  @public
		 *  framework XML Structure control
		 */
		public var Structure_code:CStructure=new CStructure();
		/**
		 *  @private
		 *   current screen 
		 */
		public var islSettings:CSettings;
		/**
		 *  @private
		 *   current screen 
		 */
		var CurrentScreenID:int=0;
		
		/**
		 *  @private
		 *  current Component
		 */
		 public var checkFinished:Boolean;
		 
		 
		var CurrentComponent:String="";
		var islCompletion:Object=new Object ();
		var islMainPlayerRunning:Boolean=true;
		var lvlIndex=5000;
		var maxDepth=1048575;
		var islBookmarkTracker="";
		var islSuspendData="";
		var islFrameworkVersion="3.0";
		var islFrameworkDate="Feb2010";
		var islFrameworkPublisher="CAIROIT-TEAM";
		var islFrameworkLastUpdate="";


		var BackPath="";

		public var playMode:Boolean = false;
		public var audioMode:Boolean = false;
		
		

		//--------------------------------------
		//  Constructor
		//--------------------------------------
		public function Framework() {

			this.focusRect=false;
			this.file_mc.visible = false;
			
			
			timer = new Timer(3000, 2);
			
			stage.addEventListener (KeyboardEvent.KEY_DOWN, keyDownHandler);
			CGlobal.content_xml="movies\\content\\";
			CGlobal.islAppRoot=this;
			CGlobal.islAppRoot.islMainPlayerRunning=true;
			CGlobal.islDebug("Version= " + islFrameworkVersion + " " + islFrameworkDate);
			
			
			CGlobal.Preloader = new FileLoader(BackPath+"shared_elements/preloader.swf");
			CGlobal.Preloader.addEventListener("onFileLoad",onPreloaderLoad);

			this.focusRect=false;
		}
		
		
		function keyDownHandler (e:KeyboardEvent):void {

				if(e.keyCode == 33){
					this.file_mc.txt.text = CGlobal.myFileName;
					this.file_mc.visible = !this.file_mc.visible
				}
		
		}
		
		
		
		//--------------------------------------
		//  Events
		//--------------------------------------
		/*
		*Fire when Preloader be Loaded
		*/
		public function contentMovieFinished(scrolledTranscript:Boolean=false):void
		{
			
			if(navigation.loader.content.visible==false)
			{
					nextScreen();
					CGlobal.islDebug("Current Screen Finished "+ this);
			}else{
					
			}
			
			
			
			
			//-----------------------------
			
			 if (scrolledTranscript)
				{
					
					
					if (!navigation.loader.content.nextEnabled && CGlobal.currentPage.@next != "null")
					{
						if (CGlobal.content_mc.controlled_navigation == "on")
						{
						}
						else if (CGlobal.content_mc.controlled_navigation == "off" || CGlobal.button_code_lib.screenButtonsControl.screenBtnCount == CGlobal.button_code_lib.screenButtonsControl.viewedBtnCount)
						{
							navigation.loader.content.enableNextButton();
							navigation.loader.content.setFlahingNextButton();
						} // end if
					} // end else if
				}
				else if (!CGlobal.content_mc.currentMainScreenAudioSegment && CGlobal.content_mc.controlled_navigation == "off")
				{
					 checkFinished = true;
					if (CGlobal.currentPage.@next != null)
					{
						
						navigation.loader.content.setFlahingNextButton();
						
						
					} // end if
					
					if (!navigation.loader.content.nextEnabled && CGlobal.currentPage.@next)
					{
						
					} // end if
				}
				else if (CGlobal.content_mc.controlled_navigation == "on")
				{
					if (!navigation.loader.content.nextEnabled && CGlobal.currentPage.@next != "null")
					{
						if (CGlobal.content_mc.controlled_navigation == "off" || CGlobal.button_code_lib.screenButtonsControl.screenBtnCount == CGlobal.button_code_lib.screenButtonsControl.viewedBtnCount)
						{
							navigation.loader.content.enableNextButton();
							navigation.loader.content.setFlahingNextButton();
						} // end if
					} // end else if
				} // end else if
			
			
		}

		function onPreloaderLoad(e:Event) {

			
			CGlobal.Preloader.removeEventListener("onFileLoad",onPreloaderLoad);
			

			islSettings=new CSettings();
			islSettings.addEventListener("onCSettingLoad",onCourseSettingLoad);
		}
		/*
		*Fire when Course Structure be Loaded
		*/

		function onCourseSettingLoad(e:Event) {
			
			Structure_code.LoadStructure();
			Structure_code.addEventListener("onCStructureLoad",onCourseStructLoad);
		}
		function onCourseStructLoad(e:Event) {
			
			navigation=new FileLoader("component/navigation.swf");
			navigation.addEventListener("onFileLoad",onNavigatorLoad);

			CGlobal.data_store= new intSharedObject();
			

		}
		function onNavigatorLoad(e:Event) {
			

			navigation.loader.content.visible=false;
			CGlobal.islAppRoot.addChildAt(navigation.loader.content,0);
			MyNavigator =new NavEvents(this,e.target.loader.content);

			
			OpenScreen(0);
			
		}
		
		/*
		*Fire every screen loading
		*/
		
		public function onFileNotFound(e:Event) {
			CGlobal.islDebug("onFileNotFound");
			nextScreen();
		}
		
		function onContentLoad(e:Event) {
		
			CGlobal.IsFinished = true;
			for (var i:int = 0; i<CGlobal.emptyMovies.length; i++)
			{			
				CGlobal.text_code_lib.islInitTextLabel(CGlobal.emptyMovies[i]);
			}
			
			
			if(CGlobal.content_mc.currentAudioSegment )
				{
					CGlobal.islAppRoot.pausedItem = CGlobal.content_mc.currentAudioSegment;							
					CGlobal.islAppRoot.pausedItem.stop();
				}
				else
				{
					CGlobal.islAppRoot.pausedItem = CGlobal.content_mc;
					CGlobal.islAppRoot.pausedItem.stop();
				}
			playContent();

			
			
			
			MyContent.removeEventListener("onFileLoad",onContentLoad);
			
			
			
			
			
			CGlobal.islAppRoot.addChildAt(MyContent.loader.content,0);
			
			// set the global var of the screen content

			if(!CGlobal.content_mc)
			{
				nextScreen();
			}
			else if (Structure_code.XMLData.groupnode.groupnode.groupnode.page[CurrentScreenID].@splashscreen.toString() == "true") {
				navigation.loader.content.visible=false;
			} else {
				
				navigation.loader.content.visible=true;
			}
			
			
		}
		
		/*
		*Fire with every component Loaded
		*/
		function onComponentLoad(e:Event) {
			CGlobal.islAppRoot.addChild(e.target.loader.content);
		}

		
		public function blah(e:TimerEvent):void{

			
			SoundMixer.soundTransform = new SoundTransform(1);
			playContent();
			e.target.removeEventListener(TimerEvent.TIMER, blah);

		}
		
		
		
		//--------------------------------------

		public function OpenScreenByActivity(Aname:String) {
			var cc:int = Structure_code.getFirstOfActivity(Aname);
			OpenScreen(cc); 
			CloseComponant();
		}
		
		public function OpenScreenBySrc(Aname:String) {
			var cc:int = Structure_code.getScreenBySrc(Aname);
			OpenScreen(cc); 
			CloseComponant();
		}

		
		
		//--------------------------------------
		//  Methods
		//--------------------------------------
		public function OpenScreen(Num:int) {
			checkFinished = false;
			if( CGlobal.content_mc && CGlobal.content_mc.myVideo){	
				// CGlobal.content_mc.myVideo.VideoFLV.getVideoPlayer(0).close(); 
 			}
			if(CGlobal.content_mc&& CGlobal.content_mc.extra_content && CGlobal.content_mc.extra_content.moviecon_mc && CGlobal.content_mc.extra_content.moviecon_mc.getChildByName("myCaptivate")){		
				CGlobal.content_mc.extra_content.moviecon_mc.getChildByName("myCaptivate").unloadAndStop();
			}
			
			pauseContent();
			
			if (Num < 0) {
				return;
			}
			CGlobal.PreviousPage=CurrentScreenID;
			CurrentScreenID=Num;
			if (this.numChildren > 1) {
				
			}

			if (MyContent && MyContent.loader.content) {
				try{

					removeChild(MyContent.loader.content);
					MyContent.loader.content=new MovieClip();
					MyContent.loader.unloadAndStop();
					MyContent.loader=null;
				}catch(e:Error){}
			}
			
				CGlobal.data_store.setScreenAsTrue(CurrentScreenID);
				
				if(Structure_code.XMLData.groupnode.groupnode.groupnode.page[Num])
				{
					
					CGlobal.currentPage=Structure_code.XMLData.groupnode.groupnode.groupnode.page[Num];
					
					MyNavigator.updateNavData()
					MyContent=new FileLoader("movies/" +CGlobal.currentPage.@src );				
					CGlobal.myFileName=CGlobal.GetFileName(CGlobal.currentPage.@src);
					
					CGlobal.emptyMovies = new Array();
					CGlobal.IsFinished = false;
										
					MyContent.addEventListener("onFileLoad",onContentLoad);
					MyContent.addEventListener("onFileNotFound",onFileNotFound);
				}
			
		}
		public function OpenGlossory()
		{
			OpenComponant("glossary"); 
		}
		public function OpenComponant(id:String) {
			
			
			timer.stop();
			
			if (CurrentComponent != "" && Components[CurrentComponent] && Components[CurrentComponent].loader && Components[CurrentComponent].loader.content && Components[CurrentComponent].loader.content.visible) {
				
				 CloseComponant();
				 if(checkFinished){
					 pauseContent();
					 
				 
				 }else{
					playContent();
				 }
				 
				if(Components[CurrentComponent]==Components[id])
				{
					navigation.loader.content.restCom();
					return;
				}
			}
			if(id=="")
			{
				return;
			}
			if(id=="course_menu"){
   			  if (Components[id] == null) {
				  
				  Components[id]=new FileLoader("component/" + id + ".swf");
				  Components[id].addEventListener("onFileLoad",onComponentLoad);
  			  } else {
				  Components[id].loader.content.buildTree();
				  Components[id].loader.content.visible=true;
			  }

				
				
				}
			
			else{
   			  if (Components[id] == null) {
				  Components[id]=new FileLoader("component/" + id + ".swf");
				  Components[id].addEventListener("onFileLoad",onComponentLoad);
  			  } else {
				  Components[id].loader.content.visible=true;
			  }
			}
			pauseContent();
			CurrentComponent=id;
		}
		public function ClearComponant()
		{
			CloseComponant();
		}
		public function CloseComponant() {
			
			 Components[CurrentComponent].loader.content.visible=false;
			 navigation.loader.content.restCom();
			 
		}
		
		public function nextScreen() {
			
					
			OpenScreen(CurrentScreenID + 1);
		}
		public function backScreen() {
			checkFinished = false;
			OpenScreen(CurrentScreenID - 1);
		}
		//stop All movies in this screen
		
		function ReplayScreen()
		{
			checkFinished = false;
			OpenScreen(CurrentScreenID)
			
		}
		function playContent()
		{
			if(CGlobal.content_mc.currentAudioSegment )
				{
					CGlobal.islAppRoot.pausedItem = CGlobal.content_mc.currentAudioSegment;							
				}
				else
				{
					CGlobal.islAppRoot.pausedItem = CGlobal.content_mc;
				}
			
			
			playMode=true;

			MyNavigator.updateBtns();

			this.file_mc.txt.text = CGlobal.myFileName;
			
			if(CGlobal.content_mc.numVideos > 0 && CGlobal.content_mc.video_mc.TriggerPoint == true)
			{
				
			}
			else
			{
				if(CGlobal.islAppRoot.pausedItem)
					CGlobal.islAppRoot.pausedItem.play();
				
				if(CGlobal.content_mc.extra_content && CGlobal.content_mc.extra_content.slider && CGlobal.content_mc.extra_content.slider.bar_mc.pointer.button_pointer)
					CGlobal.content_mc.extra_content.slider.bar_mc.pointer.button_pointer.enabled = true;			
					} // end else if
		} // End of the function

		
		function pauseContent()
		{			
		
			playMode=false;
			MyNavigator.updateBtns();
	 
			
			if(!CGlobal.content_mc)
			return;
			
				if (CGlobal.islAppRoot.islSettings.XMLData.@audioStatus == "on")
				{
					if (CGlobal.content_mc.numVideos && CGlobal.content_mc.numVideos > 0)
					{
						if (!CGlobal.content_mc.video_mc.videoEnded)
						{
							if (CGlobal.content_mc.video_mc.TriggerPoint != true)
							{
								CGlobal.islAppRoot.pausedItem = CGlobal.content_mc.video_mc.video_flv;
								CGlobal.islAppRoot.pausedItem.stop();
							} // end if
						}
						else
						{
							CGlobal.islAppRoot.pausedItem = null;
						} // end else if
					}
					else if (CGlobal.content_mc.screenAudio == "on")
					{
						if (CGlobal.content_mc.currentAudioSegment && CGlobal.content_mc.currentAudioSegment.currentFrame > 2)
						{
							try{
							if(CGlobal.content_mc.extra_content && CGlobal.content_mc.extra_content.slider)
								CGlobal.content_mc.extra_content.slider.bar_mc.pointer.button_pointer.enabled = false;
							}catch(e:Error){}
							if(CGlobal.content_mc.currentAudioSegment )
							  {
							CGlobal.islAppRoot.pausedItem = CGlobal.content_mc.currentAudioSegment;
							
							CGlobal.islAppRoot.pausedItem.stop();
							}
						}
						else
						{
							CGlobal.islAppRoot.pausedItem = CGlobal.content_mc;
							CGlobal.islAppRoot.pausedItem.stop();
						} // end else if
					}
					else if (CGlobal.content_mc.screenAudio == "off")
					{
						if (CGlobal.content_mc.currentFrame < CGlobal.content_mc.totalFrames)
						{
							CGlobal.islAppRoot.pausedItem = CGlobal.content_mc;
							CGlobal.islAppRoot.pausedItem.stop();
						}
						else
						{
							CGlobal.islAppRoot.pausedItem = "";
						} // end else if
					} // end else if
				} // end else if
			
			
		} // End of the function

		
		//---------------------------------------------------------------------------------
		

		public function functionTrace(currentFunction)
		{
		} // End of the function
		
		
		
		function init()
		{

			if (CGlobal.islAppRoot.islSettings.XMLData.@audioStatus.toString() == "off")
			{
				SoundMixer.soundTransform = new SoundTransform(0);
			}
			else
			{
				
			} // end else if
			
			CGlobal.audioState = 1;
			CGlobal.CourseComplete = false;
			CGlobal.islAppRoot.focusRect=false;
			CGlobal.data_store.readUserData()
		} // End of the function
		
		
		function initContent()
		{
			var _loc2 = null;
			if (jLessonLocation != undefined && jLessonLocation.length > 0)
			{
				_loc2 = findPageBySrc(CGlobal.Course, jLessonLocation);
			} // end if
			if (_loc2 != null && typeof(_loc2) == "object")
			{
				if (CGlobal.islAppRoot.islSettings.XMLData.@bookmark != undefined && CGlobal.islAppRoot.islSettings.XMLData.@bookmark.toString() == "prompt")
				{
					openComponent(bookmark_prompt);
				}
				else if (CGlobal.islAppRoot.islSettings.XMLData.@bookmark.toString() == "off")
				{
					currentPage = getFirstPageOfGroup(Course);
					loadPage(currentPage);
				}
				else
				{
					returnToBookmark();
				} // end else if
			}
			else
			{
				currentPage = getFirstPageOfGroup(Course);
				if (typeof(currentPage) == "object")
				{
					loadPage(currentPage);
				}
				else
				{
					CGlobal.islDebug("Error. No page object returned for loading");
				} // end else if
			} // end else if
		} // End of the function
		
public var course_pages_viewed:int = 0;
public var manual_complete:Boolean = false;
		

		function getPagesViewed()
		{
			var _loc2 = 0;
			var _loc3;
			course_pages_viewed = 0;
			for (var _loc1 = 0; _loc1 < CGlobal.Course.children.length; ++_loc1)
			{
				_loc2 = _loc2 + checkNodeProgress(CGlobal.Course.children[_loc1]);
			} // end of for
			_loc3 = course_pages_viewed / (CGlobal.Course.@totalPages / 2) * 100;
			_loc3 = Math.round(_loc3);
			return (_loc3);
		} // End of the function
		function getNumConditions()
		{
			var _loc1 = 1;
			if (islAppRoot.islCompletion.pre_assessment == "on")
			{
				++_loc1;
			} // end if
			if (islAppRoot.islCompletion.post_assessment == "on")
			{
				++_loc1;
			} // end if
			return (_loc1);
		} // End of the function
		
		function getAssScore(the_exam)
		{
			var _loc2 = 0;
			for (var _loc1 = 0; _loc1 < CGlobal.Course.children.length; ++_loc1)
			{
				if (CGlobal.Course.children[_loc1].@type == the_exam)
				{
					_loc2 = CGlobal.Course.children[_loc1].@examscore;
				} // end if
			} // end of for
			return (_loc2);
		} // End of the function
		function checkCourseProgress()
		{
			var _loc6 = getAssScore("pre_exam");
			var _loc3 = getAssScore("post_exam");
			var _loc7 = getPagesViewed();
			var _loc9 = getNumConditions();
			var _loc5 = 0;
			var _loc4 = "incomplete";
			var _loc2 = "";
			var _loc10 = CGlobal.islAppRoot.islCompletion.pre_assessment == "on" && _loc6 >= CGlobal.islAppRoot.islCompletion.pre_exam_passmark ? (true) : (false);
			var _loc8 = CGlobal.islAppRoot.islCompletion.post_assessment == "on" && _loc3 >= CGlobal.islAppRoot.islCompletion.post_exam_passmark ? (true) : (false);
			var _loc11 = _loc7 >= CGlobal.islAppRoot.islCompletion.page_views ? (true) : (false);
			if (_loc10 == true)
			{
				++_loc5;
			} // end if
			if (_loc8 == true)
			{
				++_loc5;
			} // end if
			if (_loc11 == true)
			{
				++_loc5;
			} // end if
			if (CGlobal.islAppRoot.islCompletion.manual_complete == "on")
			{
				if (manual_complete == true)
				{
					_loc4 = "completed";
				} // end if
			}
			else
			{
				if (_loc5 == _loc9)
				{
					_loc4 = "completed";
				} // end if
				if (CGlobal.islAppRoot.islCompletion.pre_assessment == "on" && CGlobal.islAppRoot.islCompletion.post_assessment == "off")
				{
					_loc2 = _loc6 >= CGlobal.islAppRoot.islCompletion.pre_exam_passmark ? (_loc6) : ("");
				}
				else if (CGlobal.islAppRoot.islCompletion.pre_assessment == "off" && CGlobal.islAppRoot.islCompletion.post_assessment == "on")
				{
					_loc2 = _loc3 >= CGlobal.islAppRoot.islCompletion.post_exam_passmark ? (_loc3) : ("");
				}
				else if (CGlobal.islAppRoot.islCompletion.pre_assessment == "on" && CGlobal.islAppRoot.islCompletion.post_assessment == "on")
				{
					_loc2 = _loc3 >= CGlobal.islAppRoot.islCompletion.post_exam_passmark ? (_loc3) : ("");
				} // end else if
			} // end else if
			if (CGlobal.islAppRoot.islSettings.delivery == "scorm")
			{
				//*********** Pending to review later ************
			}
			else if (CGlobal.islAppRoot.islSettings.delivery == "aicc_hacp")
			{
				setAiccCoreLessonValue("islSuspendData", CGlobal.islAppRoot.islSuspendData);
				setAiccCoreValue("lesson_location", CGlobal.islAppRoot.islBookmarkTracker);
				setAiccCoreValue("lesson_status", _loc4.slice(0, 1));
				setAiccCoreValue("lesson_score", _loc2);
				putParam();
			}
			else if (CGlobal.islAppRoot.islSettings.delivery == "custom")
			{
				custom_tracking_lib.updatetracking(this, CGlobal.islAppRoot.islSuspendData, CGlobal.islAppRoot.islBookmarkTracker, _loc4, _loc2);
			} // end else if
			CGlobal.islAppRoot.debugger_mc.course_complete.htmlText = _loc7 + "% of the course viewed.<br/>Course.totalPages: " + Course.totalPages / 2 + " delivery type= " + CGlobal.islAppRoot.islSettings.delivery;
		} // End of the function


		function checkNodeProgress(node:XML)
		{
			var _loc4 = 0;
			var _loc7 = 0;
			if (node.subNodes.length > 0)
			{
				for (var _loc3 = 0; _loc3 < node.children.length; ++_loc3)
				{
					var _loc2 = checkNodeProgress(node.children[_loc3]);
					_loc2 = _loc2 == undefined ? (0) : (_loc2);
					_loc4 = _loc4 + _loc2;
				} // end of for
				_loc7 = node.children.length;
			} // end if
			if (node.pageNodes.length > 0)
			{
				var _loc5 = 0;
				for (var _loc33 = 0; _loc3 < node.pageNodes.length; ++_loc33)
				{
					_loc5 = _loc5 + node.pageNodes[_loc33].progress;
					if (node.type != "pre_exam" && node.type != "post_exam")
					{
						course_pages_viewed = course_pages_viewed + (node.pageNodes[_loc33].progress == 2 ? (1) : (0));
					} // end if
				} // end of for
				var _loc8 = _loc5 / node.pageNodes.length;
				if (node.type != undefined && node.type == "pre_exam")
				{
					var _loc6 = getAssScore(node.type);
					if (_loc6 > 0 && _loc6 >= islCompletion.pre_exam_passmark)
					{
						_loc4 = _loc4 + 2;
					}
					else if (_loc6 > 0 || _loc8 > 0)
					{
						_loc4 = _loc4 + 1;
					}
					else
					{
						_loc4 = 0;
					} // end else if
				}
				else if (node.@type && node.@type.toString() == "post_exam")
				{
					_loc6 = getAssScore(node.@type.toString());
					if (_loc6 > 0 && _loc6 >= islCompletion.post_exam_passmark)
					{
						_loc4 = _loc4 + 2;
					}
					else if (_loc6 > 0 || _loc8 > 0)
					{
						_loc4 = _loc4 + 1;
					}
					else
					{
						_loc4 = 0;
					} // end else if
				}
				else if (_loc8 >= 2)
				{
					_loc4 = _loc4 + 2;
				}
				else if (_loc8 > 0)
				{
					_loc4 = _loc4 + 1;
				}
				else
				{
					_loc4 = 0;
				} // end else if
				_loc7 = _loc7 + 1;
			} // end if
			if (_loc4 > 0)
			{
				if (parseInt(_loc4 / _loc7) == 2)
				{
					return (2);
				}
				else if (_loc4 > 0)
				{
					return (1);
				} // end else if
			}
			else
			{
				return (0);
			} // end else if
		} // End of the function

//----------------------------------------------------------------------------------------------
	}
}