﻿//  use pbl_m1_l2_a4_01.fla
/*
*  @public class
*  the class controls the actions in the screens with the type Grid
*/
package 
{
	import flash.display.*;
	import flash.events.*;
	
	public class QuestionGridAlt extends MovieClip
	{
		public  var column_1feedback:Boolean; 
		public  var column_2feedback:Boolean; 
		public  var localContentLevel:MovieClip;
		public  var toggleVar:Boolean; 
		public  var popup_initalised:Boolean;  
		public  var yourOrder:Array;
		public  var rightOrder:Array;
		public  var column_1:int;
		public  var column_2:int;
		
		//public var contentLevel:MovieClip;
		//var rootLevel = _level0;
		
		public  var feedback_string:String;
		// will dealling with it and frame woek 
		// global by  == calling an objects globaly
		// islAppRoot == mean framework
		/*
		*  @public
		*  class constructor
		*/
		public function QuestionGridAlt()
			{
				toggleVar   =   true;
				popup_initalised = false;
				yourOrder   = new Array();
				rightOrder  = new Array();

				
								
			}

		/*
		*  @public
		*  initiating the screen
		*/
		public function initGRIDALTQuestion()
		{  
			
			    column_1 = 0;  
				column_2 = 0; 
			//trace(CGlobal.question_generic_lib + " ggggg");
			localContentLevel = CGlobal.question_generic_lib.contentLevel;
			
			popup_initalised = false;
			//trace(CGlobal + "    " +CGlobal.question_generic_lib  + " CGlobal.question_generic_lib");
			
			CGlobal.question_generic_lib.initQuestionScreen();
			
			
			if (!CGlobal.islAppRoot && !CGlobal.islAppRoot.islMainPlayerRunning) //  pending--->  added for test (!islAppRoot &&)
			{
				localContentLevel = CGlobal.islAppRoot;  //CGlobal.content_mc   //_level0;
			}
			else
			{
				localContentLevel = CGlobal.content_mc;
			}
			
			//localContentLevel = CGlobal.question_generic_lib.contentLevel;
			initAQL();
			initSettingsQGrid();
			if (localContentLevel.auto_create == "on" || localContentLevel.auto_create == "delayed")
			{
				autoGenerateOptions();
			} // end if
			initScreenItems();
			 initGridBoxes();
			//initAudio();     ???????????????????
		} // End of the function
		
		
		
		
		/*
		*  @public
		*  initiating and applying the default settings to the screen
		*/
		public function initSettingsQGrid()
		{
			//trace( localContentLevel +  " total_rows");
			 localContentLevel.total_rows    =  localContentLevel.aOptions.length;
			 localContentLevel.total_options =  localContentLevel.aOptions.length;
			 localContentLevel.total_columns =  localContentLevel.numberColumns;
			 localContentLevel.correct_options = new Array();
			 //trace(localContentLevel);
			 //trace(localContentLevel.correct_answer);
			 
			 localContentLevel.correct_options =  localContentLevel.correct_answer.split(",");
			 localContentLevel.total_correct_options =  localContentLevel.correct_options.length;
			 localContentLevel.total_points_possible =  localContentLevel.total_points_possible +  localContentLevel.total_correct_options;
			 toggleVar = true;
			if ( localContentLevel.max_attempts == 1)
			{
				 localContentLevel.retry_button.visible = false;
			} // end if
		} // End of the function
		/*
		*  @public
		*  auto generation of options positions
		*/
		private function autoGenerateOptions()
		{
		var xx:String = "";
		var yy:String = "";
		
		// && // var loadingLevel = 1050;
		//trace(localContentLevel+"  " +localContentLevel.grid_box)
		var xVar =  0;//localContentLevel.grid_box.x;   // pending
		var yVar =  0;//localContentLevel.grid_box.y;    // pending
		//trace ("localContentLevel.total_rows : " +  localContentLevel.total_rows);
		for (var  i:int = 1;  i <=  localContentLevel.total_rows; ++i)
		{
			if ( i < 10)
			{
				xx = "0";
			}
			else
			{
				xx = "";
			} // end else if
			for (var j = 1; j <=  localContentLevel.total_columns; ++j)
			{
				if (j < 10)
				{
					yy = "0";
				}
				else
				{
					yy = "";
				} // end else if
				
				//localContentLevel.addChild("r" + x +  i + "c" + y + j)  /// pending -->  localContentLevel.grid_box not used in v. 2 too
				//trace(localContentLevel["r" + xx +  i + "c" + yy + j] + "ff")
				//localContentLevel["r" + xx +  i + "c" + yy + j].x = xVar;
				//localContentLevel["r" + xx +  i + "c" + yy + j].y = yVar;

				
				
			        /*	   ????????? @@@@@ ?????????? 
				     duplicateMovieClip( localContentLevel.grid_box, "r" + x +  i + "c" + y + j, loadingLevel);
					 localContentLevel["r" + x +  i + "c" + y + j].x = xVar;
					 localContentLevel["r" + x +  i + "c" + y + j].y = yVar;
					 */ 
					// && //  xVar = xVar + ( localContentLevel.grid_box.width +  localContentLevel.grid_x_spacer);
					// && // ++loadingLevel;
				} // end of for
				
				// && // xVar =  localContentLevel.grid_box.x;
				// && // yVar = yVar + ( localContentLevel.grid_box.height +  localContentLevel.grid_y_spacer);
			} // end of for
//			 localContentLevel.grid_box.visible = false;
		} // End of the function
		/*
		*  @public
		*  initiating all the screen elements to it's original state
		*/
		private function initScreenItems()
		{
			CGlobal.button_code_lib.deactivateButton( localContentLevel.evaluator_button);
			CGlobal.button_code_lib.deactivateButton( localContentLevel.retry_button);
			 localContentLevel.toggle_button.visible = false;
			if ( localContentLevel.option_popup == "on" && popup_initalised == false)
			{
				assign_popup_functionality();
				popup_initalised = true;
			} // end if
			//islDebug("islAppRoot.islSettings[\"debug\"]: " + islAppRoot.islSettings.debug);
			
			if (false && islAppRoot.islSettings.debug == 1)
			{
				debug_indicator();
			} // end if
		} // End of the function

		
		/*
		*  @public
		*  assiginig the button functionality to the option elements
		*/
		private function assign_popup_functionality()
		{
			 localContentLevel.depthCounter = 1100;
			for (var i:int = 1; i <=  localContentLevel.total_rows; ++i)
			{
				localContentLevel["option" + i].tabEnabled = false;
				localContentLevel["option" + i].buttonMode = true;
				localContentLevel["option" + i].mouseChildren = false;
				localContentLevel["option" + i].addEventListener(MouseEvent.MOUSE_OVER  ,onOver);
				localContentLevel["option" + i].addEventListener(MouseEvent.MOUSE_OUT ,onOut);
			} // end of for
		} // End of the function
		
		
		/*
		*  @public
		*  triggers animation and sound effects on the option with mouse over
		*/
		private function onOver(e:MouseEvent){
			if(e.target.buttonMode ==  false) return;
					++depthCounter;
					e.target.setChildIndex(e.target ,depthCounter);
					e.target.option_popup.gotoAndPlay("on");
					if ( localContentLevel.popupAudio == "on")
					{
						CGlobal.audio_code_lib.extraAudioPlay(this.name);/// pending
					} // end if
				};
		
		/*
		*  @public
		*  triggers animation and sound effects on the option with mouse out
		*/
		private function onOut(e:MouseEvent){
			if(e.target.buttonMode ==  false) return;
					this.option_popup.gotoAndPlay("off");
					if ( localContentLevel.popupAudio == "on")
					{
						CGlobal.audio_code_lib.extraAudioStop(this.name);/// pending
					} // end if
				};
		

		/*
		*  @public
		*  initiating the grid boxes place and position on the screen
		*/
		private function initGridBoxes()
		{
			var xx:String = "";
			var yy:String = "";
			for (var i = 1; i <=  localContentLevel.total_rows; ++i)
			{
				if (i < 10)
				{
					xx = "0";
				}
				else
				{
					xx = "";
				} // end else if
				for (var j = 1; j <=  localContentLevel.total_columns; ++j)
				{
					if (j < 10)
					{
						yy = "0";
					}
					else
					{
						yy = "";
					} // end else if
					  localContentLevel["r" + xx + i + "c" + yy + j].selected = 0;
					//  trace(localContentLevel["r" + xx + i + "c" + yy + j] + "hitArea");
					  //localContentLevel["r" + xx + i + "c" + yy + j].hitArea =  localContentLevel["r" + xx + j + "c" + yy + i].hit;
				      localContentLevel["r" + xx + i + "c" + yy + j].tabEnabled = false;
					  localContentLevel["r" + xx + i + "c" + yy + j].buttonMode = true;
					  localContentLevel["r" + xx + i + "c" + yy + j].mouseChildren = false;
					  localContentLevel["r" + xx + i + "c" + yy + j].addEventListener(MouseEvent.MOUSE_DOWN ,onDown);
				   
				
				} // end of for
			} // end of for
		} // End of the function
		

		/*
		*  @public
		*  triggers the option effects and activates the evaluater button
		*/
		private function onDown(e:MouseEvent) {
			if(e.target.buttonMode ==  false) return;
			
						var row_number = e.target.name.substring(1, 3);
						
						
						if ( e.target.selected == 0)
						{
							//trace(localContentLevel.multiple_selections + " multiple_selections");
							
							if (! localContentLevel.multiple_selections)
							{
								toggleGridBoxesOff(row_number, localContentLevel);
							} // end if
							 e.target.gotoAndStop("down");
							 e.target.selected = 1;
						}
						else if ( !localContentLevel.multiple_selections)
						{
							 e.target.gotoAndStop("up");
							 e.target.selected = 0;
						} // end else if
						countSelectedGridBoxes();
						//trace(localContentLevel.total_rows + "localContentLevel.total_rows");
						trace(column_1 + column_2 + "  " +   localContentLevel.total_rows);
						if (column_1 + column_2 ==  localContentLevel.total_rows)
						{
							CGlobal.button_code_lib.activateButton( localContentLevel.evaluator_button);
						} // end if
					}
	
		/*
		*  @public
		*  turning the grid boxes off 
		*/
		private function toggleGridBoxesOff(the_row,  localContentLevel)
		{
			for (var i = 1; i <=  localContentLevel.total_columns; ++i)
			{
				if (i < 10)
				{
					y = "0";
				}
				else
				{
					y = "";
				} // end else if
				 localContentLevel["r" + the_row + "c" + y + i].gotoAndStop("up");
				 localContentLevel["r" + the_row + "c" + y + i].selected = 0;
			} // end of for
		} // End of the function
		
		/*
		*  @public
		*  counting the selected grid boxes to use in the answer evaluation
		*/
		private function countSelectedGridBoxes()
		{
			 localContentLevel.total_selected = 0;
			for (var i:int = 1; i <=  localContentLevel.total_rows; ++i)
			{
				//trace(localContentLevel["r0" + i + "c01"].clicked);
				if ( localContentLevel["r0" + i + "c01"].selected == 1 &&  localContentLevel["r0" + i + "c01"].clicked == 0)
				{
					if ( localContentLevel["r0" + i + "c02"].clicked == 1)
					{
						--column_2;
						//trace("--column_2" );
					} // end if
					++column_1;
					continue;
				} // end if
				if ( localContentLevel["r0" + i + "c02"].selected == 1 &&  localContentLevel["r0" + i + "c02"].clicked == 0)
				{
					if ( localContentLevel["r0" + i + "c01"].clicked == 1)
					{
						//trace("--column_1" );
						--column_1;
					} // end if
					++column_2;
				} // end if
			} // end of for
		} // End of the function
		
		/*
		*  @public
		*  generating debug reports
		*/
		function debug_indicator()
		{
			//trace ("debug_indicator: grid_option");
			for (var i = 1; i <=  localContentLevel.total_rows; ++i)
			{
				if (i < 10)
				{
					x = "0";
				}
				else
				{
					x = "";
				} // end else if
				for (var j = 1; j <=  localContentLevel.total_columns; ++j)
				{
					if (j < 10)
					{
						y = "0";
					}
					else
					{
						y = "";
					} // end else if
					 localContentLevel["r" + x + i + "c" + y +  localContentLevel.correct_options[i - 1]].grid_option.text = ">>>";
				} // end of for
			} // end of for
		} // End of the function
		
		
		
		
		
		
		/*
		*  @public
		*  assigning the current stage to the global aql
		*/
		private function initAQL()
		{
			CGlobal.aql = this;    //  we can replace aql in quetiongenric class with taking an object from this 
		}
		
		
		
		/*
		*  @public
		*  reseting all grid boxes to it's original positions and states
		*/
		function resetBoxes()
		{
			for (var _loc2 = 1; _loc2 <=  localContentLevel.total_rows; ++_loc2)
			{
				if (_loc2 < 10)
				{
					x = "0";
				}
				else
				{
					x = "";
				} // end else if
				for (var _loc1 = 1; _loc1 <=  localContentLevel.total_columns; ++_loc1)
				{
					if (_loc1 < 10)
					{
						y = "0";
					}
					else
					{
						y = "";
					} // end else if
					 localContentLevel["r" + x + _loc2 + "c" + y + _loc1].gotoAndStop("up");
				} // end of for
			} // end of for
		} // End of the function
		/*
		*  @public
		*  restting all the options
		*/
		function resetOptions()
		{
			resetBoxes();
			enableOptions();
		} // End of the function
		/*
		*  @public
		*  disabling the options
		*/
		function disableOptions()
		{
			for (var _loc2 = 1; _loc2 <=  localContentLevel.total_rows; ++_loc2)
			{
				if (_loc2 < 10)
				{
					x = "0";
				}
				else
				{
					x = "";
				} // end else if
				for (var _loc1 = 1; _loc1 <=  localContentLevel.total_columns; ++_loc1)
				{
					if (_loc1 < 10)
					{
						y = "0";
					}
					else
					{
						y = "";
					} // end else if
					 localContentLevel["r" + x + _loc2 + "c" + y + _loc1].buttonMode = false;
				} // end of for
			} // end of for
		} // End of the function
		/*
		*  @public
		*  checking the submitted answer against the right answers
		*/
		function evaluateAnswer()
		{
			column_1feedback = false;  ///     column_1feedback    ???      
			column_2feedback = false;  ///     column_2feedback    ???  
			trace( column_1  +   " c1 "  + column_2  + " c2 " );
			if (column_1 > column_2) 
			{
				column_1feedback = true;
			}
			else
			{
				column_2feedback = true;
			} // end else if
		} // End of the function
		/*
		*  @public
		*  showing the right answer if the provided answer was evaluated wrong
		*/
		function showCorrectAnswer()
		{
			if ( localContentLevel.option_popup == "post" && popup_initalised == false)
			{
				assign_popup_functionality();
				popup_initalised = true;
			} // end if
			if ( localContentLevel.show_answer == "on")
			{
				resetBoxes();
				showAnswerBySwitch();
			}
			else if ( localContentLevel.show_answer == "ticks")
			{
				showTicks();
			}
			else if ( localContentLevel.show_answer == "toggle")
			{
				 localContentLevel.toggle_button.visible = true;
				initToggleBtn();
				showTicks();
			} // end else if
		} // End of the function
		/*
		*  @public
		*  switches the grid boxes on and off
		*/
		function showAnswerBySwitch()
		{
			for (i = 1; i <=  localContentLevel.total_rows; i++)
			{
				if (i < 10)
				{
					x = "0";
				}
				else
				{
					x = "";
				} // end else if
				if ( localContentLevel.multiple_selections)
				{
					var _loc2 =  localContentLevel.correct_options[i - 1].split(":");
					for (var _loc1 = 1; _loc1 <=  localContentLevel.total_columns; ++_loc1)
					{
						if (_loc1 < 10)
						{
							y = "0";
						}
						else
						{
							y = "";
						} // end else if
						if (parseInt(_loc2[_loc1 - 1]) == 0)
						{
							 localContentLevel["r" + x + i + "c" + y + _loc1].gotoAndStop("up");
							continue;
						} // end if
						if (parseInt(_loc2[_loc1 - 1]) == 1)
						{
							 localContentLevel["r" + x + i + "c" + y + _loc1].gotoAndStop("down");
						} // end if
					} // end of for
					continue;
				} // end if
				if ( localContentLevel.correct_options[i - 1] < 10)
				{
					y = "0";
				}
				else
				{
					y = "";
				} // end else if
				 localContentLevel["r" + x + i + "c" + y +  localContentLevel.correct_options[i - 1]].gotoAndStop("down");
			} // end of for
		} // End of the function
		/*
		*  @public
		*  showing the right and wrong ticks according to the right and wrong options
		*/
		function showTicks()
		{
			for (var _loc1 = 1; _loc1 <=  localContentLevel.total_rows; ++_loc1)
			{
				if (_loc1 < 10)
				{
					x = "0";
				}
				else
				{
					x = "";
				} // end else if
				for (var _loc2 = 1; _loc2 <=  localContentLevel.total_columns; ++_loc2)
				{
					if (_loc2 < 10)
					{
						y = "0";
					}
					else
					{
						y = "";
					} // end else if
					if ( localContentLevel["r" + x + _loc1 + "c" + y + _loc2].selected == 1)
					{
						 localContentLevel["r" + x + _loc1 + "c" + y + _loc2].evaluator_graphic.gotoAndStop("incorrect");
					} // end if
					if ( localContentLevel["r" + x + _loc1 + "c" + y +  localContentLevel.correct_options[_loc1 - 1]].selected == 1)
					{
						 localContentLevel["r" + x + _loc1 + "c" + y +  localContentLevel.correct_options[_loc1 - 1]].evaluator_graphic.gotoAndStop("correct");
					} // end if
				} // end of for
			} // end of for
		} // End of the function
/*
*  @public
*  hiding the right and wrong ticks according to the right and wrong options
*/
function hideTicks()
{
    for (var _loc2 = 1; _loc2 <=  localContentLevel.total_rows; ++_loc2)
    {
        if (_loc2 < 10)
        {
            x = "0";
        }
        else
        {
            x = "";
        } // end else if
        for (var _loc1 = 1; _loc1 <=  localContentLevel.total_columns; ++_loc1)
        {
            if (_loc1 < 10)
            {
                y = "0";
            }
            else
            {
                y = "";
            } // end else if
             localContentLevel["r" + x + _loc2 + "c" + y + _loc1].evaluator_graphic.gotoAndStop(1);
        } // end of for
    } // end of for
} // End of the function
		/*
		*  @public
		*  enable the options to be choosen
		*/
		function enableOptions()
		{
			for (var _loc2 = 1; _loc2 <=  localContentLevel.total_rows; ++_loc2)
			{
				if (_loc2 < 10)
				{
					x = "0";
				}
				else
				{
					x = "";
				} // end else if
				for (var _loc1 = 1; _loc1 <=  localContentLevel.total_columns; ++_loc1)
				{
					if (_loc1 < 10)
					{
						y = "0";
					}
					else
					{
						y = "";
					} // end else if
					 localContentLevel["r" + x + _loc2 + "c" + y + _loc1].buttonMode = true;
					 localContentLevel["r" + x + _loc2 + "c" + y + _loc1].selected = 0;
				} // end of for
			} // end of for
		} // End of the function
		/*
		*  @public
		*  initiating the toggle button and activating it
		*/
		function initToggleBtn()
		{
			for (var _loc2 = 1; _loc2 <=  localContentLevel.total_rows; ++_loc2)
			{
				if (_loc2 < 10)
				{
					x = "0";
				}
				else
				{
					x = "";
				} // end else if
				for (var _loc1 = 1; _loc1 <=  localContentLevel.total_columns; ++_loc1)
				{
					if (_loc1 < 10)
					{
						y = "0";
					}
					else
					{
						y = "";
					} // end else if
					if ( localContentLevel["r" + x + _loc2 + "c" + y + _loc1].selected == 1)
					{
						yourOrder.push( localContentLevel["r" + x + _loc2 + "c" + y + _loc1]);
					} // end if
					if ( localContentLevel.correct_options[_loc2 - 1] == _loc1)
					{
						rightOrder.push( localContentLevel["r" + x + _loc2 + "c" + y +  localContentLevel.correct_options[_loc2 - 1]]);
					} // end if
				} // end of for
			} // end of for
		} // End of the function
		/*
		*  @public
		*  when the toggle button is released the boxes are resetted and the options are 
		*  ordered either by the user's order or the true order
		*/
		function toggleButtonRelease()
		{
			if (toggleVar)
			{
				resetBoxes();
				for (x_ = 0; x_ < rightOrder.length; x_++)
				{
					rightOrder[x_].gotoAndStop("down");
				} // end of for
				hideTicks();
				toggleVar = false;
				 localContentLevel.toggle_button.gotoAndPlay("off");
			}
			else
			{
				resetBoxes();
				for (x_ = 0; x_ < yourOrder.length; x_++)
				{
					yourOrder[x_].gotoAndStop("down");
				} // end of for
				showTicks();
				toggleVar = true;
				 localContentLevel.toggle_button.gotoAndPlay("on");
			} // end else if
		} // End of the function
		
	
	}
}