﻿/*
*  @public
*  
*/
package {
	import flash.display.MovieClip;
	import flash.events.*;
	import flash.utils.*;

	public class Video_Code extends MovieClip {

		public   var contentLevel:MovieClip;
		
		public   var minimum_load:int;
		public   var currentVideoObject:Object = new Object();
		public   var videoPath;
		public   var videoInitX;
		public   var videoInitY;
		
		public var tmpInt:uint;
		public var swf :FileLoader;
	
		/*
		*  @public
		*  class constructor
		*/
		public function Video_Code() {
			contentLevel=new MovieClip  ;
		}
	
		/*
		*  @public
		*  initializes the video screen, defines the video main points and properties
		*/
		public function initVideoScreen(movie:MovieClip)
			{
				
				var myurl:String = unescape(movie.loaderInfo.url);
				
				var end = myurl.lastIndexOf(".swf");
				var len = myurl.length;
				
				var _loc2 = -1;
				var xx = end - 1;
				while (xx--)
				{
					if (myurl.charCodeAt(xx) == 47 || myurl.charCodeAt(xx) == 92)
					{
						_loc2 = xx;
						break;
					} // end if
					xx > 0;
				} // end while
				if (_loc2 > -1)
				{
					videoPath = myurl.substring(0, _loc2);
				}
				else
				{
					videoPath = myurl;
				} // end else if
					videoPath = videoPath.replace("lib", "movies");
				CGlobal.rootPath = myurl.substring(0, myurl.indexOf("lib"));
				 
				if (!CGlobal.islAppRoot.islMainPlayerRunning)
				{
					contentLevel = CGlobal.islAppRoot;
				}
				else
				{
					contentLevel = CGlobal.content_mc;
				} // end else if
				if (contentLevel.video_startPoint == "beginning")
				{
					findVidObject("1");
				}
				else if (contentLevel.video_startPoint.indexOf("intro") > -1)
				{
					findVidObject("intro");
				} // end else if
				videoInitX = contentLevel.video_mc._x;
				videoInitY = contentLevel.video_mc._y;
			} // End of the function
			

		/*
		*  @public
		*  finds the video object
		*/
		public function findVidObject(launchBtn:String)
		{
			var _loc1 = launchBtn.substring(launchBtn.lastIndexOf("_") + 1, launchBtn.length);
			currentVideoObject = contentLevel["videoItem_" + _loc1];
			loadVidHolder();
		} // End of the function


		/*
		*  @private
		*  loads the video holder
		*/
		private function loadVidHolder()
			{
				if (contentLevel.screenAudio == "on")
				{
					contentLevel.audio_holder.gotoAndStop(1);
				} // end if
				clearInterval(tmpInt);
				minimum_load = 40;
				if (currentVideoObject && currentVideoObject.video_loadPoint )
				{
					minimum_load = currentVideoObject.video_loadPoint;
				} // end if
				contentLevel.pausePoint = false;
				if (contentLevel == CGlobal.islAppRoot)
				{
					swf  = new FileLoader("../shared_elements/video_holder.swf");
				}
				else
				{
					swf = new FileLoader("shared_elements/video_holder.swf");
				} // end else if
				
				swf.addEventListener("onFileLoad",onSwfLoad);
				
				tmpInt = setInterval(flvSetup, 1000);
				CGlobal.tmpInt = tmpInt;
			} // End of the function
	

			function onSwfLoad(e:Event) {
				contentLevel.video_mc.addChildAt(e.target.loader.content,0);
			}
		

		/*
		*  @private
		*  setups the flv, defines it's main points and applies the proper skin
		*/
		private function flvSetup()
		{
			clearInterval(tmpInt);
			/*			
			trace(contentLevel)
			trace(contentLevel.video_mc)
			*/
			if(!currentVideoObject || contentLevel.video_mc)
			{
				return;
			}
			contentLevel.video_mc.video_flv.width = currentVideoObject.video_width;
			contentLevel.video_mc.video_flv.height = currentVideoObject.video_height;
			if (contentLevel == CGlobal.islAppRoot) // pinding --> contentLevel == _level0
			{
				if (currentVideoObject.skin != undefined)
				{
					contentLevel.video_mc.video_flv.skin = "../shared_elements/" + currentVideoObject.skin;
				} // end if
			}
			else if (currentVideoObject.skin != undefined)
			{
				contentLevel.video_mc.video_flv.skin = "shared_elements/" + currentVideoObject.skin;
			} // end else if
			if (currentVideoObject.skin != undefined)
			{
				contentLevel.video_mc.video_flv.skinAutoHide = currentVideoObject.autohideskin == "true" ? (true) : (false);
			} // end if
			if (!isNaN(currentVideoObject.video_x))
			{
				contentLevel.video_mc.x = currentVideoObject.video_x;
			}
			else
			{
				contentLevel.video_mc.x = videoInitX;
			} // end else if
			if (!isNaN(currentVideoObject.video_y))
			{
				contentLevel.video_mc.y = currentVideoObject.video_y;
			}
			else
			{
				contentLevel.video_mc.y = videoInitY;
			} // end else if
			if (currentVideoObject.video_preloader == "on")
			{
				contentLevel.video_mc.outline.outline_middle.width = currentVideoObject.video_width - 20;
				contentLevel.video_mc.outline.outline_rightEdge.x = contentLevel.video_mc.outline.outline_middle.width + contentLevel.video_mc.outline.outline_middle.x + contentLevel.video_mc.outline.outline_rightEdge.width;
				contentLevel.video_mc.outline.x = 10;
				contentLevel.videoPreLoadWid = contentLevel.video_mc.outline.outline_middle.width;
				contentLevel.video_mc.outline.bar_mc.width = contentLevel.videoPreLoadWid * 1.000000E-002;
				centerPoint = contentLevel.video_mc.outline._width / 2 + contentLevel.video_mc.outline.x;
				contentLevel.video_mc.percent_txt.x = centerPoint - contentLevel.video_mc.percent_txt.width / 2;
				contentLevel.video_mc.outline.visible = true;
				contentLevel.video_mc.outline.bar_mc.visible = true;
				if (currentVideoObject.video_preloader_position == "top")
				{
					contentLevel.video_mc.outline.y = 10;
					contentLevel.video_mc.percent_txt.y = contentLevel.video_mc.outline.y + contentLevel.video_mc.outline.height;
				}
				else if (currentVideoObject.video_preloader_position == "center")
				{
					vidCenterPoint = currentVideoObject.video_height / 2;
					contentLevel.video_mc.outline.y = vidCenterPoint - contentLevel.video_mc.outline.height / 2;
					contentLevel.video_mc.percent_txt.y = contentLevel.video_mc.outline.y + contentLevel.video_mc.outline.height;
				}
				else if (currentVideoObject.video_preloader_position == "bottom")
				{
					totalHeight = contentLevel.video_mc.outline.height + contentLevel.video_mc.percent_txt.height;
					contentLevel.video_mc.outline.y = currentVideoObject.video_height - totalHeight - 10;
					contentLevel.video_mc.percent_txt.y = contentLevel.video_mc.outline.y + contentLevel.video_mc.outline.height;
				} // end else if
			} // end else if
			loadVideo();
		} // End of the function


		/*
		*  @private
		*  loads the flv video file to the video holder in the screen
		*/
		private function loadVideo()
		{
			var _loc2 = parent.parent.net_connection;
			var _loc3;
			if (_loc2 != undefined && (_loc2 == "low" || _loc2 == "medium"))
			{
				_loc3 = "low";
			}
			else
			{
				_loc3 = "high";
			} // end else if
			if (_loc3 == "low")
			{
				if (currentVideoObject.flv_file_low != "")
				{
					contentLevel.video_mc.video_flv.contentPath = contentLevel.myflvPath + currentVideoObject.flv_file_low;
				}
				else
				{
					contentLevel.video_mc.video_flv.contentPath = contentLevel.myflvPath + currentVideoObject.flv_file;
				} // end else if
			}
			else
			{
				contentLevel.video_mc.video_flv.contentPath = contentLevel.myflvPath + currentVideoObject.flv_file;
			} // end else if
			preloading();
			declareListeners();
			addCues();
		} // End of the function
		
		/*
		*  @private
		*  preloader for the video to show the percent and number of loaded frames
		*/
		private function preloading()
		{
			var loaded:uint = contentLevel.video_mc.video_flv.bytesLoaded();
			var total:uint = contentLevel.video_mc.video_flv.bytesTotal();
			
			
			contentLevel.video_mc.outline.bar_mc.addEventListener(Event.ENTER_FRAME,simulate);
			
			
		} // End of the function
		/*
		*  @public
		*  simulates the loading process via a loading bar and percentage text
		*/
		function simulate(event:Event)
				{
				loaded = contentLevel.video_mc.video_flv.bytesLoaded;
				total = contentLevel.video_mc.video_flv.bytesTotal;
				if (isFinite(loaded) && isFinite(total))
				{
					var _loc2 = Math.ceil(loaded / (total * (minimum_load / 100)) * 100);
					if (_loc2 > 99)
					{
						_loc2 = 100;
					} // end if
					contentLevel.video_mc.outline.bar_mc.width = contentLevel.videoPreLoadWid * (_loc2 / 100);
					contentLevel.video_mc.percent_txt.htmlText = currentVideoObject.video_preloadText + " " + _loc2 + "%";
					if (_loc2 == 100)
					{
						contentLevel.video_mc.outline.visible = false;
						contentLevel.video_mc.percent_txt.visible = false;
						event.target.removeEventListener(Event.ENTER_FRAME,simulate);
					} // end if
				} // end if
				}
				
		/*
		*  @public
		*  adding listeners
		*/
		function declareListeners()
		{
			contentLevel.video_mc.video_flv.addEventListener("progress", onProgress);
			contentLevel.video_mc.video_flv.addEventListener("complete", onComplete);
			
			if (currentVideoObject.video_timings == "on")
			{
				contentLevel.video_mc.timingMc.visible = true;
				contentLevel.video_mc.video_flv.addEventListener("playheadUpdate", onPlayheadUpdate);
				
			} // end if
			
			contentLevel.video_mc.video_flv.addEventListener("cuePoint", on_CuePoint);

		} // End of the function
		
		
		/*
		*  @public
		*  plays the video effect while the video is loading
		*/
		function onProgress(eventObj:Event)
			{
				if (contentLevel.video_mc.video_flv.bytesTotal > 5 && contentLevel.video_mc.video_flv.bytesLoaded / contentLevel.video_mc.video_flv.bytesTotal * 100 >= minimum_load)
				{
					contentLevel.video_mc.videoEnded = false;
					if (currentVideoObject.startVideoEffect != "off")
					{
						startVideoEffect("startVideoEffect");
					}
					else if (currentVideoObject.video_autoPlay == "on")
					{
						contentLevel.video_mc.video_flv.autoPlay = true;
						contentLevel.video_mc.video_flv.play();
					}
					else
					{
						contentLevel.video_mc.video_flv.autoPlay = false;
					} // end else if
				} // end else if
			}// end function
		
		/*
		*  @public
		*  plays the video when 100% loaded
		*/
		function onComplete(eventObject:Event)
			{
				contentLevel.video_mc.video_flv.pause();
				contentLevel.video_mc.videoEnded = true;
				contentLevel.video_mc.timingMc.visible = false;
				if (currentVideoObject.endVideoEffect != "off")
				{
					startVideoEffect("endVideoEffect");
				} // end if
			}// end function
		
		
		/*
		*  @public
		*  updates the time of the playhead during the video playback
		*/
		function onPlayheadUpdate(eventObject)
				{
					contentLevel.video_mc.timingMc.timer1 = contentLevel.video_mc.video_flv.playheadTime;
				}// end function
		

		/*
		*  @public
		*  fires an action when the video reaches a cue point
		*/
		function on_CuePoint(eventObject:Event)
			{
				if (eventObject.info.pauseVideo == "on")
				{
					contentLevel.pausePoint = true;
					var _loc3 = eventObject.info.triggerMc;
					contentLevel.currentTrigger = _loc3;
				}
				else
				{
					contentLevel.pausePoint = false;
				} // end else if
				var _loc4 = eventObject.info.name;
				var _loc5 = eventObject.info.type;
				var _loc2 = eventObject.info.label;
				if (_loc2 != undefined)
				{
					contentLevel.gotoAndPlay(_loc2);
				} // end if
			}// end function
		
		
		
		
		/*
		*  @public
		*  adds a cue point to the video
		*/
		 function addCues()
		{
			for (i = 1; !isNaN(i); i = NaN)
			{
				if (currentVideoObject["cue_" + i] != undefined)
				{
					contentLevel.video_mc.video_flv.addASCuePoint(currentVideoObject["cue_" + i]);
					++i;
					continue;
				} // end if
			} // end of for
		} // End of the function
		
		/*
		*  @public
		*  start a visual effect on the video
		*/
		 function startVideoEffect(currentEffect)
		{
			var _loc2;
			var endPoint;
			var incrementalNum;
			if (contentLevel[currentEffect] == "fade_in")
			{
				_loc2 = 0;
				endPoint = 100;
				incrementalNum = 10;
			}
			else if (contentLevel[currentEffect] == "fade_out")
			{
				_loc2 = 100;
				endPoint = 0;
				incrementalNum = -10;
			} // end else if
			//contentLevel.video_mc.createEmptyMovieClip("video_effect", 10); // ??
			contentLevel.video_mc.video_effect.startEffect = true;
			contentLevel.video_mc.video_flv.alpha = _loc2;
			
			
			contentLevel.video_mc.video_effect.addEventListener(Event.ENTER_FRAME,trans);
		}
		/*
		*  @public
		*  applies the visual effect on the video
		*/
		function trans(event:Event)
			{
				if (event.target.startEffect == true)
				{
					contentLevel.video_mc.video_flv.alpha = contentLevel.video_mc.video_flv.alpha + incrementalNum;
					if (contentLevel[currentEffect] == "fade_in")
					{
						if (contentLevel.video_mc.video_flv.alpha >= endPoint)
						{
							contentLevel.video_mc.video_flv.autoPlay = true;
							contentLevel.video_mc.video_flv.play();
							event.target.removeListener(Event.ENTER_FRAME,trans);
						} // end if
					}
					else if (contentLevel[currentEffect] == "fade_out")
					{
						if (contentLevel.video_mc.video_flv.alpha <= endPoint)
						{
							event.target.removeListener(Event.ENTER_FRAME,trans);
						} // end if
					} // end if
				} // end else if
			
		} // End of the function
		
		
		/*
		*  @public
		*  checks the check points in the video, pauses and plays according to the check points
		*/
		function labelCheckPoint()
		{
			if (contentLevel.pausePoint == true)
			{
				contentLevel.video_mc.video_flv.pause();
				trace ("set triggerpoint bool");
				contentLevel.video_mc.TriggerPoint = true;
				contentLevel.stop();
			}
			else if (currentVideoObject.video_cuePoints == "on")
			{
				CGlobal.islDebug("cue points are on - stop movie");
				contentLevel.stop();
			}
			else
			{
				contentLevel.play();
			} // end else if
			if (contentLevel.currentTrigger.viewed)
			{
				contentLevel.video_mc.video_flv.play();
				contentLevel.currentTrigger = "";
			} // end if
		} // End of the function
		

		/*
		*  @public
		*  triggers the play action on the video
		*/
		function triggerPoint()
		{
			if (contentLevel.video_mc.video_flv.paused && contentLevel[contentLevel.currentTrigger].viewed)
			{
				contentLevel.video_mc.video_flv.play();
				contentLevel[contentLevel.currentTrigger].visible = false;
			} // end if
		} // End of the function
		
	} // close of class
	
} // closed of package