﻿/**
*  public class
*  scrollClass places and positions the scroll controls in the component
*/
package {
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.utils.Timer;
	public class scrollClass extends Sprite {
		/**
		 *  @public
		 *  hold the main course menu referance
		 */
		var cm:MovieClip;
		/**
		 *  @public
		 *  group of variables holds the scroll compinent sprites 
		 */
		var name_con:Sprite;
		var name_mask:Sprite;
		var scrollTrack_mc:Sprite;
		var scrollCentral:Sprite;
		var scrollUp_mc:Sprite;
		var scrollDown_mc:Sprite;
		/**
		 *  @public function
		 *  class constructor
		 */
		 public function Refresh():void
			{
				//trace("refreshScroll");
				this.scrollMove();
			}
		public function scrollClass(cm:MovieClip,name_con:Sprite,name_mask:Sprite,scrollTrack_mc:Sprite,scrollCentral:Sprite,scrollUp_mc:Sprite,scrollDown_mc:Sprite) {
			/**
			  *  assigning the course menu stage and sprites to our variable
			  */
			this.cm = cm;
			this.name_con = name_con;
			this.name_mask = name_mask;
			this.scrollTrack_mc = scrollTrack_mc;
			this.scrollCentral = scrollCentral;
			this.scrollUp_mc = scrollUp_mc;
			this.scrollDown_mc = scrollDown_mc;
		}
			var scrollHeight:Number ;//= scrollCentral.height;
			var contentHeight:Number ;//= name_con.height;
			var scrollFaceHeight:Number ;//= scrollTrack_mc.height;
			var maskHeight:Number ;//= name_mask.height;
			var initPosition:Number ;//= scrollTrack_mc.y;// = scrollCentral.y + 14;
			var initContentPos:Number ;//= name_con.y;
			var finalContentPos:Number ;//= maskHeight-contentHeight+initContentPos;
			var left:Number ;//= scrollCentral.x;
			var top:Number ;//= scrollCentral.y;
			var right:Number = 0;
			var bottom:Number ;//= scrollCentral.height- scrollFaceHeight - 2;//- 14
			var bottom2:Number ;//= scrollCentral.height-scrollFaceHeight+ scrollCentral.y - 14;
			var dy:Number = 0;
			var speed:Number = 10;
			var moveVal:Number;/// = (contentHeight-maskHeight)/(scrollHeight-scrollFaceHeight);
			var currPos:Number;
			var rect1:Rectangle ;//= new Rectangle(left,top,right,bottom);
			var countTimer:Timer;// = new Timer(50);
			/**
			 *  @public
			 *  calculates the position of the main container and places it the new position
			 */
			function scrollMove() {//event:Event
				contentHeight = name_con.height;
				moveVal = (contentHeight-maskHeight)/(scrollHeight - 14 - scrollFaceHeight);
				dy =  Math.abs(initPosition-scrollTrack_mc.y);
				
				name_con.y = Math.round(dy*-1*moveVal+initContentPos);
			}
		/**
		 *  @public function
		 *  class's main function, contains all the scroll controls
		 */
		 
		public function scrollComponent() {
			/**
			 *  @private
			 *  group of variables holding scroll components values that are used in the calculations
			 */
			scrollHeight = scrollCentral.height;
			contentHeight = name_con.height;
			scrollFaceHeight = scrollTrack_mc.height;
			maskHeight = name_mask.height;
			initPosition = scrollTrack_mc.y;// = scrollCentral.y + 14;
			initContentPos = name_con.y;
			finalContentPos = maskHeight-contentHeight+initContentPos;
			left = scrollCentral.x;
			top = scrollCentral.y;
			right = 0;
			bottom = scrollCentral.height- scrollFaceHeight - 2;//- 14
			bottom2 = scrollCentral.height-scrollFaceHeight+ scrollCentral.y - 14;
			dy = 0;
			speed = 10;
			moveVal = (contentHeight-maskHeight)/(scrollHeight-scrollFaceHeight);
			currPos;
			rect1 = new Rectangle(left,top,right,bottom);
			countTimer = new Timer(50);
			
			
			countTimer.addEventListener(TimerEvent.TIMER ,PlaceScroll);
			countTimer.start();
			/**
			 *  assigning the event listeners to the scroll components
			 */
			addEventListener(Event.ENTER_FRAME , PlaceScroll);
			scrollTrack_mc.addEventListener(MouseEvent.MOUSE_DOWN, scrollMouseDown);
			cm.addEventListener(MouseEvent.MOUSE_UP, scrollMouseUp);
			//scrollTrack_mc.addEventListener(MouseEvent.MOUSE_OUT, scrollMouseUp);
			if(CGlobal.islAppRoot)
			CGlobal.islAppRoot.addEventListener(MouseEvent.MOUSE_UP, releaseOut);
			else
			mc.addEventListener(MouseEvent.MOUSE_UP, releaseOut);
			scrollUp_mc.addEventListener(MouseEvent.MOUSE_DOWN, btnUpPress);
			scrollUp_mc.addEventListener(MouseEvent.MOUSE_UP, btnUpRelease);
			scrollUp_mc.addEventListener(MouseEvent.MOUSE_OUT, btnUpOut);
			scrollDown_mc.addEventListener(MouseEvent.MOUSE_DOWN, btnDownPress);
			scrollDown_mc.addEventListener(MouseEvent.MOUSE_UP, btnDownRelease);
			scrollDown_mc.addEventListener(MouseEvent.MOUSE_OUT, btnDownOut);
			

			/**
			 *  @public
			 *  starts the required functions and setting the variables values
			 *  when the mouse is clicked
			 */
			function scrollMouseDown(event:MouseEvent) {
				countTimer.start();
				currPos = scrollTrack_mc.y;
				scrollTrack_mc.startDrag(false, rect1);
				scrollTrack_mc.drag=true;
				//scrollTrack_mc.addEventListener(Event.ENTER_FRAME, scrollMove);
			}
						
			/**
			 *  @public
			 *  stops the functions and setting the variables values
			 *  when the mouse is relrased
			 */
			function scrollMouseUp(event:MouseEvent) {
				countTimer.stop();
				scrollTrack_mc.stopDrag();
				scrollTrack_mc.drag=false;
				scrollTrack_mc.removeEventListener(Event.ENTER_FRAME, scrollMove);
			}
			/**
			 *  @public
			 *  stops the track bar dragging and removes the listeners
			 *  when the mouse is released
			 */
			function releaseOut(event:MouseEvent) {
				if (event.target == scrollTrack_mc) {

				} else {

					scrollTrack_mc.stopDrag();
					scrollTrack_mc.drag=false;
					scrollTrack_mc.removeEventListener(Event.ENTER_FRAME, scrollMove);
				}
				//this.removeEventListener(MouseEvent.MOUSE_UP, releaseOut);
			}
			/**
			 *  @public
			 *  adds the event listener when the up button is pressed
			 */
			function btnUpPress(event:MouseEvent) {
				countTimer.start();
				scrollUp_mc.addEventListener(Event.ENTER_FRAME, btnUpEnterFrame);
			}
			/**
			 *  @public
			 *  changes the positions of the main container and the track bar
			 *  when the up button is pressed
			 */
			function btnUpEnterFrame(event:Event) {

				if (name_con.y >= initContentPos||scrollTrack_mc.y <=top ) {
					scrollTrack_mc.y = top;
				} else {
					scrollTrack_mc.y -= speed/moveVal;

				}
			}
			/**
			 *  @public
			 *  removes the event listener when the up button is released
			 */
			function btnUpRelease(event:MouseEvent) {
				countTimer.stop();
				scrollUp_mc.removeEventListener(Event.ENTER_FRAME, btnUpEnterFrame);
			}
			/**
			 *  @public
			 *  removes the event listener when the up button is released
			 */
			function btnUpOut(event:MouseEvent) {
				
				if(!scrollTrack_mc.drag)
				countTimer.stop();
				scrollUp_mc.removeEventListener(Event.ENTER_FRAME, btnUpEnterFrame);
			}
			/**
			 *  @public
			 *  adds the event listener when the up button is pressed
			 */
			function btnDownPress(event:MouseEvent) {
				countTimer.start();
				scrollDown_mc.addEventListener(Event.ENTER_FRAME, btnDownEnterFrame);
			}
			/**
			 *  @public
			 *  changes the positions of the main container and the track bar
			 *  when the down button is pressed
			 */
			function btnDownEnterFrame(event:Event) {
				finalContentPos = maskHeight-contentHeight+initContentPos;
				if (name_con.y <= finalContentPos || scrollTrack_mc.y >= (bottom + initPosition) ) {
					scrollTrack_mc.y = bottom + initPosition;
				} else {
					scrollTrack_mc.y += speed/moveVal;
				}
			}
			/**
			 *  @public
			 *  removes the event listener when the down button is released
			 */
			function btnDownRelease(event:MouseEvent) {	
				countTimer.stop();
				scrollDown_mc.removeEventListener(Event.ENTER_FRAME, btnDownEnterFrame);
			}
			/**
			 *  @public
			 *  removes the event listener when the down button is released
			 */
			function btnDownOut(event:MouseEvent) {
				if(!scrollTrack_mc.drag)
				countTimer.stop();
				scrollDown_mc.removeEventListener(Event.ENTER_FRAME, btnDownEnterFrame);
			}

			if ( contentHeight < maskHeight ) {
				scrollTrack_mc.visible = false;
				scrollUp_mc.enabled = false;
				scrollDown_mc.enabled = false;
			} else {
				scrollTrack_mc.visible = true;
				scrollUp_mc.enabled = true;
				scrollDown_mc.enabled = true;
			}
			/**
			 *  @public
			 *  create the content mask
			 */
			function createMask(Pane,panelW, panelH):MovieClip {
				var cont:MovieClip = new MovieClip();
				var color = Math.round(Math.random()*0xFFFFFF);
				cont.graphics.beginFill(color,0.5);
				cont.graphics.drawRect(0,0,panelW,panelH);
				cont.graphics.endFill();
				return cont;
			}
			/**
			 *  @public
			 *  places the scroll main container and calculates the percentage
			 *  of the moved track bar
			 */
			function PlaceScroll(event:Event) {
				scrollMove();
				if (name_con.height > name_mask.height) {
					scrollTrack_mc.visible = true;
					scrollUp_mc.enabled = true;
					scrollDown_mc.enabled = true;
				} else {
					scrollTrack_mc.visible = false;
					scrollUp_mc.enabled = false;
					scrollDown_mc.enabled = false;
				}
				var up:int = Math.round(scrollTrack_mc.y - name_con.y);
				var Percentage:int = scrollCentral.height /name_con.height;
				scrollTrack_mc.y += (up * Percentage);

				if (name_con.height > name_mask.height) {
					contentHeight = name_con.height;
					moveVal = (contentHeight-maskHeight)/(scrollHeight - 12 - scrollFaceHeight);
					dy =  Math.abs(initPosition-scrollTrack_mc.y);
					name_con.y = Math.round(dy*-1*moveVal+initContentPos);
				} else {
					name_con.y = initContentPos;
					scrollTrack_mc.y = initPosition;
				}
			}
		}
	}
}